
#----------------------------------------------------------------------
#
#  SQL Engine Ver.3.15
#      CGI module for your SQL programming.
#      for Perl.
#                        Produced by Tom Yuhki all right reserved
#                        E-Mail: deagle@edit.ne.jp
#                        URL   : http://www.edit.ne.jp/~deagle/se/e/
#
#----------------------------------------------------------------------

package Se;

# Initialize
Initialize();

# Inline mode control
$own = __FILE__;
Inline() if !$INC{$own};

sub DBOpen {
	$DbName = $_[0];
	$FlName = $_[1];
	$forupdate = $_[2];
	$forinsert = $_[3];

	if ( $FlName =~ /^http:\/\// ) {
		@r = GetOuterFile( $FlName, ($TimeOut==0)?15:$TimeOut, '' );
		if ( $r[0] != 0 ) { return $r[0]; }
		$FlName = $r[1];
		$outerSwitch = 1;
	} else {
		$outerSwitch = 0;
	}

	foreach ( @DbList ) { if ( $DbName eq $_ ) { return 22; } }
	while ( 1 ) { if ( !(-e "SE.COMMIT.LOCK") ) { last; } }

	if ( $forupdate == 0 && $forinsert == 0 ) {
		open(IN, "<$FlName") || return 7;
		eval { flock(IN, 1); };
		@fDB = <IN>;
		close(IN);
	} elsif ( $forinsert == 0 ) {
		open(LOCK, "<$FlName") || return 7;
		eval { flock(LOCK, 2); };
		@fDB = <LOCK>;
		$LockedDb = @DbList;
	} else {
		open(IN, "<$FlName") || return 7;
		eval { flock(IN, 1); };
		$fDB[0] = <IN>;
		close(IN);
	}
	if ( $CharCode == 2 ) { $fDB[0] =~ s/^\xef\xbb\xbf//; }

	$TABLE = @DbList;
	if ( !($fDB[0] =~ /^\s*?<\?xml\s/) ) {
		xchomp(@fDB);

		# CSV
		@Items = xsplit4load($Separater, $fDB[0]);
		if ( $NoColumns[$TABLE] == 1 ) {
			if ( @COLUMNS == 0 ) {
				for ( $j = 1; $j <= @Items; $j++ ) { $COLUMNS[$j-1] = $j; }
			}
			if ( @Items != @COLUMNS ) {
				if ( $forupdate != 0 ) {
					close(LOCK);
					$LockedDb = 0;
				}
				return 46;
			}
			@Items = @COLUMNS;
		}

		for ( $j = 0; $j < @Items; $j++ ) {
			$Items[$j] =~ s/^\s+(.*?)\s+$/$1/;
			if ( $Items[$j] eq "" ) {
				if ( $forupdate != 0 ) {
					close(LOCK);
					$LockedDb = 0;
				}
				return 15;
			}
		}
		if ( !DoubleItem(@Items) ) {
			if ( $forupdate != 0 ) {
				close(LOCK);
				$LockedDb = 0;
			}
			return 31;
		}

		$rec = 0;
		if ( $NoColumns[$TABLE] == 1 ) { @{$DB[$TABLE]->[$rec++]} = @Items; }
		foreach ( @fDB ) {
			@tDB = xsplit4load($Separater, $_);
			@{$DB[$TABLE]->[$rec++]} = @tDB;
		}
		$DbLineCount[$TABLE] = $rec;
		$XML[$TABLE] = '';
	} else {
		# RSS
		if ( $forinsert != 0 ) { return 78; }

		$XML = join('', @fDB);
		$OXML = $XML;
		@fDB = undef;

		$XML =~ /<?xml\s+([^>]*)>/i;
		$INFO = $1;
		if ( $INFO =~ /version\s*=\s*['"]?([^"'\?]*)['"]?/i ) { $XML[$TABLE] = $1; }
		$XML[$TABLE] = '0.0' if ( $XML[$TABLE] eq '' );
		$XML[$TABLE] .= ';';
		if ( $INFO =~ /encoding\s*=\s*['"]?([^"'\?]*)['"]?/i ) { $XML[$TABLE] .= lc($1); }

		@{$DB[$TABLE]->[0]} = ( 'ID', 'ABOUT', 'TITLE', 'LINK', 'DESCRIPTION', 'SUBJECT', 'DATE', 'TYPE', 'FORMAT', 'IDENTIFIER', 'SOURCE', 'RELATION', 'COVERAGE', 'RIGHTS' );


		$rec = 1; $id = 1;
		$XML =~ s/<.*>/lc($&)/eig;
		if ( ($start = index($XML, '<channel')) == -1 || ($end = index($XML, '</channel>')) == -1 ) {
			if ( $forupdate != 0 ) {
				close(LOCK);
				$LockedDb = 0;
			}
			return 79;
		}
		@tDB = getItemFromTag(substr($OXML, $start, $end - $start));
		@{$DB[$TABLE]->[$rec++]} = (0, @tDB);
		$XML = substr($XML, 0, $start) . substr($XML, $end + 10);
		$OXML = substr($OXML, 0, $start) . substr($OXML, $end + 10);

		while ( ($start = index($XML, '<item')) != -1 && ($end = index($XML, '</item>')) != -1 ) {
			@tDB = getItemFromTag(substr($OXML, $start, $end - $start));
			@{$DB[$TABLE]->[$rec++]} = ($id++, @tDB);
			$XML = substr($XML, 0, $start) . substr($XML, $end + 7);
			$OXML = substr($OXML, 0, $start) . substr($OXML, $end + 7);
		}
		$DbLineCount[$TABLE] = $rec;
	}

	$DbList[$TABLE] = $DbName;
	$DbFile[$TABLE] = $FlName if ( $outerSwitch == 0 );
;

	return 0;
}

sub Fetch {
	return CFetch("DEFAULTCURSOR", @_ );
}

sub CFetch {
	my( $i, $result );

	# Get a cursor number
	if ( $Cursors{$_[0]} == undef ) { return 13; }
	$CURSOR = $Cursors{$_[0]};

	if ( $CurPos[$CURSOR] > $RecordCount[$CURSOR] ) { return 13; }

	$i = 0;
	while ( $ExecuteResult[$CURSOR]->[0]->[$i] ne '' ) {
		$result = $ExecuteResult[$CURSOR]->[$CurPos[$CURSOR]]->[$i];
		if ( $result =~ s/^__SE_SYSTEM_ARRAY:// ) {
			@{$_[$i+1]} = Str2Array($result);
		} else {
			if ( ref($_[$i+1]) eq 'ARRAY' ) {
				if ( $result eq '' ) {
					@{$_[$i+1]} = ();
				} else {
					@{$_[$i+1]} = ($result);
				}
			} else {
				$_[$i+1] = $result;
			}
		}
		$i++;
	}

	$CurPos[$CURSOR]++;

	return 0;
}

sub RecordCount {

	if ( $_[0] eq '' ) {
		return $RecordCount;
	} else {
		if ( $Cursors{$_[0]} == undef ) {
			my ( $i );
			for ( $i = 0; $i < @DbList; $i++ ) {
				if ( $_[0] eq $DbList[$i] ) {
					return $DbLineCount[$i] - 1;
				}
			}
			return 0;
		}
		$CURSOR = $Cursors{$_[0]};
		return $RecordCount[$CURSOR];
	}

}

sub FExec {
	my( @result, $i, $result, @stmp, $w );
	$r = Execute($_[0]);
	if ( $r != 0 ) { $_[1] = $r; return undef; }
	if ( $RecordCount[$NewestCursor] == 0 ) { $_[1] = 13; return undef; }

	if ( wantarray() ) {
		$i = 0;
		while ( $ExecuteResult[$NewestCursor]->[0]->[$i] ne '' ) {
			$w = $ExecuteResult[$NewestCursor]->[1]->[$i];
			if ( $w =~ s/^__SE_SYSTEM_ARRAY:// ) {
				@stmp = Str2Array($w);
				$result[$i] = \@stmp;
			} else {
				$result[$i] = $w;
			}
			$i++;
		}
		return @result;
	} else {
		$result = $ExecuteResult[$NewestCursor]->[1]->[0];
		if ( $result =~ s/^__SE_SYSTEM_ARRAY:// ) {
			@stmp = Str2Array($result);
			$result = \@stmp;
		}
		return $result;
	}

}

sub GetRecord {
	my( $i, $w, @tmp, @result, @stmp, $curName );

	$curName = $_[0];
	$curName = $_[1] if ( $_[0] eq '' && $_[1] ne '' );

	$CURSOR = ( $curName eq '' ) ? "DEFAULTCURSOR" : $curName;
	if ( $Cursors{$CURSOR} == undef ) { return undef; }
	$CURSOR = $Cursors{$CURSOR};

	@tmp = @{$ExecuteResult[$CURSOR]->[$CurPos[$CURSOR]]};
	for ( $i = 0; $i < @tmp; $i++ ) {
		$w = $ExecuteResult[$CURSOR]->[$CurPos[$CURSOR]]->[$i];
		if ( $w =~ s/^__SE_SYSTEM_ARRAY:// ) {
			@stmp = Str2Array($w);
			$result[$i] = \@stmp;
		} else {
			$result[$i] = $w;
		}
	}

	return @result;

}

sub GetValue {
	my( $i, $c, $result );

	$CURSOR = ( $_[1] eq '' ) ? "DEFAULTCURSOR" : $_[1];
	if ( $Cursors{$CURSOR} == undef ) { return undef; }
	$CURSOR = $Cursors{$CURSOR};

	$i = 0;
	while ( $ExecuteResult[$CURSOR]->[0]->[$i] ne '' ) {
		if ( index($_[0],".") == -1 && ($p = index($ExecuteResult[$CURSOR]->[0]->[$i], ".")) != -1 ) {
			$c = substr($ExecuteResult[$CURSOR]->[0]->[$i], $p + 1);
		} else {
			$c = $ExecuteResult[$CURSOR]->[0]->[$i];
		}
		if ( $_[0] eq $c ) {
			$result = $ExecuteResult[$CURSOR]->[$CurPos[$CURSOR]]->[$i];
			if ( $result =~ s/^__SE_SYSTEM_ARRAY:// ) {
				return Str2Array($result);
			} else {
				if ( wantarray() && $result eq '' ) {
					return ();
				} else {
					return $result;
				}
			}
		}
		$i++;
	}
	return undef;

}

sub Next {
	return CursorMove($_[0], 1);
}

sub CursorMove {

	$CURSOR = ( $_[0] eq '' ) ? "DEFAULTCURSOR" : $_[0];
	if ( $Cursors{$CURSOR} == undef ) { return 43; }
	$CURSOR = $Cursors{$CURSOR};

	if ( $_[1] eq '' ) {
		$CurPos[$CURSOR] = 1;
	} else {
		$CurPos[$CURSOR] += $_[1];
	}

	if ( $CurPos[$CURSOR] < 1 ) { $CurPos[$CURSOR] = 1; }
	if ( $CurPos[$CURSOR] > $RecordCount[$CURSOR] ) { return 13; }

}

sub GetColumnNames {
	my( @result );

	$CURSOR = ( $_[0] eq '' ) ? "DEFAULTCURSOR" : $_[0];
	if ( $Cursors{$CURSOR} == undef ) { return; }
	$CURSOR = $Cursors{$CURSOR};

	@result = @{$ExecuteResult[$CURSOR]->[0]};

	return @result;

}

sub Execute {
	my( @SQL, $r, $i, $c, $k );

	if ( $_[0] eq '' ) {
		if ( @PROCEDURE == 0 ) { return 69; }
		foreach ( @PROCEDURE ) { if ( $_ eq '?' ) { return 70; } }
	} else {
		@PROCEDURE = xsplit4sql($_[0]);
		if ( @PROCEDURE == 0 ) { return 72; }
	}

	for ( $i = 0, $c = 0; $i <= @PROCEDURE; $i++ ) {
		if ( $PROCEDURE[$i] eq ';' || $i == @PROCEDURE) {
			$r = ExecuteSQL(@SQL);
			if ( $r != 0 ) { return $r; }
			@SQL = undef;
			$c = 0;
		} else {
			$SQL[$c++] = $PROCEDURE[$i];
		}
	}

	@PROCEDURE = ();
	return 0;

}

sub AutoCommit {
	my $v = $_[0];
	if ( $v =~ /(true|on)/i ) { $v = 1; }
	else { $v = $_[0] - 0; }
	$AutoCommit = $v;
	return 0;
}

sub Commit {
	return Execute("COMMIT $_[0]");
}

sub Rollback {
	return Execute("ROLLBACK $_[0]");
}

sub FileOwnerIs {

	$FileUID = $_[0];
	$FileGID = $_[1];
#	$FileAtt = $_[2];

	return 0;

}

sub GetXmlInfo {
	$TABLE = FindTable($_[0]);
	if ( $TABLE eq '' ) { return (); }
	if ( $XML[$TABLE] eq '' ) { return (); }
	return split(/;/, $XML[$TABLE]);
}

sub CharCodeIs {
	my ( $codename ) = uc($_[0]);
	if ( $codename eq 'SHIFT_JIS' || $codename eq 'SHIFTJIS' || $codename eq 'SJIS' || $codename eq '0' ) {
		$CharCode = 0;
	} elsif ( $codename eq 'EUC' || $codename eq 'EUC-JP' || $codename eq 'EUC_JP' || $codename eq '1' ) {
		$CharCode = 1;
		PrepareEUC();
	} elsif ( $codename eq 'UTF_8' || $codename eq 'UTF-8' || $codename eq '2' ) {
		$CharCode = 2;
		PrepareUTF8();
	}
	return 0;
}

sub SeparaterIs {
	$Separater = $_[0];
	return 0;
}

sub ExecuteSQL {
	my( @SQL ) = @_;
	my( $i, $c, $w, @RSQL, @SubQuery );

	# Sub-query control
	for ( $i = 0; $i < @SQL; $i++ ) {
		push( @RSQL, $SQL[$i] );
		if ( $SQL[$i] eq '(' && lc($SQL[$i+1]) eq 'select' ) {
			# Start Sub-query
			$parent = 0;
			for ( $i++, $c = 0; $i < @SQL; $i++ ) {
				if ( $parent == 0 && $SQL[$i] eq ')' ) {
					last;
				}
				elsif ( $SQL[$i] eq '(' ) { $parent++; }
				elsif ( $SQL[$i] eq ')' ) { $parent--; }
				$SubQuery[$c++] = $SQL[$i];
			}
			if ( $parent != 0 ) { return 16; }
			$NestLevel++;
			$r = ExecuteSQL(@SubQuery);
			if ( $r != 0 ) { return $r; }
			$NestLevel--;

			pop(@RSQL);
			push( @RSQL, "__ResultSet($NewestCursor)" );
		}
	}

	$r = compile(@RSQL);
	if ( $r != 0 ) { return $r; }

	if ( $COMMAND eq 'select' ) {
		$r = seSelect();
	} elsif( $COMMAND eq 'update' ) {
		$r = seUpdate();
	} elsif( $COMMAND eq 'insert' ) {
		$r = seInsert();
	} elsif( $COMMAND eq 'delete' ) {
		$r = seDelete();
	} elsif( $COMMAND eq 'add' ) {
		if ( $Listeners[$TABLE] ne '' ) { return 54; }
		$r = seAdd();
	} elsif( $COMMAND eq 'create' ) {
		$r = seCreate();
	} elsif( $COMMAND eq 'open' ) {
		$r = seOpen();
	} elsif( $COMMAND eq 'desc' ) {
		$r = seDesc();
	} elsif( $COMMAND eq 'relate' ) {
		$r = seRelate();
	} elsif( $COMMAND eq 'lock' ) {
		if ( $Listeners[$TABLE] ne '' ) { return 54; }
		$r = seLock();
	} elsif( $COMMAND eq 'unlock' ) {
		$r = seUnlock();
	} elsif( $COMMAND eq 'commit' ) {
		$r = seCommit();
	} elsif( $COMMAND eq 'rollback' ) {
		$r = seRollback();
	} else {
		return 2;
	}
	if ( $r != 0 ) { return $r; }

	if ( ($COMMAND eq 'update' || $COMMAND eq 'insert' || $COMMAND eq 'delete') &&
			$r == 0 && $Listeners[$TABLE] ne '' ) {
		foreach( @RSQL ) { $OuterSQL[$TABLE] .= "$_ "; }
		$OuterSQL[$TABLE] .= ";";
	}

}

sub Prepare {
	@PROCEDURE = xsplit4sql($_[0]);
	if ( @PROCEDURE == 0 ) { return 72; }
	return 0;
}

sub SetValue {
	my( $flg ) = 0;
	my( $value );

	if ( @_ >= 2 ) {
		$value = "__SE_SYSTEM_ARRAY:" . Array2Str(@_);
	} else {
		$value = $_[0];
	}

	if ( $value =~ /\D/ || $value eq '' ) {
		$value =~ s/\r//g;
		$value = '"' . $value . '"';
	}
	foreach ( @PROCEDURE ) {
		if ( $_ eq '?' ) {
			$_ = $value;
			$flg = 1;
			last;
		}
	}
	if ( $flg == 0 ) { return 71; }
	return 0;
}

sub CreateExcelFile {
	my( $TableName, $FileName, $BackUp ) = @_;
	my( $i, $WriteLine, $item, @n );

	while ( 1 ) { if ( !(-e "SE.LOCK") ) { last; } }
	open(LOCK,">SE.LOCK");
	close(LOCK);

	# Open a table (view)
	$TABLE = FindTable($TableName);
	if ( $TABLE eq '' ) {
		unlink("SE.LOCK");
		return 1;
	}

	$buffringmode = $|;
	$| = 1;

	# Back up when back up mode
	if ( $BackUp != 0 && (-e $FileName) ) {
		if ( open(IN , "<$FileName") == undef ) {
			$| = $buffringmode;
			unlink("SE.LOCK");
			return 7;
		}
		if ( open(OUT, ">$FileName.bak") == undef ) {
			$| = $buffringmode;
			close(IN);
			unlink("SE.LOCK");
			return 7;
		}
		eval { flock(OUT, 2); };
		binmode(IN);
		binmode(OUT);
		$/ = '';
		$size = (stat(IN))[7];
		if ( sysread(IN, $Data, $size) != $size ) {
			$| = $buffringmode;
			close(IN);
			close(OUT);
			unlink("SE.LOCK");
			return 7;
		}
		print OUT $Data;
		close(IN);
		close(OUT);
	}

	# write
	if ( open(OUT, ">$FileName") == undef ) {
		$| = $buffringmode;
		unlink("SE.LOCK");
		return 7;
	}
	eval { flock(OUT, 2); };

	binmode(OUT);
	for ( $i = 0; $i < $DbLineCount[$TABLE]; $i++ ) {
		@n = @{$DB[$TABLE]->[$i]};
		$WriteLine = '';
		foreach ( @n ) {
			if ( /[\x00-\x19\,]/ ) {
				$item = "\"$_\"$Separater";
			} else {
				$item = "$_$Separater";
			}
			$WriteLine .= $item;
		}
		$WriteLine =~ s/$Separater$/\n/;
		$WriteLine =~ s/\t//;
		print OUT $WriteLine;
	}

	close(OUT);
	$| = $buffringmode;
	unlink("SE.LOCK");
	return 0;

}

sub RelateWords {
	my( $w, $i );
	my( $key, @vals ) = @_;

	if ( @vals == 0 ) { return 77; }

	$key = rolling2($key);
	if ( $key eq '' ) { return 77; }

	for ( $i = 0; $i < @vals; $i++ ) {
		$vals[$i] = rolling2($vals[$i]);
		if ( $vals[$i] eq '' ) {
			splice( @vals, $i, 1 );
			next;
		}
	}

	$key =~ s/[\?\.\^\$\[\]\*\+\|\(\)\\]/\\$&/g;
	foreach ( @vals ) {
		s/[\?\.\^\$\[\]\*\+\|\(\)\\]/\\$&/g;
		$RelateWord{$_} = $key;
	}

	$RegRelate = '(';
	foreach ( keys( %RelateWord ) ) { $RegRelate .= "$_|"; }
	$RegRelate =~ s/\|$/\)/;

	return 0;

}

sub RelateWordsFromFile {
	my ( @rdata, @tmp, $r );
	my( $key, @vals );

	open(IN, "<$_[0]") || return 7;
	<IN>;	# disregard column line
	@rdata = <IN>;
	close(IN);
	xchomp(@rdata);

	foreach ( @rdata ) {
		@tmp = xsplit4load($Separater, $_);
		if ( $tmp[0] =~ /^disregard:/i ) {
			$tmp[0] =~ s/^disregard://i;
			SetDisregardWords(@tmp);
		} else {
			$r = RelateWords(@tmp);
		}
	}

	return 0;

}

sub SetDisregardWords {
	my ( $word );

	foreach ( @_ ) {
		$word = rolling2($_);
		$word =~ s/[\?\.\^\$\[\]\*\+\|\(\)\\]/\\$&/g;
		if ( $_ ne '' ) { push( @DisregardWords, $word ); }
	}

	$RegDisregard = '(';
	foreach ( @DisregardWords ) { $RegDisregard .= "$_|"; }
	$RegDisregard =~ s/\|$/\)/;

	return 0;

}

sub CreateXml {

	my( $charset ) = $_[2];
	if ( $charset eq '' ) {
		if ( $CharCode == 0 ) {
			$charset = 'Shift_JIS';
		} elsif ( $CharCode == 1 ) {
			$charset = 'EUC-JP';
		} elsif ( $CharCode == 2 ) {
			$charset = 'UTF-8';
		}
	}
	my( $XML ) = $DefaultXML;
	$XML =~ s/___SYSTEM_CHARA_SET___/$charset/;

	open(OUT, ">$_[1]");
	print OUT $XML;
	close(OUT);

	DBOpen($_[0], $_[1]);
	Execute("DELETE FROM $_[0]");
	return 0;

}

sub StartSession {
	$SessionLimit = $_[0] - 0;
	$SessionLimit += time if ( $SessionLimit != 0 );

	foreach (split(/; */, $ENV{'HTTP_COOKIE'})) {
		($name, $value) = split(/=/, $_);
		if ( $name eq 'se_system_session' ) {
			$SessionID = $value;
			last;
		}
	}

	if ( $SessionID eq '' ) {
		$SessionID = sprintf("%03d%03d%03d%03d", split(/\./, $ENV{REMOTE_ADDR})) . time;
	}

	local($tmp);
	$tmp = "Set-Cookie: ";
	$tmp .= "se_system_session=$SessionID; ";
	$tmp .= "expires=Thu, 1-Jan-2030 00:00:00 GMT;\n";
	print $tmp;

	if ( Execute("OPEN SE_SYSTEM_SESSION FILE './system_session.cgi'") != 0 ) {
		if ( Execute("CREATE TABLE SE_SYSTEM_SESSION ( ID, LIMIT, NAME, DATA ) FILE './system_session.cgi'") != 0 ) {
			return 82;
		}
	}

	Execute("DELETE FROM SE_SYSTEM_SESSION WHERE LIMIT != 0 AND LIMIT < " . time );
	Commit();

	return 0;
}

sub GetSession {
	my $TABLE = FindTable(SE_SYSTEM_SESSION);
	if ( $TABLE eq '' ) { return (); }
	my @data = Str2Array(FExec("SELECT DATA FROM SE_SYSTEM_SESSION WHERE ID = '$SessionID' AND NAME = '$_[0]'"));
	if ( $_[1] != 0 ) {
		my $limit = $_[1] + time;
		Execute("UPDATE SE_SYSTEM_SESSION SET LIMIT = $limit WHERE ID = '$SessionID' AND NAME = '$name'");
	}
	if ( wantarray() ) {
		return @data;
	} else {
		return $data[0];
	}
}

sub GetApplication {
	my $TABLE = FindTable(SE_SYSTEM_SESSION);
	if ( $TABLE eq '' ) { return (); }
	my @data = Str2Array(FExec("SELECT DATA FROM SE_SYSTEM_SESSION WHERE ID = '' AND NAME = '$_[0]'"));
	if ( $_[1] != 0 ) {
		my $limit = $_[1] + time;
		Execute("UPDATE SE_SYSTEM_SESSION SET LIMIT = $limit WHERE ID = '' AND NAME = '$name'");
	}
	if ( wantarray() ) {
		return @data;
	} else {
		return $data[0];
	}
}

sub GetAllSession {
	my $TABLE = FindTable(SE_SYSTEM_SESSION);
	if ( $TABLE eq '' ) { return (); }
	my ( %result, $name, $data );
	Execute("SELECT NAME, DATA FROM SE_SYSTEM_SESSION WHERE ID = '$SessionID'");
	while ( Se::Fetch($name, $data) == 0 ) { $result{$name} = Str2Array($data); }
	if ( $_[1] != 0 ) {
		my $limit = $_[1] + time;
		Execute("UPDATE SE_SYSTEM_SESSION SET LIMIT = $limit WHERE ID = '$SessionID'");
	}
	return %result;
}

sub SetSession {
	return SetLimitedSession( $SessionLimit, @_ );
}

sub SetApplication {
	return SetLimitedApplication( $SessionLimit, @_ );
}

sub SetLimitedSession {
	my $limit = $_[0];
	if ( $limit != 0 ) { $limit += time; }
	my $name = $_[1];
	if ( $name eq '' ) { return 84; }
	my @value = @_; shift(@value); shift(@value);
	my $data = Array2Str(@value);
	my ( $rec, $found, $TABLE );
	$found = 0;
	$TABLE = FindTable(SE_SYSTEM_SESSION);
	if ( $TABLE eq '' ) { return 83; }

	if ( $_[1] ne '' ) {
		for ( $rec = 1; $rec < $DbLineCount[$TABLE]; $rec++ ) {
			if ( $DB[$TABLE]->[$rec]->[0] eq $SessionID && $DB[$TABLE]->[$rec]->[2] eq $name ) {
				$found = 1;
				last;
			}
		}

		if ( $found ) {
			Execute("UPDATE SE_SYSTEM_SESSION SET LIMIT = $limit, DATA = '$data' WHERE ID = '$SessionID' AND NAME = '$name'");
		} else {
			Execute("INSERT INTO SE_SYSTEM_SESSION VALUES ( '$SessionID', $limit, '$name', '$data' )");
		}
	} else {
		Execute("DELETE FROM SE_SYSTEM_SESSION WHERE WHERE ID = '$SessionID' AND NAME = '$name'");
	}

	return 0;

}

sub SetLimitedApplication {
	my $limit = $_[0];
	if ( $limit != 0 ) { $limit += time; }
	my $name = $_[1];
	if ( $name eq '' ) { return 84; }
	my @value = @_; shift(@value); shift(@value);
	my $data = Array2Str(@value);
	my ( $rec, $found, $TABLE );
	$found = 0;
	$TABLE = FindTable(SE_SYSTEM_SESSION);
	if ( $TABLE eq '' ) { return 83; }

	if ( $_[1] ne '' ) {
		for ( $rec = 1; $rec < $DbLineCount[$TABLE]; $rec++ ) {
			if ( $DB[$TABLE]->[$rec]->[0] eq '' && $DB[$TABLE]->[$rec]->[2] eq $name ) {
				$found = 1;
				last;
			}
		}

		if ( $found ) {
			Execute("UPDATE SE_SYSTEM_SESSION SET LIMIT = $limit, DATA = '$data' WHERE ID = '' AND NAME = '$name'");
		} else {
			Execute("INSERT INTO SE_SYSTEM_SESSION VALUES ( '', $limit, '$name', '$data' )");
		}
	} else {
		Execute("DELETE FROM SE_SYSTEM_SESSION WHERE WHERE ID = '' AND NAME = '$name'");
	}

	return 0;

}

sub EndSession {
	Commit(SE_SYSTEM_SESSION);
}

sub GetTableNo {
	my ( $dbno, $i ) = -1;
	for ( $i = 0; $i < @DbList; $i++ ) {
		if ( $_[0] eq $DbList[$i] ) {
			$dbno = $i;
			last;
		}
	}
	return $dbno;
}

sub GetDirectRecord {
	my ( $i, @result, @stmp );

	if ( $_[0] < 0 ) { return (); }
	if ( $DbList[$_[0]] eq undef ) { return (); }
	if ( $_[1] < 0 || $_[1] >= $DbLineCount[$_[0]] ) { return (); }

	@result = @{$DB[$_[0]]->[$_[1]]};
	for ( $i = 0; $i < @result; $i++ ) {
		if ( $result[$i] =~ s/^__SE_SYSTEM_ARRAY:// ) {
			@stmp = Str2Array($result[$i]);
			$result[$i] = \@stmp;
		}
	}

	return @result;

}

sub seSelect {
	my( $i, $c, $l, $lcnt, @result, $rec, $start, $s, @STABLE, $k, $same, @DOrder );

	# WHERE search
	@result = Search();
	if ( $SearchError != 0 ) { return $SearchError; }

	@{STABLE} = @{$TABLE};

	# initialize result
	$NewestCursor = $CURSOR;
	$RecordCount[$NewestCursor] = 0;
	$ExecuteResult[$CURSOR] = undef;

	# Get a record count
	foreach ( @result ) { if ( $_ == 1 ) { $RecordCount[$CURSOR]++; } }
	$RecordCount[$CURSOR] = 0 if ( $RecordCount[$CURSOR] == undef );

	# Check complex column output and function output
	$ColumnIn = 0;
	$FunctionIn = 0;
	for ( $i = 0; $i < @COLUMNS; $i++ ) {
		# input column name for search
		if ( $COLUMNS[$i]->[3] eq '' ) {
			if ( $COLUMNS[$i]->[0] == 0 ) {
				$ExecuteResult[$CURSOR]->[0]->[$i] = $STABLE[0]->[$COLUMNS[$i]->[1]];
			} else {
				if ( $COLUMNS[$i]->[1] eq 'count' ) {
					$ExecuteResult[$CURSOR]->[0]->[$i] = uc($COLUMNS[$i]->[1]) . " OF $COLUMNS[$i]->[2]";
				} else {
					$ExecuteResult[$CURSOR]->[0]->[$i] = uc($COLUMNS[$i]->[1]) . " OF $STABLE[0]->[$COLUMNS[$i]->[2]]";
				}
			}
		} else {
			$ExecuteResult[$CURSOR]->[0]->[$i] = $COLUMNS[$i]->[3];
		}
		if ( $COLUMNS[$i]->[0] == 1 ) {
			$FunctionIn = 1;
			if ( $COLUMNS[$i]->[1] eq 'count' ) {
				$ExecuteResult[$CURSOR]->[1]->[$i] = $RecordCount[$CURSOR];
			}
		} else {
			$ColumnIn++;
		}
	}

	if ( @GROUP == 0 ) {
		if ( $ColumnIn == $FunctionIn ) { return 17; }

		# calculate function
		if ( $FunctionIn == 1 ) {
			@Avg = ();
			@fi = ();
			for ( $rec = 1; $rec < $TableLineCnt; $rec++ ) {
				if ( $result[$rec-1] == 1 ) {
					for ( $i = 0; $i < @COLUMNS; $i++ ) {
						if ( $COLUMNS[$i]->[1] eq 'avg' ) {
							$Avg[$i] = 1;
							$ExecuteResult[$CURSOR]->[1]->[$i] += $STABLE[$rec]->[$COLUMNS[$i]->[2]];
						} elsif ( $COLUMNS[$i]->[1] eq 'sum' ) {
							$ExecuteResult[$CURSOR]->[1]->[$i] += $STABLE[$rec]->[$COLUMNS[$i]->[2]];
						} elsif ( $COLUMNS[$i]->[1] eq 'max' ) {
							if ( $fi[$i] == 0 ) {
								$fi[$i] = 1;
								$ExecuteResult[$CURSOR]->[1]->[$i] = $STABLE[$rec]->[$COLUMNS[$i]->[2]];
							} elsif ( $ExecuteResult[$CURSOR]->[1]->[$i] < $STABLE[$rec]->[$COLUMNS[$i]->[2]] ) {
								$ExecuteResult[$CURSOR]->[1]->[$i] = $STABLE[$rec]->[$COLUMNS[$i]->[2]];
							}
						} elsif ( $COLUMNS[$i]->[1] eq 'min' ) {
							if ( $fi[$i] == 0 ) {
								$fi[$i] = 1;
								$ExecuteResult[$CURSOR]->[1]->[$i] = $STABLE[$rec]->[$COLUMNS[$i]->[2]];
							} elsif ( $ExecuteResult[$CURSOR]->[1]->[$i] > $STABLE[$rec]->[$COLUMNS[$i]->[2]] ) {
								$ExecuteResult[$CURSOR]->[1]->[$i] = $STABLE[$rec]->[$COLUMNS[$i]->[2]];
							}
						} elsif ( $COLUMNS[$i]->[1] eq 'grouping' ) {
							$ExecuteResult[$CURSOR]->[1]->[$i] = AddArray($ExecuteResult[$CURSOR]->[1]->[$i], $STABLE[$rec]->[$COLUMNS[$i]->[2]]);
						} elsif ( $COLUMNS[$i]->[1] eq 'grouping2' ) {
							$ExecuteResult[$CURSOR]->[1]->[$i] = AddArrayDistinct($ExecuteResult[$CURSOR]->[1]->[$i], $STABLE[$rec]->[$COLUMNS[$i]->[2]]);
						}
					}
				}
			}
			for ( $i = 0; $i < @COLUMNS; $i++ ) {
				if ( $Avg[$i] == 1 ) {
					$ExecuteResult[$CURSOR]->[1]->[$i] /= $RecordCount[$CURSOR];
				}
			}
			$RecordCount[$CURSOR] = 1;
		}

		# Get a column
		if ( $ColumnIn > 0 ) {
			for ( $rec = 0, $l = 1; $rec < @result; $rec++ ) {
				if ( $result[$rec] == 1 ) {
					for ( $c = 0; $c < @COLUMNS; $c++ ) {
						if ( $COLUMNS[$c]->[0] == 0 ) {
							$ExecuteResult[$CURSOR]->[$l]->[$c] = $STABLE[$rec+1]->[$COLUMNS[$c]->[1]];
						} else {
							if ( $COLUMNS[$c]->[1] eq 'length' ) {
								$ExecuteResult[$CURSOR]->[$l]->[$c] = length($STABLE[$rec+1]->[$COLUMNS[$c]->[2]]);
							} elsif ( $COLUMNS[$c]->[1] eq 'upper' ) {
								$ExecuteResult[$CURSOR]->[$l]->[$c] = graphic_uc($STABLE[$rec+1]->[$COLUMNS[$c]->[2]]);
							} elsif ( $COLUMNS[$c]->[1] eq 'lower' ) {
								$ExecuteResult[$CURSOR]->[$l]->[$c] = graphic_lc($STABLE[$rec+1]->[$COLUMNS[$c]->[2]]);
							} elsif ( $COLUMNS[$c]->[1] eq 'rolling' ) {
								$ExecuteResult[$CURSOR]->[$l]->[$c] = rolling($STABLE[$rec+1]->[$COLUMNS[$c]->[2]]);
							} elsif ( $COLUMNS[$c]->[1] eq 'rolling2' ) {
								$ExecuteResult[$CURSOR]->[$l]->[$c] = rolling2($STABLE[$rec+1]->[$COLUMNS[$c]->[2]]);
							} elsif ( $COLUMNS[$c]->[1] eq 'getyear' ) {
								$ExecuteResult[$CURSOR]->[$l]->[$c] = year($STABLE[$rec+1]->[$COLUMNS[$c]->[2]]);
							} elsif ( $COLUMNS[$c]->[1] eq 'getmonth' ) {
								$ExecuteResult[$CURSOR]->[$l]->[$c] = month($STABLE[$rec+1]->[$COLUMNS[$c]->[2]]);
							} elsif ( $COLUMNS[$c]->[1] eq 'getday' ) {
								$ExecuteResult[$CURSOR]->[$l]->[$c] = day($STABLE[$rec+1]->[$COLUMNS[$c]->[2]]);
							} elsif ( $COLUMNS[$c]->[1] eq 'gethour' ) {
								$ExecuteResult[$CURSOR]->[$l]->[$c] = hour($STABLE[$rec+1]->[$COLUMNS[$c]->[2]]);
							} elsif ( $COLUMNS[$c]->[1] eq 'getminute' ) {
								$ExecuteResult[$CURSOR]->[$l]->[$c] = minute($STABLE[$rec+1]->[$COLUMNS[$c]->[2]]);
							} elsif ( $COLUMNS[$c]->[1] eq 'getsecond' ) {
								$ExecuteResult[$CURSOR]->[$l]->[$c] = second($STABLE[$rec+1]->[$COLUMNS[$c]->[2]]);
							} elsif ( $COLUMNS[$c]->[1] eq 'getweek' ) {
								$ExecuteResult[$CURSOR]->[$l]->[$c] = week($STABLE[$rec+1]->[$COLUMNS[$c]->[2]]);
							} elsif ( $COLUMNS[$c]->[1] eq 'wordrolling' ) {
								$ExecuteResult[$CURSOR]->[$l]->[$c] = wrolling($STABLE[$rec+1]->[$COLUMNS[$c]->[2]]);
							}
						}
					}
					$l++;
				}
			}
		}
	} else {
		local( @n );

		# Process of GROUP BY

		# Check invalid column
		for ( $i = 0; $i < @COLUMNS; $i++ ) {
			if ( $COLUMNS[$i]->[0] == 0 || $COLUMNS[$i]->[0] == 2 ) {
				for ( $k = 0; $k < @GROUP; $k++ ) {
					if ( $GROUP[$k]->[0] eq $ExecuteResult[$CURSOR]->[0]->[$i] ) { last; }
				}
				if ( $k == @GROUP ) { return 17; }
			}
			if ( $COLUMNS[$i]->[0] == 1 &&
				($COLUMNS[$i]->[1] ne 'avg' && $COLUMNS[$i]->[1] ne 'sum' &&
				 $COLUMNS[$i]->[1] ne 'max' && $COLUMNS[$i]->[1] ne 'min' &&
				 $COLUMNS[$i]->[1] ne 'count' &&
				 $COLUMNS[$i]->[1] ne 'grouping' && $COLUMNS[$i]->[1] ne 'grouping2') ) { return 17; }
		}

		# Get a column
		for ( $rec = 0, $l = 1; $rec < @result; $rec++ ) {
			if ( $result[$rec] == 1 ) {
				for ( $c = 0; $c < @COLUMNS; $c++ ) {
					if ( $COLUMNS[$c]->[0] == 1 ) {
						$ExecuteResult[$CURSOR]->[$l]->[$c] = $STABLE[$rec+1]->[$COLUMNS[$c]->[2]];
					} elsif ( $COLUMNS[$c]->[0] == 2 ) {
						if ( $COLUMNS[$c]->[1] eq 'length' ) {
							$ExecuteResult[$CURSOR]->[$l]->[$c] = length($STABLE[$rec+1]->[$COLUMNS[$c]->[2]]);
						} elsif ( $COLUMNS[$c]->[1] eq 'upper' ) {
							$ExecuteResult[$CURSOR]->[$l]->[$c] = graphic_uc($STABLE[$rec+1]->[$COLUMNS[$c]->[2]]);
						} elsif ( $COLUMNS[$c]->[1] eq 'lower' ) {
							$ExecuteResult[$CURSOR]->[$l]->[$c] = graphic_lc($STABLE[$rec+1]->[$COLUMNS[$c]->[2]]);
						} elsif ( $COLUMNS[$c]->[1] eq 'rolling' ) {
							$ExecuteResult[$CURSOR]->[$l]->[$c] = rolling($STABLE[$rec+1]->[$COLUMNS[$c]->[2]]);
						} elsif ( $COLUMNS[$c]->[1] eq 'rolling2' ) {
							$ExecuteResult[$CURSOR]->[$l]->[$c] = rolling2($STABLE[$rec+1]->[$COLUMNS[$c]->[2]]);
						} elsif ( $COLUMNS[$c]->[1] eq 'getyear' ) {
							$ExecuteResult[$CURSOR]->[$l]->[$c] = year($STABLE[$rec+1]->[$COLUMNS[$c]->[2]]);
						} elsif ( $COLUMNS[$c]->[1] eq 'getmonth' ) {
							$ExecuteResult[$CURSOR]->[$l]->[$c] = month($STABLE[$rec+1]->[$COLUMNS[$c]->[2]]);
						} elsif ( $COLUMNS[$c]->[1] eq 'getday' ) {
							$ExecuteResult[$CURSOR]->[$l]->[$c] = day($STABLE[$rec+1]->[$COLUMNS[$c]->[2]]);
						} elsif ( $COLUMNS[$c]->[1] eq 'gethour' ) {
							$ExecuteResult[$CURSOR]->[$l]->[$c] = hour($STABLE[$rec+1]->[$COLUMNS[$c]->[2]]);
						} elsif ( $COLUMNS[$c]->[1] eq 'getminute' ) {
							$ExecuteResult[$CURSOR]->[$l]->[$c] = minute($STABLE[$rec+1]->[$COLUMNS[$c]->[2]]);
						} elsif ( $COLUMNS[$c]->[1] eq 'getsecond' ) {
							$ExecuteResult[$CURSOR]->[$l]->[$c] = second($STABLE[$rec+1]->[$COLUMNS[$c]->[2]]);
						} elsif ( $COLUMNS[$c]->[1] eq 'getweek' ) {
							$ExecuteResult[$CURSOR]->[$l]->[$c] = week($STABLE[$rec+1]->[$COLUMNS[$c]->[2]]);
						} elsif ( $COLUMNS[$c]->[1] eq 'wordrolling' ) {
							$ExecuteResult[$CURSOR]->[$l]->[$c] = wrolling($STABLE[$rec+1]->[$COLUMNS[$c]->[2]]);
						}
					} else {
						$ExecuteResult[$CURSOR]->[$l]->[$c] = $STABLE[$rec+1]->[$COLUMNS[$c]->[1]];
					}
				}
				$l++;
			}
		}
		$lcnt = $l;

		# Change column name to number for GROUP BY
		for ( $i = 0; $i < @GROUP; $i++ ) {
			for ( $c = 0; $c < @COLUMNS; $c++ ) {
				if ( $GROUP[$i]->[0] eq $ExecuteResult[$CURSOR]->[0]->[$c] ) {
					$GROUP[$i]->[0] = $c;
					$GROUP[$i]->[2] = 2;
					last;
				}
			}
			if ( $c == @COLUMNS ) { return 59; }
		}

		# sort
		for ( $i = 0; $i < @GROUP; $i++ ) {
			if ( $i == 0 ) {
				Sort3( $i, 1, $RecordCount[$CURSOR]+1 );
			} else {
				# diside a starting position and a finishing position
				for ( $rec = 1, $start = $s = 0; $rec < $RecordCount[$CURSOR]+1; $rec++ ) {
					$l = $i - 1;
					if ( $s == 0 ) {
						for ( $k = 0; $k <= $l; $k++ ) {
							if ( $ExecuteResult[$CURSOR]->[$rec]->[$GROUP[$k]->[0]] ne $ExecuteResult[$CURSOR]->[$rec+1]->[$GROUP[$k]->[0]] ) { last; }
						}
						if ( $k > $l ) {
							$start = $rec;
							$s = 1;
						}
					}
					if ( $s == 1 ) {
						for ( $k = 0; $k <= $l; $k++ ) {
							if ( $ExecuteResult[$CURSOR]->[$rec]->[$GROUP[$k]->[0]] ne $ExecuteResult[$CURSOR]->[$rec+1]->[$GROUP[$k]->[0]] ) { last; }
						}
						if ( $k <= $l ) {
							$max = $rec + 1;
							$s = 0;
							Sort3( $i, $start, $max );
						}
					}
				}
			}
		}

		# Statistics process for every group
		for ( $rec = $c = $s = 1; $rec < $lcnt; $rec++, $s++ ) {
			for ( $i = 0; $i < @COLUMNS; $i++ ) {
				if ( $COLUMNS[$i]->[0] == 0 ) {
					$ExecuteResult[$CURSOR]->[$c]->[$i] = $ExecuteResult[$CURSOR]->[$rec]->[$i];
				}
				if ( $s == 1 ) {
					$ExecuteResult[$CURSOR]->[$c]->[$i] = $ExecuteResult[$CURSOR]->[$rec]->[$i];
				} else {
					if ( $COLUMNS[$i]->[1] eq 'avg' ) {
						$ExecuteResult[$CURSOR]->[$c]->[$i] += $ExecuteResult[$CURSOR]->[$rec]->[$i];
					} elsif ( $COLUMNS[$i]->[1] eq 'sum' ) {
						$ExecuteResult[$CURSOR]->[$c]->[$i] += $ExecuteResult[$CURSOR]->[$rec]->[$i];
					} elsif ( $COLUMNS[$i]->[1] eq 'max' ) {
						if ( $ExecuteResult[$CURSOR]->[$c]->[$i] < $ExecuteResult[$CURSOR]->[$rec]->[$i] ) {
							$ExecuteResult[$CURSOR]->[$c]->[$i] = $ExecuteResult[$CURSOR]->[$rec]->[$i];
						}
					} elsif ( $COLUMNS[$i]->[1] eq 'min' ) {
						if ( $ExecuteResult[$CURSOR]->[$c]->[$i] > $ExecuteResult[$CURSOR]->[$rec]->[$i] ) {
							$ExecuteResult[$CURSOR]->[$c]->[$i] = $ExecuteResult[$CURSOR]->[$rec]->[$i];
						}
					} elsif ( $COLUMNS[$i]->[1] eq 'grouping' ) {
						$ExecuteResult[$CURSOR]->[$c]->[$i] = AddArray($ExecuteResult[$CURSOR]->[$c]->[$i], $ExecuteResult[$CURSOR]->[$rec]->[$i]);
					} elsif ( $COLUMNS[$i]->[1] eq 'grouping2' ) {
						$ExecuteResult[$CURSOR]->[$c]->[$i] = AddArrayDistinct($ExecuteResult[$CURSOR]->[$c]->[$i], $ExecuteResult[$CURSOR]->[$rec]->[$i]);
					}
				}
			}
			for ( $k = 0; $k < @GROUP; $k++ ) {
				if ( $GROUP[$k]->[2] == 1 ) {
					if ( $ExecuteResult[$CURSOR]->[$rec]->[$GROUP[$k]->[0]] != $ExecuteResult[$CURSOR]->[$rec+1]->[$GROUP[$k]->[0]] ) { last; }
				} else {
					if ( $ExecuteResult[$CURSOR]->[$rec]->[$GROUP[$k]->[0]] ne $ExecuteResult[$CURSOR]->[$rec+1]->[$GROUP[$k]->[0]] ) { last; }
				}
			}
			if ( $k == @GROUP ) { $same = 1; }
			else { $same = 0; }
			if ( !$same || $rec+1 >= $lcnt ) {
				for ( $i = 0; $i < @COLUMNS; $i++ ) {
					if ( $Avg[$i] == 1 ) {
						$ExecuteResult[$CURSOR]->[$c]->[$i] /= $s;
					}
					if ( $COLUMNS[$i]->[0] == 1 && $COLUMNS[$i]->[1] eq 'count' ) {
						$ExecuteResult[$CURSOR]->[$c]->[$i] = $s;
					}
				}
				$s = 0;
				$c++;
			}
		}
		$RecordCount[$NewestCursor] = $c - 1;
	}

	if ( $Distinct ) {
		# sort
		for ( $i = 0; $i < @COLUMNS; $i++ ) {
			if ( $i == 0 ) {
				Sort4( $i, 1, $RecordCount[$CURSOR]+1 );
			} else {
				# diside a starting position and finished position
				for ( $rec = 1, $start = $s = 0; $rec < $RecordCount[$CURSOR]+1; $rec++ ) {
					$l = $i - 1;
					if ( $s == 0 ) {
						for ( $k = 0; $k <= $l; $k++ ) {
							if ( $ExecuteResult[$CURSOR]->[$rec]->[$k] ne $ExecuteResult[$CURSOR]->[$rec+1]->[$k] ) { last; }
						}
						if ( $k > $l ) {
							$start = $rec;
							$s = 1;
						}
					}
					if ( $s == 1 ) {
						for ( $k = 0; $k <= $l; $k++ ) {
							if ( $ExecuteResult[$CURSOR]->[$rec]->[$k] ne $ExecuteResult[$CURSOR]->[$rec+1]->[$k] ) { last; }
						}
						if ( $k <= $l ) {
							$max = $rec + 1;
							$s = 0;
							Sort4( $i, $start, $max );
						}
					}
				}
			}
		}

		# Check any overlap
		$c = 0;
		for ( $l = $rec = 1; $rec <= $RecordCount[$CURSOR]; $rec++ ) {
			if ( join('__SE_SEPAR_', @{$ExecuteResult[$CURSOR]->[$rec]}) ne join('__SE_SEPAR_', @{$ExecuteResult[$CURSOR]->[$rec+1]}) ) {
				@{ExecuteResult[$CURSOR]->[$l]} = @{ExecuteResult[$CURSOR]->[$rec]};
				$l++;
			} else {
				$c++;
			}
		}
		$RecordCount[$CURSOR] -= $c;
	}

	# Change column name to number for sort
	for ( $i = 0; $i < @ORDERS; $i++ ) {
		for ( $c = 0; $c < @COLUMNS; $c++ ) {
			if ( $ORDERS[$i]->[0] eq $ExecuteResult[$CURSOR]->[0]->[$c] ) {
				$ORDERS[$i]->[0] = $c;
				last;
			}
		}
		if ( $c == @COLUMNS ) { return 12; }
	}

	# diside sort means
	for ( $i = 0; $i < @ORDERS; $i++ ) {
		if ( $ORDERS[$i]->[2] == 0 ) {
			if ( $ExecuteResult[$CURSOR]->[1]->[$ORDERS[$i]->[0]] =~ /\D/ ) {
				$ORDERS[$i]->[2] = 2;
			} else {
				$ORDERS[$i]->[2] = 1;
			}
		}
	}

	# sort
	for ( $i = 0; $i < @ORDERS; $i++ ) {
		if ( $i == 0 ) {
			Sort( $i, 1, $RecordCount[$CURSOR]+1 );
		} else {
			for ( $rec = 1, $start = $s = 0; $rec < $RecordCount[$CURSOR]+1; $rec++ ) {
				$l = $i - 1;
				if ( $s == 0 ) {
					for ( $k = 0; $k <= $l; $k++ ) {
						if ( $ExecuteResult[$CURSOR]->[$rec]->[$ORDERS[$k]->[0]] ne $ExecuteResult[$CURSOR]->[$rec+1]->[$ORDERS[$k]->[0]] ) { last; }
					}
					if ( $k > $l ) {
						$start = $rec;
						$s = 1;
					}
				}
				if ( $s == 1 ) {
					for ( $k = 0; $k <= $l; $k++ ) {
						if ( $ExecuteResult[$CURSOR]->[$rec]->[$ORDERS[$k]->[0]] ne $ExecuteResult[$CURSOR]->[$rec+1]->[$ORDERS[$k]->[0]] ) { last; }
					}
					if ( $k <= $l ) {
						$max = $rec + 1;
						$s = 0;
						Sort( $i, $start, $max );
					}
				}
			}
		}
	}

	$RecordCount = $RecordCount[$NewestCursor];
	$CurPos[$CURSOR] = 1;

	# output when SQL has "TO"
	if ( $TARGET ne '' ) {
		for ( $rec = 0; $rec < $RecordCount+1; $rec++ ) {
			@{$DB[$TARGET]->[$rec]} = @{$ExecuteResult[$CURSOR]->[$rec]};
		}
		$DbLineCount[$TARGET] = $RecordCount + 1;
	}

	# display when inline mode
	if ( $inlinemode != 0 && $NestLevel == 0 ) {
		@itemlen = ();
		$itemh = "";
		$l = 0;
		foreach  ( @COLUMNS ) {
			$imaxlen = length(getDisplayItem($ExecuteResult[$CURSOR]->[0]->[$l]));
			for ( $m = 1; $m <= $RecordCount[$CURSOR]; $m++ ) {
				$nowlen = length(getDisplayItem($ExecuteResult[$CURSOR]->[$m]->[$l]));
				if ( $nowlen > $imaxlen ) { $imaxlen = $nowlen; }
			}
			$itemlen[$l] = $imaxlen;
			print "$ExecuteResult[$CURSOR]->[0]->[$l]".(" "x($imaxlen+1-length(getDisplayItem($ExecuteResult[$CURSOR]->[0]->[$l]))));
			$itemh .= "-"x($imaxlen)." ";
			$l++;
		}
		print "\n$itemh\n";
		for ( $l = 1; $l <= $RecordCount[$CURSOR]; $l++ ) {
			@n2 = ();
			@n2 = @{$ExecuteResult[$CURSOR]->[$l]};
			$m = 0;
			foreach ( @n2 ) {
				$item = getDisplayItem($_);
				print "$item".(" "x($itemlen[$m]-length($item)+1));
				$m++;
			}
			print "\n";
		}
		print "\n";
		print "\t$RecordCount[$CURSOR] record(s) selected\n\n";
	}

	return 0;

}

sub getDisplayItem {
	if ( $_[0] =~ /^__SE_SYSTEM_ARRAY:/ ) {
		if ( $ArrayUnfold ) {
			my ( $w ) = '';
			foreach ( Str2Array(substr($_[0], 18)) ) { $w .= ($w eq '') ? $_ : ",$_"; }
			return $w;
		} else {
			return "(Array)";
		}
	} else {
		return $_[0];
	}
}

sub seUpdate {
	my( $i, $c, @result, $rec );

	if ( @COLUMNS == 0 ) { return 19; }

	# WHERE search
	@result = Search();
	if ( $SearchError != 0 ) { return $SearchError; }

	# update values by result
	$RecordCount = 0;
	for ( $rec = 0; $rec < @result; $rec++ ) {
		if ( $result[$rec] == 1 ) {
			$RecordCount++;
			for ( $c = 0; $c < @COLUMNS; $c++ ) {
				if ( $IndexList[$TABLE]->[0] == $COLUMNS[$c]->[0] ) {
					$IndexList[$TABLE]->[1]->{$DB[$TABLE]->[$rec+1]->[$COLUMNS[$c]->[0]]} = undef;
					$IndexList[$TABLE]->[1]->{$COLUMNS[$c]->[1]} = $rec+1;
				}
				$DB[$TABLE]->[$rec+1]->[$COLUMNS[$c]->[0]] = $COLUMNS[$c]->[1];
			}
		}
	}

	if ( $AutoCommit ) { Commit($DbList[$TABLE]); }
	if ( $inlinemode != 0 ) {
		print "\n\t$RecordCount record(s) updated\n\n";
	}

	return 0;

}

sub seInsert {
	my( $i, $c, $rec, $max, @tmp );


	# insert new record
	if ( $COLUMNS[0]->[1] == 2 ) {
		# any records mode
		$RecordCount = 0;
		for ( $rec = 1; $rec <= $RecordCount[$COLUMNS[0]->[2]]; $rec++ ) {
			$max = @{$ExecuteResult[$COLUMNS[0]->[2]]->[$rec]};
			for ( $c = 0; $c < $max; $c++ ) {
				$DB[$TABLE]->[$DbLineCount[$TABLE]]->[$c] = $ExecuteResult[$COLUMNS[0]->[2]]->[$rec]->[$c];
				if ( $IndexList[$TABLE]->[0] != -1 ) {
					$IndexList[$TABLE]->[1]->{$DB[$TABLE]->[$DbLineCount[$TABLE]]->[$IndexList[$TABLE]->[1]]} = $rec;
				}
			}
			$DbLineCount[$TABLE]++;
			$RecordCount++;
		}
	} else {
		# normally insert
		for ( $i = 0; $i < @COLUMNS; $i++ ) {
			if ( $COLUMNS[$i]->[1] == 0 ) {
				$DB[$TABLE]->[$DbLineCount[$TABLE]]->[$COLUMNS[$i]->[0]] = $COLUMNS[$i]->[2];
			} else {
				if ( lc($COLUMNS[$i]->[2]) eq 'nextval' ) {
					for ( $rec = 1, $max = 0; $rec < $DbLineCount[$TABLE]; $rec++ ) {
						if ( $max < $DB[$TABLE]->[$rec]->[$COLUMNS[$i]->[0]] ){
							$max = $DB[$TABLE]->[$rec]->[$COLUMNS[$i]->[0]];
						}
					}
					$DB[$TABLE]->[$DbLineCount[$TABLE]]->[$COLUMNS[$i]->[0]] = ++$max;
				} elsif ( lc($COLUMNS[$i]->[2]) eq 'systime' ) {
					$DB[$TABLE]->[$DbLineCount[$TABLE]]->[$COLUMNS[$i]->[0]] = time;
				} elsif ( $COLUMNS[$i]->[2] =~ /^__ResultSet\((\d+)\)$/ ) {
					@tmp = getResultByArray($1, 0, 'V');
					if ( @tmp <= 1 ) {
						$DB[$TABLE]->[$DbLineCount[$TABLE]]->[$COLUMNS[$i]->[0]] = $tmp[0];
					} else {
						$DB[$TABLE]->[$DbLineCount[$TABLE]]->[$COLUMNS[$i]->[0]] = "__SE_SYSTEM_ARRAY:" . Array2Str(@tmp);
					}
				} else {
					return 21;
				}
			}
		}
		if ( $IndexList[$TABLE]->[0] != -1 ) {
			$IndexList[$TABLE]->[1]->{$DB[$TABLE]->[$DbLineCount[$TABLE]]->[$IndexList[$TABLE]->[0]]} = $DbLineCount[$TABLE];
		}

		$DbLineCount[$TABLE]++;
		$RecordCount = 1;
	}

	if ( $AutoCommit ) { Commit($DbList[$TABLE]); }
	if ( $inlinemode != 0 ) {
		print "\n\t$RecordCount records(s) inserted\n\n";
	}

	return 0;

}

sub seDelete {
	my ( $rec, $c, $NewRecordCount );

	# WHERE search
	@result = Search();
	if ( $SearchError != 0 ) { return $SearchError; }

	# Mark to records which should be deleted
	$RecordCount = 0;
	for ( $rec = 1; $rec < $DbLineCount[$TABLE]; $rec++ ) {
		if ( $result[$rec-1] == 1 ) {
			$RecordCount++;
			if ( $IndexList[$TABLE]->[0] != -1 ) {
				$IndexList[$TABLE]->[1]->{$DB[$TABLE]->[$rec]->[$IndexList[$TABLE]->[0]]} = undef;
			}
			$DB[$TABLE]->[$rec] = undef;
		}
	}

	# Delete records marked
	for ( $rec = 1, $c = 1; $rec <= $DbLineCount[$TABLE]; $rec++, $c++ ) {
		while ( $DB[$TABLE]->[$c] == undef && $c < $DbLineCount[$TABLE] ) {
			$c++;
		}
		if ( $DB[$TABLE]->[$rec] == undef ) {
			@{$DB[$TABLE]->[$rec]} = @{$DB[$TABLE]->[$c]};
			$DB[$TABLE]->[$c] = undef;
		}
	}

	# Delete zombie data
	$NewRecordCount = $DbLineCount[$TABLE] - $RecordCount;
	for ( $rec = $NewRecordCount; $rec < $DbLineCount[$TABLE]; $rec++ ) {
		$DB[$TABLE]->[$c] = undef;
	}

	# Renew the number of record
	$DbLineCount[$TABLE] = $NewRecordCount;

	if ( $AutoCommit ) { Commit($DbList[$TABLE]); }
	if ( $inlinemode != 0 ) {
		print "\n\t$RecordCount record(s) deleted\n\n";
	}

	return 0;

}

sub seAdd {
	local( $n, $num );

	# Add column
	@n = @{$DB[$TABLE]->[0]};
	$DB[$TABLE]->[0]->[@n] = $COLUMNS[0];

	if ( $inlinemode != 0 ) {
		print "\n\tThe table $DbList[$TABLE] was added the column $COLUMNS[0]\n\n";
	}

	return 0;

}

sub seCreate {
	local( $WriteLine );

	if ( $TARGET eq 'table' ) {
		# Check overlaped column
		if ( !DoubleItem(@COLUMNS) ) {
			pop(@DbList);
			pop(@DbFile);
			return 31;
		}

		if ( $DbFile[$TABLE] ne '' ) {
			# Check exist file
			if ( -e $DbFile[$TABLE] ) {
				pop(@DbList);
				pop(@DbFile);
				return 32;
			}

			# file open
			if ( !open(OUT, ">$DbFile[$TABLE]") ) {
				pop(@DbList);
				pop(@DbFile);
				return 7;
			}
			eval { flock(OUT, 2); };

			# create database file
			$WriteLine = "";
			foreach ( @COLUMNS ) {
				if ( $_ eq '' ) { return 15; }
				s/\\/\\\\/g;
				s/\n/\\n/g;
				s/\t/\\t/g;
				s/"/\\"/g;
				$item = "\"$_\",";
				$WriteLine .= $item;
			}
			$WriteLine =~ s/,$/\n/;
			print OUT $WriteLine;

			# deside file status
			close(OUT);
			if ( $FileUID ne "" && $FileGID ne "" ) {
				chown( $FileUID, $FileGID, $FlName );
			}
			chmod(0666, $DbFile[$TABLE]);

			if ( $DbList[$TABLE] eq '(' ) {
				pop(@DbList);
				pop(@DbFile);
				return 0;
			}

		} elsif ( $DbList[$TABLE] eq '(' ) {
			pop(@DbList);
			pop(@DbFile);
			return 75;
		}

		# create a table
		@{$DB[$TABLE]->[0]} = @COLUMNS;
		$DbLineCount[$TABLE] = 1;
		$IndexList[$TABLE]->[0] = $IndexColumn;
	} else {
		return seCreateView();
	}

	return 0;

}

sub seCreateView {
	my( $i, $j, $rec, $l, $c, $tName );
	local( @JOINTMP );

	# initialize
	$DB[$TABLE] = undef;
	$DbLineCount[$TABLE] = 1;
	@JOINTMP = ();

	$j = 0;
	for ( $i = 0; $i < 2; $i++ ) {
		$JOINTMP[$i] = makeTempForCView( \@{$DB[$TABLES[$i]->[0]]}, $DbLineCount[$TABLES[$i]->[0]], $DbList[$TABLES[$i]->[0]] );
		sortAll( $i, $DbLineCount[$TABLES[$i]->[0]], $ColNo[$i], \@{$TABLES[$i]} );
	}

	compJoinTable( \@{$DB[$TABLE]}, $DbLineCount[$TABLE], $ColNo[0],
				\@{$JOINTMP[0]}, $DbLineCount[$TABLES[0]->[0]], \@{$JOINTMP[1]}, $DbLineCount[$TABLES[1]->[0]] );

	$DbFile[$TABLE] = '';

	return 0;

}

sub makeTempForCView {
	my ( @src, $cnt, $alias );
	my ( $i, $rec, $c, $tName, @dest, @n );

	@{src} = @{$_[0]};
	$cnt = $_[1];
	$alias = $_[2];
	@{n} = @{$src[0]};

	# copy table to temporary
	for ( $rec = 0; $rec < $cnt; $rec++ ) {
		$c = 0;
		for ( $c = 0; $c < @n; $c++ ) {
			if ( $rec == 0 && index($src[0]->[$c],".") == -1 ) {
				$dest[$rec]->[$c] = "$alias.$src[$rec]->[$c]";
			} else {
				$dest[$rec]->[$c] = "$src[$rec]->[$c]";
			}
		}
	}

	return \@dest;

}

sub sortAll {
	my ( $cnt, $ColNo );
	my ( $i, $c, $rec, $start, $l, $s );
	local( @SetInfo );

	$i = $_[0];
	$cnt = $_[1];
	$ColNo = $_[2];
	@{SetInfo} = @{$_[3]};

	# deside sort means
	for ( $c = 1; $c <= $ColNo; $c++ ) {
		if ( $SetInfo[$c]->[2] == 0 ) { $SetInfo[$c]->[2] = 2; }
	}

	# sort
	for ( $c = 1; $c <= $ColNo; $c++ ) {
		if ( $c == 1 ) {
			Sort2( $i, $c, 1, $cnt, \@SetInfo );
		} else {
			for ( $rec = 1, $start = $s = 0; $rec < $cnt; $rec++ ) {
				$l = $c - 1;
				if ( $s == 0 && $JOINTMP[$i]->[$rec]->[$SetInfo[$l]->[0]] eq $JOINTMP[$i]->[$rec+1]->[$SetInfo[$l]->[0]] ) {
					$start = $rec;
					$s = 1;
				}
				if ( $s == 1 && $JOINTMP[$i]->[$rec]->[$SetInfo[$l]->[0]] ne $JOINTMP[$i]->[$rec+1]->[$SetInfo[$l]->[0]] ) {
					$max = $rec + 1;
					$s = 0;
					Sort2( $i, $c, $start, $max, \@SetInfo );
				}
			}
		}
	}

}

sub compJoinTable {
	local( @dest, $dstCount, $ColNo, @tbl1, $cnt1, @tbl2, $cnt2 );
	local( @Comps, @result, $line, $i, $j, $out, $c, $l, @n, $k, $out );

	$dstCount = $_[1];
	$ColNo = $_[2];
	@{tbl1} = @{$_[3]};
	$cnt1 = $_[4];
	@{tbl2} = @{$_[5]};
	$cnt2 = $_[6];

	# deside compare means
	@Comps = ();
	for ( $c = 1; $c <= $ColNo; $c++ ) {
		if ( $TABLES[0]->[$c]->[2] == 2 ) {
			$Comps[$c] = \&Comp_c;
		} else {
			$Comps[$c] = \&Comp_n;
		}
	}

	# create column name
	@{n} = @{$tbl1[0]};
	for ( $c = $i = 0; $i < @n; $i++ ) {
		if ( index($tbl1[0]->[$i],".") == -1 ) {
			$dest[0]->[$c++] = "$alias.$tbl1[0]->[$i]";
		} else {
			$dest[0]->[$c++] = "$tbl1[0]->[$i]";
		}
	}
	@{n} = @{$tbl2[0]};
	for (      $i = 0; $i < @n; $i++ ) {
		if ( index($tbl2[0]->[$i],".") == -1 ) {
			$dest[0]->[$c++] = "$alias.$tbl2[0]->[$i]";
		} else {
			$dest[0]->[$c++] = "$tbl2[0]->[$i]";
		}
	}

	# Compare and output column
	$i = $j = 1;
	while ( $i < $cnt1 && $j < $cnt2 ) {
		$r = CompsAll($i, $j);
		if ( $r == 0 ) {
			# accorded
			copyCompResult($i, $j);
			for ( $k = $j + 1; $k < $cnt2; $k++ ) {
				if ( CompsAll($i, $k) == 0 ) { copyCompResult($i, $k); }
			}
			$i++;
		} elsif ( $r == -1 ) {
			if ( $INOUT == 2 ) {
				# when outer join
				$c = $l = 0;
				while ( $tbl1[0]->[$c] ne '' ) {
					$dest[$dstCount]->[$l] = $tbl1[$i]->[$c];
					$c++;
					$l++;
				}
				$dstCount++;
			}
			$i++;
		} elsif ( $r == 1 ) {
			$j++;
		}
	}

	while ( $i < $cnt1 && $INOUT == 2 ) {
		# when outer join
		$c = $l = 0;
		while ( $tbl1[0]->[$c] ne '' ) {
			$dest[$dstCount]->[$l] = $tbl1[$i]->[$c];
			$c++;
			$l++;
		}
		$dstCount++;
		$i++;
	}

	@{$_[0]} = @{dest};
	$_[1] = $dstCount;
	return 0;

}

sub CompsAll {
	my ( $i, $j ) = @_;
	my ( $c, $r );
	for ( $c = 1; $c <= $ColNo; $c++ ) {
		$r = &{$Comps[$c]}($tbl1[$i]->[$TABLES[0]->[$c]->[0]], $tbl2[$j]->[$TABLES[1]->[$c]->[0]]);
		if ( $r != 0 ) { last; }
	}
	return $r;
}

sub copyCompResult {
	my ( $i, $j ) = @_;
	my ( $c, $l );
	while ( $tbl1[0]->[$c] ne '' ) {
		$dest[$dstCount]->[$l] = $tbl1[$i]->[$c];
		$c++;
		$l++;
	}
	$c = 0;
	while ( $tbl2[0]->[$c] ne '' ) {
		$dest[$dstCount]->[$l] = $tbl2[$j]->[$c];
		$c++;
		$l++;
	}
	$dstCount++;
}

sub Comp_c { return $_[0] cmp $_[1]; }
sub Comp_n { return $_[0] <=> $_[1]; }

sub seOpen {
	local( $DBNAME, $DBFILE );
	my( $c, $rec );

	$DBNAME = $DbList[$TABLE];
	$DBFILE = $DbFile[$TABLE];
	pop(@DbList);
	pop(@DbFile);

	if ( $CONNECTER == 1 ) {
		$r = DBOpen($DBNAME, $DBFILE, $VALUES[0], $VALUES[1]);
		if ( $r != 0 ) { return $r; }
	} else {
		$URL = $Listener;
		$URL =~ s/[\x00-\x20]/'%'.unpack("H2", $1)/ego;
		$URL .= "?mode=read&pass=".EncodeURL($Password)."&file=".EncodeURL($OuterFile);
		$URL .= "&compress=on" if $Compressable;

		while ( 1 ) { if ( !(-e "SE.LOCK") ) { last; } }
		open(LOCK,">SE.LOCK");
		close(LOCK);
		@r = GetOuterFile( $URL, $TimeOut, $OuterFile );
		unlink("SE.LOCK");
		if ( $r[0] != 0 ) { return $r[0]; }

		$DBFILE = $r[1];
		$r = DBOpen($DBNAME, $DBFILE, $VALUES[0], $VALUES[1]);
		if ( $r != 0 ) { return $r; }

		$Listeners[$TABLE] = $Listener;
		$OuterFiles[$TABLE] = $OuterFile;
		$Passwords[$TABLE] = $Password;
		$TimeOut[$TABLE] = $TimeOut;
		$OuterSQL[$TABLE] = "OPEN $DBNAME FILE '$OuterFile' FOR UPDATE;";

	}

	$c = 0;
	while ( $DB[$TABLE]->[0]->[$c] ne '' ) {
		if ( $DB[$TABLE]->[0]->[$c] eq $IndexColumn ) { $IndexColumn = $c; last; }
		$c++;
	}
	if ( $DB[$TABLE]->[0]->[$c] eq '' ) { $IndexColumn = -1; }

	$IndexList[$TABLE]->[0] = $IndexColumn;
	if ( $IndexColumn != -1 ){
		for ( $rec = 1; $rec < $DbLineCount[$TABLE]; $rec++ ) {
			$IndexList[$TABLE]->[1]->{$DB[$TABLE]->[$rec]->[$IndexColumn]} = $rec;
		}
	}

	return 0;

}

sub seRelate {
	my( $VIEW );

	# check file exists
	if ( -e $InnerFile ) { return 32; }

	$DbFile[$TABLE] = $InnerFile;

	return 0;

}

sub seDesc {
	my ( $l, $m, $ilen, $mlen );

	# initialize
	$ExecuteResult[$CURSOR] = undef;

	# create DESC cursor
	if ( $TABLE == 0 ) {
		$ExecuteResult[$CURSOR]->[1]->[0] = @DbList - 1;
		for ( $l = 1; $l < @DbList; $l++ ) {
			$ExecuteResult[$CURSOR]->[0]->[$l-1] =
			$ExecuteResult[$CURSOR]->[2]->[$l-1] = $DbList[$l];
			$ExecuteResult[$CURSOR]->[3]->[$l-1] = $DbLineCount[$l] - 1;
		}
	} else {
		@n = @{$DB[$TABLE]->[0]};
		for ( $i = 0; $i < @n; $i++ ) {
			$ExecuteResult[$CURSOR]->[0]->[$i] =
			$ExecuteResult[$CURSOR]->[2]->[$i] = $n[$i];
		}
		$ExecuteResult[$CURSOR]->[1]->[0] = @n;
		for ( $l = 0; $l < @n; $l++ ) {
			$ExecuteResult[$CURSOR]->[3]->[$l] = 0;
			for ( $m = 1; $m < $DbLineCount[$TABLE]; $m++ ) {
				if ( length($DB[$TABLE]->[$m]->[$l]) > $ExecuteResult[$CURSOR]->[3]->[$l] ) {
					$ExecuteResult[$CURSOR]->[3]->[$l] = length($DB[$TABLE]->[$m]->[$l]);
				}
			}
		}
	}

	$NewestCursor = $CURSOR;
	$RecordCount = 3;
	$RecordCount[$NewestCursor] = 3;
	$CurPos[$CURSOR] = 1;

	if ( $inlinemode != 0 && $NestLevel == 0 ) {
		if ( $TABLE == 0 ) {
			print "Number of opened tables: $ExecuteResult[$CURSOR]->[1]->[0]\n";
		} else {
			print "Table $DbList[$TABLE] has $ExecuteResult[$CURSOR]->[1]->[0] record(s)\n";
		}
		$mlen = 0;
		@n = @{$ExecuteResult[$CURSOR]->[0]};
		for ( $l = 0; $l < @n; $l++ ) {
			$clen = length($ExecuteResult[$CURSOR]->[2]->[$l]);
			if ( $mlen < $clen ) { $mlen = $clen; }
		}
		for ( $l = 0; $l < @n; $l++ ) {
			$ilen = " "x($mlen-length($ExecuteResult[$CURSOR]->[2]->[$l]));
			print "\t$ExecuteResult[$CURSOR]->[2]->[$l]$ilen ($ExecuteResult[$CURSOR]->[3]->[$l])\n";
		}
		print "\n";
	}

	return 0;

}

sub seLock {
	my( $flockmode );

	# Check already locked
	if ( $LockedDb != 0 ) { return 26; }

	if ( $VALUES[0] == 1 ) {
		$flockmode = 6;
	} else {
		$flockmode = 2;
	}

	if ( $DbFile[$TABLE] eq '' ) { return 67; }
	if ( open(LOCK, "$DbFile[$TABLE]") == undef ) { return 7; }
	eval { flock(LOCK, $flockmode); };

	$LockedDb = $TABLE;

	return 0;

}

sub seUnlock {

	if ( $LockedDb != 0 ) {
		eval { flock(LOCK, 8); };
		close(LOCK);
	}

	$LockedDb = 0;
	return 0;

}

sub seCommit {
	my( $i, $r, $l, $c, $start, $end, $XML, $OXML, $WXML, @OSQL, $IXML, $BXML, $CURSOR );

	$buffringmode = $|;
	$| = 1;

	while ( 1 ) { if ( !(-e "SE.COMMIT.LOCK") ) { last; } }
	open(LOCK,">SE.COMMIT.LOCK");
	close(LOCK);
	seUnlock();

	for ( $l = 1; $l < @DbList; $l++ ) {
		if ( $TABLE > 0 ) {
			if ( $l != $TABLE ) { next; }
			if ( $DbFile[$l] eq '' ) {
				$| = $buffringmode;
				unlink("SE.COMMIT.LOCK");
				return 65;
			}
		} else {
			if ( $DbFile[$l] eq '' ) { next; }
		}

		if ( $XML[$l] eq '' ) {
			#CSV
			if ( $Carefully[$l] > 0 ) {
				$r = open(OUT, ">>$DbFile[$l]");
			} else {
				$r = open(OUT, ">$DbFile[$l]");
			}
			eval { flock(OUT, 2); };
			if ( $r == undef ) {
				$| = $buffringmode;
				unlink("SE.COMMIT.LOCK");
				return 7;
			}

			$c = $Carefully[$l];
			if ( $NoColumns[$l] == 1 && $c == 0 ) { $c++; }
			for ( $i = $c; $i < $DbLineCount[$l]; $i++ ) {
				@n = @{$DB[$l]->[$i]};
				$WriteLine = "";
				foreach ( @n ) {
					$b = $_;
					$b =~ s/(\\|\n|\t|"|')/$Conv_CON2ESC{$&}/g;
					$item = "\"$b\"$Separater";
					$WriteLine .= $item;
				}
				$WriteLine =~ s/$Separater$/\n/;
				print OUT $WriteLine;
			}
			$Carefully[$l] = 0;

			close(OUT);
		} else {
			# sort before save
			$NestLevel++;
			Execute("SELECT * FROM $DbList[$l] ORDER BY ID CURSOR XMLSAVEQUERY");
			$NestLevel--;
			$CURSOR = $Cursors{XMLSAVEQUERY};

			#XML
			open(IN, "<$DbFile[$l]");
			$XML = $OXML = '';
			foreach ( <IN> ) { $XML .= $_; $OXML .= $_; }
			close(IN);

			if ( $ExecuteResult[$CURSOR]->[1]->[0] != 0 ) {
				$| = $buffringmode;
				unlink("SE.COMMIT.LOCK");
				return 81;
			}
			$XML =~ s/<.*>/lc($&)/eig;
			if ( ($start = index($XML, '<channel')) == -1 || ($end = index($XML, '</channel>')) == -1 ) {
				$| = $buffringmode;
				unlink("SE.COMMIT.LOCK");
				return 79;
			}
			if ( $start > $end ) {
				$| = $buffringmode;
				unlink("SE.COMMIT.LOCK");
				return 79;
			}
			$WXML = substr($OXML, 0, $start);
			$channel = substr($OXML, $start, $end - $start + 10);
			$XML = substr($XML, $end + 10);
			$OXML = substr($OXML, $end + 10);
			$WXML .= putChannelToXML( $channel, $l );

			if ( ($start = index($XML, '<image')) != -1 && ($end = index($XML, '</image>')) != -1 ) {
				if ( $start < $end ) {
					$WXML .= "\n  " . substr($OXML, $start, $end - $start + 8);
				}
			}

			if ( ($start = index($XML, '<item')) != -1 && ($end = index($XML, '</item>')) != -1 ) {
				if ( $start < $end ) {
					$BXML = substr($OXML, $start, $end - $start + 7);
				}
			}
			if ( $BXML eq '' ) {
				if ( ($start = index($DefaultXML, '<item ')) != -1 && ($end = index($DefaultXML, '</item>')) != -1 ) {
					$BXML = substr($DefaultXML, $start, $end - $start + 7);
				}
			}
			for ( $i = 2; $i <= $RecordCount[$CURSOR]; $i++ ) {
				$IXML = $BXML;
				if ( $ExecuteResult[$CURSOR]->[$i]->[6] =~ /\D/ ) {
					$time = $ExecuteResult[$CURSOR]->[$i]->[6];
				} else {
					@time = localtime($ExecuteResult[$CURSOR]->[$i]->[6]);
					@lt = localtime(time); @gt = gmtime(time);
					if ( $lt[2] < $gt[2] ) { $lt[2] += 24; }
					$diff = $lt[2] - $gt[2];
					$time = sprintf("%04d-%02d-%02dT%02d:%02d:%02d+%02d:00", $time[5]+1900, $time[4]+1, $time[3], $time[2], $time[1], $time[0], $diff);
				}
				foreach ( @n ) { s/</&lt;/g; s/>/&gt;/g; }
				$IXML =~ s/(<item\s*rdf:about\s*=\s*['"]?)([^'"]*)(['"]?\s*>)/$1$ExecuteResult[$CURSOR]->[$i]->[1]$3/i;
				$IXML = putItemToXML( $IXML, 'title', $ExecuteResult[$CURSOR]->[$i]->[2] );
				$IXML = putItemToXML( $IXML, 'link', $ExecuteResult[$CURSOR]->[$i]->[3] );
				$IXML = putItemToXML( $IXML, 'description', $ExecuteResult[$CURSOR]->[$i]->[4] );
				$IXML = putItemToXML( $IXML, 'dc:subject', $ExecuteResult[$CURSOR]->[$i]->[5] );
				$IXML = putItemToXML( $IXML, 'dc:date', $time );
				$IXML = putItemToXML( $IXML, 'dc:type', $ExecuteResult[$CURSOR]->[$i]->[7] );
				$IXML = putItemToXML( $IXML, 'dc:format', $ExecuteResult[$CURSOR]->[$i]->[8] );
				$IXML = putItemToXML( $IXML, 'dc:identifier', $ExecuteResult[$CURSOR]->[$i]->[9] );
				$IXML = putItemToXML( $IXML, 'dc:source', $ExecuteResult[$CURSOR]->[$i]->[10] );
				$IXML = putItemToXML( $IXML, 'dc:relation', $ExecuteResult[$CURSOR]->[$i]->[11] );
				$IXML = putItemToXML( $IXML, 'dc:coverage', $ExecuteResult[$CURSOR]->[$i]->[12] );
				$IXML = putItemToXML( $IXML, 'dc:rights', $ExecuteResult[$CURSOR]->[$i]->[13] );
				$WXML .= "\n\n $IXML";
			}

			if ( ($end = rindex($OXML, '</item>')) != -1 ) { $WXML .= substr($OXML, $end + 7); }
			elsif ( ($end = rindex($DefaultXML, '</item>')) != -1 ) { $WXML .= substr($DefaultXML, $end + 7); }
			open(OUT, ">$DbFile[$l]");
			print OUT $WXML;
			close(OUT);

		}

		if ( $Listeners[$l] ne '' && $OuterSQL[$l] ne '') {
			# when open by outer server
			$URL = $Listener;
			$URL =~ s/[\x00-\x20]/'%'.unpack("H2", $1)/ego;
			$URL .= "?mode=write&pass=".EncodeURL($Passwords[$l])."&file=".EncodeURL($OuterFiles[$l])."&SQL=".EncodeURL($OuterSQL[$l]);
			$URL .= "COMMIT;";
			$OuterSQL[$l] = "OPEN $DbList[$l] FILE '$OuterFiles[$l]' FOR UPDATE;";

			$r = UpdateOuterFile( $URL, $TimeOut[$l] );
			if ( $r != 0 ) {
				unlink("SE.COMMIT.LOCK");
				return $r;
			}
		}

	}

	unlink("SE.COMMIT.LOCK");
	$| = $buffringmode;
	return 0;

}

sub seRollback {
	my( $i, $l, $start, $end, $XML, $OXML );

	seUnlock();

	for ( $l = 1; $l < @DbList; $l++ ) {
		if ( $TABLE > 0 ) {
			if ( $l != $TABLE ) { next; }
			if ( $DbFile[$l] eq '' ) { return 66; }
		} else {
			if ( $DbFile[$l] eq '' ) { next; }
		}

		seUnlock();
		if ( open(IN, "<$DbFile[$l]") == undef ) { return 7; }
		eval { flock(IN, 1); };

		if ( $NoColumns[$l] == 1 ) { @COLUMNS = @{$DB[$l]->[0]}; }

		$DB[$l] = undef;
		$DbLineCount[$l] = 0;

		@fDB = <IN>;
		close(IN);

		if ( $XML[$l] eq '' ) {
			# CSV
			xchomp(@fDB);

			$rec = 0;
			if ( $NoColumns[$l] == 1 ) { @{$DB[$l]->[$rec++]} = @COLUMNS; }
			foreach ( @fDB ) {
				@tDB = xsplit4load($Separater,$_);
				@{$DB[$l]->[$rec++]} = @tDB;
			}
			$DbLineCount[$l] = $rec;
			$Carefully[$l] = 0;
		} else {
			# XML

			@{$DB[$l]->[0]} = ( 'ID', 'ABOUT', 'TITLE', 'LINK', 'DESCRIPTION', 'SUBJECT', 'DATE', 'TYPE', 'FORMAT', 'IDENTIFIER', 'SOURCE', 'RELATION', 'COVERAGE', 'RIGHTS' );
			$rec = 1;
			$XML = join('', @fDB); $OXML = $XML;
			$XML =~ s/<.*>/lc($&)/eig;
 			if ( ($start = index($XML, '<channel')) == -1 || ($end = index($XML, '</channel>')) == -1 ) { return 79; }
			@tDB = getItemFromTag(substr($OXML, $start, $end - $start));
			@{$DB[$l]->[$rec++]} = (0, @tDB);
			$XML = substr($XML, 0, $start) . substr($XML, $end + 10);
			$OXML = substr($OXML, 0, $start) . substr($OXML, $end + 10);

			while ( ($start = index($XML, '<item')) != -1 && ($end = index($XML, '</item>')) != -1 ) {
				@tDB = getItemFromTag(substr($OXML, $start, $end - $start));
				@{$DB[$l]->[$rec++]} = (1, @tDB);
				$XML = substr($XML, 0, $start) . substr($XML, $end + 7);
				$OXML = substr($OXML, 0, $start) . substr($OXML, $end + 7);
			}
			$DbLineCount[$l] = $rec;
			$Carefully[$l] = 0;
		}

		if ( $Listeners[$l] ne '' && $OuterSQL[$l] ne '') {
			# when open by outer server
			$OuterSQL[$l] = "OPEN $DbList[$l] FILE '$OuterFiles[$l]' FOR UPDATE;";
		}
	}

	return 0;

}

sub Search {
	local( $rec, @stack, @result, $i, $value, $AndOnly, $OrOnly, @tmp, $a );
	local( @STABLE, $TableCnt );
	$SearchError = 0;

	if ( $COMMAND eq 'select' ) {
		@{STABLE} = @{$TABLE};
		$TableCnt = $TableLineCnt;
	} else {
		@{STABLE} = @{$DB[$TABLE]};
		$TableCnt = $DbLineCount[$TABLE];
	}
	if ( @WHERES == 0 ) {
		for ( $i = 0; $i < $TableCnt - 1; $i++ ) { $result[$i] = 1; }
		return @result;
	}

	# Check expression how include "OR" and "NOT"
	$AndOnly = 1;
	$OrOnly = 1;
	foreach $Formula ( @WHERES ) {
		if ( $Formula->[0] == 2 || $Formula->[0] == 3 ) { $AndOnly = 0; }
		if ( $Formula->[0] == 1 || $Formula->[0] == 3 ) { $OrOnly = 0; }
	}
	if ( !$AndOnly ) { @schRecs = (); }

	# start reverse Poland notation
	if ( @schRecs == 0 ) {
		# normal mode
		for ( $rec = 1; $rec < $TableCnt; $rec++ ) {
			$SearchError = SearchBody();
#			if ( $SearchError != 0 ) { last; }
		}
	} else {
		# index fast mode
		if ( $NeedSearch ) {
			foreach $rec ( @schRecs ) {
				$SearchError = SearchBody();
#				if ( $SearchError != 0 ) { last; }
			}
		}
	}

#	$SearchError = 0;
	return @result;

}

sub SearchBody {
	my ( $value, $rvalue );
	@stack = ();
	foreach $Formula ( @WHERES ) {
		if ( $Formula->[0] == 0 ) {
			# check
			if ( $Formula->[6] == 0 ) { $value = $STABLE[$rec]->[$Formula->[1]]; }
			elsif ( $Formula->[6] == 1 ) { $value = length($STABLE[$rec]->[$Formula->[1]]); }
			elsif ( $Formula->[6] == 2 ) { $value = graphic_uc($STABLE[$rec]->[$Formula->[1]]); }
			elsif ( $Formula->[6] == 3 ) { $value = graphic_lc($STABLE[$rec]->[$Formula->[1]]); }
			elsif ( $Formula->[6] == 4 ) { $value = rolling($STABLE[$rec]->[$Formula->[1]]); }
			elsif ( $Formula->[6] == 5 ) { $value = rolling2($STABLE[$rec]->[$Formula->[1]]); }
			elsif ( $Formula->[6] == 6 ) { $value = year($STABLE[$rec]->[$Formula->[1]]); }
			elsif ( $Formula->[6] == 7 ) { $value = month($STABLE[$rec]->[$Formula->[1]]); }
			elsif ( $Formula->[6] == 8 ) { $value = day($STABLE[$rec]->[$Formula->[1]]); }
			elsif ( $Formula->[6] == 9 ) { $value = hour($STABLE[$rec]->[$Formula->[1]]); }
			elsif ( $Formula->[6] == 10) { $value = minute($STABLE[$rec]->[$Formula->[1]]); }
			elsif ( $Formula->[6] == 11) { $value = second($STABLE[$rec]->[$Formula->[1]]); }
			elsif ( $Formula->[6] == 12) { $value = week($STABLE[$rec]->[$Formula->[1]]); }
			elsif ( $Formula->[6] == 13) { $value = wrolling($STABLE[$rec]->[$Formula->[1]]); }

			if ( $Formula->[7] != 0 ) {
				if ( $Formula->[7] == -1 ) { $rvalue = $STABLE[$rec]->[$Formula->[5]->[0]]; }
				elsif ( $Formula->[7] == 1 ) { $rvalue = length($STABLE[$rec]->[$Formula->[5]->[0]]); }
				elsif ( $Formula->[7] == 2 ) { $rvalue = graphic_uc($STABLE[$rec]->[$Formula->[5]->[0]]); }
				elsif ( $Formula->[7] == 3 ) { $rvalue = graphic_lc($STABLE[$rec]->[$Formula->[5]->[0]]); }
				elsif ( $Formula->[7] == 4 ) { $rvalue = rolling($STABLE[$rec]->[$Formula->[5]->[0]]); }
				elsif ( $Formula->[7] == 5 ) { $rvalue = rolling2($STABLE[$rec]->[$Formula->[5]->[0]]); }
				elsif ( $Formula->[7] == 6 ) { $rvalue = year($STABLE[$rec]->[$Formula->[5]->[0]]); }
				elsif ( $Formula->[7] == 7 ) { $rvalue = month($STABLE[$rec]->[$Formula->[5]->[0]]); }
				elsif ( $Formula->[7] == 8 ) { $rvalue = day($STABLE[$rec]->[$Formula->[5]->[0]]); }
				elsif ( $Formula->[7] == 9 ) { $rvalue = hour($STABLE[$rec]->[$Formula->[5]->[0]]); }
				elsif ( $Formula->[7] == 10) { $rvalue = minute($STABLE[$rec]->[$Formula->[5]->[0]]); }
				elsif ( $Formula->[7] == 11) { $rvalue = second($STABLE[$rec]->[$Formula->[5]->[0]]); }
				elsif ( $Formula->[7] == 12) { $rvalue = week($STABLE[$rec]->[$Formula->[5]->[0]]); }
				elsif ( $Formula->[7] == 13) { $rvalue = wrolling($STABLE[$rec]->[$Formula->[5]->[0]]); }
			} else {
				$rvalue = $Formula->[5]->[0];
			}

			if ( $Formula->[2] ne 'in' && $Formula->[4] != 1 ) { return 10; }
			if ( $Formula->[3] == 0 ) {
				# compare string
				if ( $Formula->[2] eq '=' ) {
					if ( $value eq $rvalue ) {
						push( @stack, 1 );
					} else {
						push( @stack, 0 );
					}
				} elsif ( $Formula->[2] eq '>' ) {
					if ( $value gt $rvalue ) {
						push( @stack, 1 );
					} else {
						push( @stack, 0 );
					}
				} elsif ( $Formula->[2] eq '<' ) {
					if ( $value lt $rvalue ) {
						push( @stack, 1 );
					} else {
						push( @stack, 0 );
					}
				} elsif ( $Formula->[2] eq '>=' || $Formula->[2] eq '=>' ) {
					if ( $value ge $rvalue ) {
						push( @stack, 1 );
					} else {
						push( @stack, 0 );
					}
				} elsif ( $Formula->[2] eq '<=' || $Formula->[2] eq '=<' ) {
					if ( $value le $rvalue ) {
						push( @stack, 1 );
					} else {
						push( @stack, 0 );
					}
				} elsif ( $Formula->[2] eq '<>' || $Formula->[2] eq '!=' ) {
					if ( $value ne $rvalue ) {
						push( @stack, 1 );
					} else {
						push( @stack, 0 );
					}
				} elsif ( $Formula->[2] eq 'like' ) {
					$des = $rvalue;
					if ( $CharCode == 0 ) {
						$src = sjis2euc($value);
						$des = sjis2euc($des);
					} else {
						$src = $value;
					}
					$des =~ s/[\?\.\^\$\[\]\*\+\|\(\)\\]/\\$&/g;
					$des =~ s/\?/./g;
					$des =~ s/%/.*/g;
					if ( $src =~ m/^$des$/s ) { push( @stack, 1 ); }
					else { push( @stack, 0 ); }
				} elsif ( $Formula->[2] eq 'match' ) {
					$des = $rvalue;
					if ( $CharCode == 0 ) {
						$src = sjis2euc($value);
						$des = sjis2euc($des);
					} else {
						$src = $value;
					}
					if ( $src =~ /$des/ ) { push( @stack, 1 ); }
					else { push( @stack, 0 ); }
				} elsif ( $Formula->[2] eq 'contain' ) {
					if ( ($r = xindex($value, $rvalue)) != -1 ) {
						push( @stack, 1 );
					} else {
						push( @stack, 0 );
					}
				} elsif ( $Formula->[2] eq 'in' ) {
					@tmp = ();
					for ( $i = 0; $i < $Formula->[4]; $i++ ) {
						$a = $Formula->[5]->[$i];
						if ( $a =~ s/^__SE_SYSTEM_ARRAY:// ) {
							@tmp = Str2Array($a);
							for ( $a = 0; $a < @tmp; $a++ ) {
								if ( $value eq $tmp[$a] ) {
									push( @stack, 1 );
									last;
								}
							}
							if ( $a < @tmp ) { last; }
						} else {
							if ( $value eq $a ) {
								push( @stack, 1 );
								last;
							}
						}
					}
					if ( $i == $Formula->[4] && @tmp == 0 ) {
						push( @stack, 0 );
					}
				} else {
					return 3;
				}
			} else {
				# compare number
				if ( $Formula->[2] eq '=' ) {
					if ( $value == $rvalue ) {
						push( @stack, 1 );
					} else {
						push( @stack, 0 );
					}
				} elsif ( $Formula->[2] eq '>' ) {
					if ( $value > $rvalue ) {
						push( @stack, 1 );
					} else {
						push( @stack, 0 );
					}
				} elsif ( $Formula->[2] eq '<' ) {
					if ( $value < $rvalue ) {
						push( @stack, 1 );
					} else {
						push( @stack, 0 );
					}
				} elsif ( $Formula->[2] eq '>=' || $Formula->[2] eq '=>' ) {
					if ( $value >= $rvalue ) {
						push( @stack, 1 );
					} else {
						push( @stack, 0 );
					}
				} elsif ( $Formula->[2] eq '<=' ||  $Formula->[2] eq '=<' ) {
					if ( $value <= $rvalue ) {
						push( @stack, 1 );
					} else {
						push( @stack, 0 );
					}
				} elsif ( $Formula->[2] eq '<>' || $Formula->[2] eq '!=' ) {
					if ( $value != $rvalue ) {
						push( @stack, 1 );
					} else {
						push( @stack, 0 );
					}
				} elsif ( $Formula->[2] eq 'contain' ) {
					if ( xindex($value, $rvalue) != -1 ) {
						push( @stack, 1 );
					} else {
						push( @stack, 0 );
					}
				} elsif ( $Formula->[2] eq 'in' ) {
					@tmp = ();
					for ( $i = 0; $i < $Formula->[4]; $i++ ) {
						if ( $Formula->[5]->[$i] =~ s/^__SE_SYSTEM_ARRAY:// ) {
							@tmp = Str2Array($Formula->[5]->[$i]);
							for ( $a = 0; $a < @tmp; $a++ ) {
								if ( $value == $tmp[$a] ) {
									push( @stack, 1 );
									last;
								}
							}
							if ( $a < @tmp ) { last; }
						} else {
							if ( $value == $Formula->[5]->[$i] ) {
								push( @stack, 1 );
								last;
							}
						}
					}
					if ( $i == $Formula->[4] && @tmp == 0 ) {
						push( @stack, 0 );
					}
				} else {
					return 3;
				}
			}
			if ( $AndOnly ) {
				if ( !$stack[@stack-1] ) {
					@stack = (0);
					last;
				}
			}
			if ( $OrOnly ) {
				if ( $stack[@stack-1] ) {
					@stack = (1);
					last;
				}
			}
		} elsif ( $Formula->[0] == 1 ) {
			# AND compare
			push( @stack, pop(@stack) & pop(@stack) );
		} elsif ( $Formula->[0] == 2 ) {
			# OR compare
			push( @stack, pop(@stack) | pop(@stack) );
		} elsif ( $Formula->[0] == 3 ) {
			# NOT
			push( @stack, (pop(@stack)==0) ? 1 : 0 );
		}
	}

	if ( @stack != 1 ) { return 10; }
	$result[$rec-1] = pop(@stack);
	return 0;
}

sub compile {
	local( @SQL ) = @_;
	my( $len, $i, $c, $l, $k, @tmp, $w, @STABLE, $cnt, @cReady );

	# initialize
	$COMMAND = '';
	@TABLES = ();
	$TABLE = '';
	$TableLineCnt = 0;
	$CURSOR = '';
	$TARGET = '';
	@COLUMNS = ();
	$ColNo = 0;
	@VALUES = ();
	@WHERES = ();
	@ORDERS = ();
	@GROUP = ();
	$INOUT = 0;
	$CONNECTER = 0;
	$pos = 0;
	$IndexColumn = -1;
	$IndexTable = -1;
	@schRecs = ();
	$NeedSearch = 1;
	$Distinct = 0;

	$MaxSent = @SQL;

	$COMMAND = lc($SQL[0]);
	if ( $COMMAND eq 'select' ) {
		$i = 1;
		if ( lc($SQL[$i]) eq 'distinct' ) { $Distinct = 1; $i++; }

		while ( $i < $MaxSent ) {
			if ( lc($SQL[$i]) eq 'from' ) {
				for ( $cnt = $i + 1; $cnt < $MaxSent; $cnt++ ) {
					if ( $SQL[$cnt] =~ /^(WHERE|ORDER|CURSOR|GROUP|TO)$/i ) { last; }
				}
				$i++;
				( $TABLE, $TableLineCnt, $i, $err ) = CreateJoinProgram($i, $cnt);
				@{STABLE} = @{$TABLE};
				%i2n = ();
				for ( $k = 0; $STABLE[0]->[$k] ne ''; $k++ ) {
					$i2n{$STABLE[0]->[$k]} = $k;
				}
				if ( $err != 0 ) { return $err; }
				last;
			}
			$i++;
		}
		$i = 1;
		while ( $i < $MaxSent ) {
			$lcSQL = lc($SQL[$i]);
			if ( $lcSQL eq 'to' ) {
				if ( $cReady[0]) { $i++; next; }
				$i++;
				$TARGET = FindTable($SQL[$i], 1);
				if ( $TARGET ne '' ) {
					if ( $DbFile[$TARGET] ne '' ) { return 22; }
				} else {
					$TARGET = @DbList;
					$DbList[$TARGET] = $SQL[$i];
				}
				$i = 1;
				$cReady[0] = 1;
			} elsif ( $lcSQL eq 'where' ) {
				if ( $cReady[1]) { $i++; next; }
				for ( $cnt = $i + 1; $cnt < $MaxSent; $cnt++ ) {
					if ( $SQL[$cnt] =~ /^(FROM|ORDER|CURSOR|GROUP|TO)$/i ) { last; }
				}
				$i++;
				$i = CreateSearchProgram($i, $cnt, @SQL);
				if ( $i < 0 ) { return $i * -1; }
				$i = 1;
				$cReady[1] = 1;
			} elsif( $lcSQL eq 'order' ) {
				if ( $cReady[2]) { $i++; next; }
				$i++;
				if ( lc($SQL[$i]) eq 'by' ) { $i++; }
				$OrderNo = 0;
				$OrderMode = 0;

				while ( !($SQL[$i] =~ /^(FROM|WHERE|CURSOR|GROUP|TO)$/i) ) {
					if ( $i >= $MaxSent ) { last; }
					if ( $SQL[$i] eq ',' ) {
						$OrderMode = 0;
						$i++;
						next;
					}
					if ( $OrderMode == 0 ) {
						$ORDERS[$OrderNo]->[0] = $SQL[$i];
						$OrderNo++;
						$OrderMode = 1;
					} else {
						$lcOP = lc($SQL[$i]);
						if ( $lcOP eq 'desc' ) {
							$ORDERS[$OrderNo-1]->[1] = 1;
						} else {
							if ( $ORDERS[$OrderNo-1]->[2] != 0 ) { return 11; }
							if ( $lcOP eq 'number' ) {
								$ORDERS[$OrderNo-1]->[2] = 1;
							} elsif ( $lcOP eq 'charactor' || $lcOP eq 'character' ) {
								$ORDERS[$OrderNo-1]->[2] = 2;
							} else {
								return 21;
							}
						}
					}
					$i++;
				}
				if ( $OrderNo == 0 ) { return 6; }

				$i = 1;
				$cReady[2] = 1;
			} elsif( $lcSQL eq 'group' ) {
				if ( $cReady[3]) { $i++; next; }
				$i++;
				if ( lc($SQL[$i]) eq 'by' ) { $i++; }
				$OrderNo = 0;

				while ( !($SQL[$i] =~ /^(FROM|WHERE|CURSOR|ORDER|TO)$/i) ) {
					if ( $i >= $MaxSent ) { last; }
					$GROUP[$OrderNo++]->[0] = $SQL[$i++];
					if ( lc($SQL[$i]) eq 'number' ) {
						$GROUP[$OrderNo-1]->[2] = 1;
						$i++;
					} elsif ( lc($SQL[$i]) eq 'charactor' || lc($SQL[$i]) eq 'character' ) {
						$GROUP[$OrderNo-1]->[2] = 2;
						$i++;
					} else {
						$GROUP[$OrderNo-1]->[2] = 2;
					}
					if ( $SQL[$i] eq ',' ) { $i++ }
				}
				if ( @GROUP == 0 ) { return 57; }

				$i = 1;
				$cReady[3] = 1;
			} elsif( $lcSQL eq 'cursor' ) {
				if ( $cReady[4]) { $i++; next; }
				$CURSOR = $SQL[$i+1];
				$i += 2;
				if ( $CURSOR eq '' ) { return 37; }
				$i = 1;
				$cReady[4] = 1;
			} else {
				$i++;
			}
		}
		if ( $TABLE eq '' ) { return 4; }
		if ( $CURSOR eq '' ) {
			if ( $NestLevel == 0 ) {
				$CURSOR = "DEFAULTCURSOR";
				if ( $Cursors{$CURSOR} == undef ) { $Cursors{$CURSOR} = $CursorCount++; }
				$CURSOR = $Cursors{$CURSOR};
			} else {
				$c = 1;
				$CURSOR = "SUBCUR_$c";
				while ( $Cursors{$CURSOR} != undef ) { $c++; $CURSOR = "_SE_SYS_SUBCUR_$c"; }
				$Cursors{$CURSOR} = $CursorCount++;
				$CURSOR = $Cursors{$CURSOR};
			}
		} else {
			if ( $Cursors{$CURSOR} == undef ) { $Cursors{$CURSOR} = $CursorCount++; }
			$CURSOR = $Cursors{$CURSOR};
		}

		$i = 1;
		if ( lc($SQL[$i]) eq 'distinct' ) { $i++; }
		while ( !($SQL[$i] =~ /^(FROM|WHERE|ORDER|CURSOR|TO)$/i) ) {
			if ( $i >= $MaxSent ) { last; }
			if ( $SQL[$i+1] eq '(' && $SQL[$i+3] eq ')' ) {
				$COLUMNS[$ColNo]->[1] = lc($SQL[$i]);
				if ( $COLUMNS[$ColNo]->[1] eq 'count' || $COLUMNS[$ColNo]->[1] eq 'avg' ||
				     $COLUMNS[$ColNo]->[1] eq 'max'   || $COLUMNS[$ColNo]->[1] eq 'min' ||
				     $COLUMNS[$ColNo]->[1] eq 'sum'   ||
				     $COLUMNS[$ColNo]->[1] eq 'grouping' || $COLUMNS[$ColNo]->[1] eq 'grouping2' ) {
					$COLUMNS[$ColNo]->[0] = 1;	# FUNCTION
				} elsif ( $COLUMNS[$ColNo]->[1] eq 'length'   ||
					  $COLUMNS[$ColNo]->[1] eq 'upper'    ||
					  $COLUMNS[$ColNo]->[1] eq 'lower'    ||
					  $COLUMNS[$ColNo]->[1] eq 'rolling'  ||
					  $COLUMNS[$ColNo]->[1] eq 'rolling2' ||
					  $COLUMNS[$ColNo]->[1] eq 'getyear'     ||
					  $COLUMNS[$ColNo]->[1] eq 'getmonth'    ||
					  $COLUMNS[$ColNo]->[1] eq 'getday'      ||
					  $COLUMNS[$ColNo]->[1] eq 'gethour'     ||
					  $COLUMNS[$ColNo]->[1] eq 'getminute'   ||
					  $COLUMNS[$ColNo]->[1] eq 'getsecond'   ||
					  $COLUMNS[$ColNo]->[1] eq 'getweek' ||
					  $COLUMNS[$ColNo]->[1] eq 'wordrolling' ) {
					$COLUMNS[$ColNo]->[0] = 2;	# FUNCTION
				} else {
					return 14;
				}
				if ( $COLUMNS[$ColNo]->[1] ne 'count' ) {
					$COLUMNS[$ColNo]->[2] = $i2n{$SQL[$i+2]};
					if ( $COLUMNS[$ColNo]->[2] eq '' ) { return 14; }
				} else {
					$COLUMNS[$ColNo]->[2] = $SQL[$i+2];
				}
				$i += 4;
				if ( lc($SQL[$i]) eq 'as' ) {
					$COLUMNS[$ColNo]->[3] = $SQL[++$i];
					$i++;
				}
				$ColNo++;
			} else {
				$COLUMNS[$ColNo]->[0] = 0;	# COLUMN
				if ( $SQL[$i] eq '*' ) {
					@{n} = @{$STABLE[0]};
					for( $c = 0; $c < @n; $c++ ) {
						$COLUMNS[$ColNo]->[0] = 0;
						$COLUMNS[$ColNo]->[1] = $c;
						$ColNo++;
					}
					if ( lc($SQL[$i+1]) eq 'as' ) { return 42; }
					$i++;
				} else {
					$COLUMNS[$ColNo]->[0] = 0;
					$COLUMNS[$ColNo]->[1] = $i2n{$SQL[$i]};
					if ( $COLUMNS[$ColNo]->[1] eq '' ) { return 14; }
					$i++;
					if ( lc($SQL[$i]) eq 'as' ) {
						$COLUMNS[$ColNo]->[3] = $SQL[++$i];
						$i++;
					}
					$ColNo++;
				}
			}
			if ( lc($SQL[$i]) eq 'as' ) {
				if ( $SQL[$i-1] eq '*' ) { return 42; }
				$COLUMNS[$ColNo-1]->[3] = $SQL[++$i];
				$i++;
			}

			if ( $SQL[$i] ne ',' && !($SQL[$i] =~ /^(FROM|WHERE|ORDER|CURSOR|TO)$/i) ) { return 14; }
			if ( $SQL[$i] eq ',' ) { $i++; }
		}
		if ( $ColNo == 0 ) { return 5; }
		if ( $i == $MaxSent ) { return 4; }

	} elsif ( $COMMAND eq 'update' ) {
		$TABLE = FindTable($SQL[1]);
		if ( $TABLE eq '' ) { return 1; }

		$i = 2;
		while ( $i < $MaxSent ) {
			$lcSQL = lc($SQL[$i]);
			if ( $lcSQL eq 'where' ) {
				if ( $cReady[0]) { $i++; next; }
				for ( $cnt = $i + 1; $cnt < $MaxSent; $cnt++ ) {
					if ( lc($SQL[$cnt]) eq 'set' ) { last; }
				}
				$i++;
				$i = CreateSearchProgram($i, $cnt, @SQL);
				if ( $i < 0 ) { return $i * -1; }
				$i = 1;
				$cReady[0] = 1;
			} elsif( $lcSQL eq 'set' ) {
				if ( $cReady[1]) { $i++; next; }
				$i++;
				$ColNo = 0;

				while ( lc($SQL[$i]) ne 'where' ) {
					if ( $i >= $MaxSent ) { last; }

					$COLUMNS[$ColNo]->[0] = $i2n{$SQL[$i++]};
					if ( $COLUMNS[$ColNo]->[0] eq '' ) { return 24; }

					if ( $SQL[$i] ne '=' ) { return 23; }

					$COLUMNS[$ColNo]->[1] = $SQL[++$i];
					if ( $COLUMNS[$ColNo]->[1] =~ /^['"]/ ) {
						$COLUMNS[$ColNo]->[1] =~ s/^['"]//;
						$COLUMNS[$ColNo]->[1] =~ s/['"]$//;
					} else {
						if ( !($COLUMNS[$ColNo]->[1] =~ /^[\-\.0-9]+$/) ) {
							if ( lc($COLUMNS[$ColNo]->[1]) eq 'systime' ) { $COLUMNS[$ColNo]->[1] = time; }
							elsif ( $COLUMNS[$ColNo]->[1] =~ /^__ResultSet\((\d+)\)$/ ) {
								@tmp = getResultByArray($1, 0, 'V');
								if ( @tmp <= 1 ) {
									$COLUMNS[$ColNo]->[1] = $tmp[0];
								} else {
									$COLUMNS[$ColNo]->[1] = "__SE_SYSTEM_ARRAY:" . Array2Str(@tmp);
								}
							} else { return 23; }
						}
					}
					$ColNo++;

					if ( $SQL[++$i] eq ',' ) { $i++; }
				}
				if ( $ColNo == 0 ) { return 44; }
				$i = 1;
				$cReady[1] = 1;
			} else {
				$i++;
			}
		}
		if ( $TABLE eq '' ) { return 1; }
		$Carefully[$TABLE] = 0;

	} elsif ( $COMMAND eq 'insert' ) {
		$i = 1;
		if ( lc($SQL[$i]) eq 'into' ) { $i++; }

		$TABLE = FindTable($SQL[$i]);
		if ( $TABLE eq '' ) { return 1; }

		$i++;
		$ColNo = 0;
		while ( lc($SQL[$i]) ne 'values' && !($SQL[$i] =~ /^__ResultSet\((\d+)\)$/) ) {
			if ( $i >= $MaxSent ) { last; }
			if ( $SQL[$i] eq ')' ) { $i++; last; }

			if ( $SQL[$i] eq '(' || $SQL[$i] eq ',' ) { $i++; next; }
			elsif ( $SQL[$i] eq '*' ) {
				@n = @{$DB[$TABLE]->[0]};
				for( $c = 0; $c < @n; $c++ ) {
					$COLUMNS[$ColNo]->[0] = $c;
					$ColNo++;
				}
			} else {
				$COLUMNS[$ColNo]->[0] = $i2n{$SQL[$i]};
				if ( $COLUMNS[$ColNo]->[0] eq '' ) { return 21; }
				$ColNo++;
			}
			$i++;
		}
		if ( $ColNo == 0 ) { 
			@n = @{$DB[$TABLE]->[0]};
			for( $c = 0; $c < @n; $c++ ) {
				$COLUMNS[$ColNo]->[0] = $c;
				$ColNo++;
			}
		}

		$OldColNo = $ColNo;
		$ColNo = 0;
		if ( $SQL[$i] =~ /^__ResultSet\((\d+)\)$/ ) {
			$ColNo = getResultByArray($1, 0, 'H');
			$COLUMNS[0]->[1] = 2;
			$COLUMNS[0]->[2] = $1;
		} else {
			$i++;
			while ( lc($SQL[$i]) ne 'carefully' ) {
				if ( $i >= $MaxSent ) { last; }
				if ( $SQL[$i] eq ')' ) { $i++; last; }

				if ( $SQL[$i] eq '(' || $SQL[$i] eq ',' ) { $i++; next; }

				$COLUMNS[$ColNo]->[2] = $SQL[$i];
				if ( $COLUMNS[$ColNo]->[2] =~ /^['"]/ ) {
					$COLUMNS[$ColNo]->[1] = 0; # Value
					$COLUMNS[$ColNo]->[2] =~ s/^['"]//;
					$COLUMNS[$ColNo]->[2] =~ s/['"]$//;
				} else {
					if ( !($COLUMNS[$ColNo]->[2] =~ /^[\-\.0-9]+$/) ) {
						$COLUMNS[$ColNo]->[1] = 1; # system algebra
					} else {
						$COLUMNS[$ColNo]->[1] = 0;
					}
				}
				$ColNo++;
				$i++;
			}
		}
		if ( $OldColNo != $ColNo ) { return 45; }

		$care = 0;
		if ( lc($SQL[$i]) eq 'carefully' ) {
			if ( $XML[$TABLE] ne '' ) { return 80; }
			$care = 1;
		}
		if ( $care == 0 ) { $Carefully[$TABLE] = 0; }
		if ( $care == 1 && $Carefully[$TABLE] == 0 ) {
			$Carefully[$TABLE] = $DbLineCount[$TABLE];
		}

	} elsif ( $COMMAND eq 'delete' ) {
		$i = 1;
		if ( lc($SQL[$i]) eq 'from' ) { $i++; }

		$TABLE = FindTable($SQL[$i]);
		if ( $TABLE eq '' ) { return 1; }

		while ( $i < $MaxSent ) {
			if ( lc($SQL[$i]) eq 'where' ) {
				$i = CreateSearchProgram(++$i, $MaxSent, @SQL);
				if ( $i < 0 ) { return $i * -1; }
			} else {
				$i++;
			}
		}
		$Carefully[$TABLE] = 0;

	} elsif ( $COMMAND eq 'add' ) {
		$i = 1;
		if ( lc($SQL[$i]) eq 'column' ) { $i++; }

		$c = $SQL[$i++];
		if ( lc($SQL[$i++]) ne 'to' ) { return 40; }

		$TABLE = FindTable($SQL[$i]);
		if ( $TABLE eq '' ) { return 1; }

		$COLUMNS[0] = $i2n{$c};
		if ( $COLUMNS[0] ne '' ) { return 41; }
		$COLUMNS[0] = $c;

	} elsif ( $COMMAND eq 'create' ) {
		$i = 1;

		$TARGET = lc($SQL[$i++]);
		if ( $TARGET eq 'view' ) {
			$j = $i;
			while ( $j < $MaxSent ) { if ( lc($SQL[$j++]) eq 'from' ) { last; } }
			if ( $j == $MaxSent ) { $TARGET = 'table'; }
		}

		if ( $TARGET eq 'table' ) {

			$TABLE = FindTable($SQL[$i]);
			if ( $TABLE ne '' ) { return 22; }
			$TABLE = @DbList;
			$DbList[$TABLE] = $SQL[$i];

			$i++;
			$ColNo = 0;
			while ( lc($SQL[$i]) ne 'file' ) {
				if ( $i >= $MaxSent ) { last; }
				if ( $SQL[$i] eq ')' ) { $i++; last; }

				if ( $SQL[$i] eq '(' || $SQL[$i] eq ',' ) { $i++; next; }
				else {
					$COLUMNS[$ColNo] = $SQL[$i];
					if ( lc($SQL[$i+1]) eq 'index' ) { $IndexColumn = $ColNo; $i++; }
					$ColNo++;
				}
				$i++;
			}
			if ( $ColNo == 0 ) {
				pop(@DbList);
				return 38;
			}

			if ( $i < $MaxSent ) {
				$i++;
				$DbFile[$TABLE] = $SQL[$i];
				if ( $DbFile[$TABLE] eq '' ) {
					pop(@DbList);
					return 30;
				}
				if ( $DbFile[$TABLE] =~ /^['"]/ ) {
					$DbFile[$TABLE] =~ s/^['"]//;
					$DbFile[$TABLE] =~ s/['"]$//;
				}
			}
		} elsif ( $TARGET eq 'view' ) {

			$TABLE = FindTable($SQL[$i], 1);
			if ( $TABLE ne '' ) {
				if ( $DbFile[$TABLE] ne '' ) { return 22; }
			} else {
				$TABLE = @DbList;
				$DbList[$TABLE] = $SQL[$i];
			}
			$i++;

			if ( lc($SQL[$i++]) ne 'from' ) { return 4; }

			for ( $c = 0; $c < 2; $c++ ) {
				$TABLES[$c]->[0] = FindTable($SQL[$i]);
				if ( $TABLES[$c]->[0] eq '' ) { pop(@DbList); return 1; }
				$i++;

				$ColNo[$c] = 0;
				$ColMode = 0;
				while ( lc($SQL[$i]) ne 'and' ) {
					if ( $i >= $MaxSent ) { last; }
					if ( $SQL[$i] eq ')' ) { $i++; last; }
					if ( $SQL[$i] eq '(' ) { $i++; next; }

					if ( $SQL[$i] eq ',' ) {
						$ColMode = 0;
						$i++;
						next;
					}
					if ( $ColMode == 0 ) {
						$ColNo[$c]++;
						$TABLES[$c]->[$ColNo[$c]]->[0] = $i2n{$SQL[$i++]};
						if ( $TABLES[$c]->[$ColNo[$c]]->[0] eq '' ) { pop(@DbList); return 21; }
						$TABLES[$c]->[$ColNo[$c]]->[1] = 0;
						$ColMode = 1;
					} else {
						$lcOP = lc($SQL[$i++]);
						if ( $c == 1 ) { pop(@DbList); return 64; }
						if ( $TABLES[$c]->[$ColNo[0]]->[2] != 0 ) { pop(@DbList); return 11; }
						if ( $lcOP eq 'number' ) {
							$TABLES[0]->[$ColNo[0]]->[2] =
							$TABLES[1]->[$ColNo[0]]->[2] = 1;
						} elsif ( $lcOP eq 'charactor' || $lcOP eq 'character' ) {
							$TABLES[0]->[$ColNo[0]]->[2] =
							$TABLES[1]->[$ColNo[0]]->[2] = 2;
						} else {
							pop(@DbList);
							return 21;
						}
					}
				}

				if ( $ColNo[$c] == 0 ) { pop(@DbList); return 62; }
				if ( $c == 0 && lc($SQL[$i]) ne 'and' ) { pop(@DbList); return 60; }
				if ( $c == 1 && lc($SQL[$i]) eq 'and' ) { pop(@DbList); return 61; }
				$i++;
			}
			if ( $ColNo[0] != $ColNo[1] ) { pop(@DbList); return 62; }

			if ( lc($SQL[$i-1]) eq 'outer' ) { $INOUT = 2; }

		} else {
			return 28;
		}

	} elsif ( $COMMAND eq 'open' ) {
		$i = 1;

		$TimeOut = 15;
		if ( lc($SQL[$i]) eq 'table' ) { $i++ }

		$TABLE = FindTable($SQL[$i], 1);
		if ( $TABLE ne '' ) { return 22; }
		$TABLE = @DbList;
		$DbList[$TABLE] = $SQL[$i];
		$NoColumns[$TABLE] = 0;
		if ( $SQL[$i+1] eq '(' ) {
			$i += 2;
			while ( $i < $MaxSent ) {
				if ( $SQL[$i] eq ')' ) { last; }
				if ( $SQL[$i] eq ',' ) { $i++; next; }
				push( @COLUMNS, $SQL[$i] );
				$i++;
			}
		}

		# seach FILE sentence first
		$i++;
		while ( $i < $MaxSent ) {
			if ( lc($SQL[$i++]) eq 'file' ) {
				$DbFile[$TABLE] = $SQL[$i];
				if ( $DbFile[$TABLE] eq '' ) {
					pop(@DbList);
					return 30;
				}
				if ( $DbFile[$TABLE] =~ /^['"]/ ) {
					$DbFile[$TABLE] =~ s/^['"]//;
					$DbFile[$TABLE] =~ s/['"]$//;
				}
				if ( lc($SQL[++$i]) eq 'nocolumns' ) {
					$NoColumns[$TABLE] = 1;
				}
				$CONNECTER = 1;
				last;
			}
		}

		$i = 1;
		while ( $i < $MaxSent ) {
			$lcSQL = lc($SQL[$i]);
			if ( $lcSQL eq 'outer' ) {
				$i++;
				if ( lc($SQL[$i]) eq 'connect' ) { $i++; }
				if ( lc($SQL[$i]) eq 'to' ) { $i++; }
				$Listener = $SQL[$i];
				if ( $Listener =~ /^['"]/ ) {
					$Listener =~ s/^['"]//;
					$Listener =~ s/['"]$//;
				}
				$i++;
				if ( $DbFile[$TABLE] eq '' ) {
					pop(@DbList);
					pop(@DbFile);
					return 29;
				} else {
					$OuterFile = $DbFile[$TABLE];
				}
				if ( !(-d "./se_sqlsys") ) {
					if ( -e "./se_sqlsys" || -l "./se_sqlsys" ) {
						pop(@DbList);
						pop(@DbFile);
						return 47;
					}
					mkdir( "./se_sqlsys", 777 );
				}
				$CONNECTER = 2;
			} elsif ( $lcSQL eq 'password' ) {
				$i++;
				$Password = $SQL[$i++];
				if ( $Password =~ /^['"]/ ) {
					$Password =~ s/^['"]//;
					$Password =~ s/['"]$//;
				}
			} elsif ( $lcSQL eq 'timeout' ) {
				$i++;
				$TimeOut = $SQL[$i++];
			} elsif ( $lcSQL eq 'for' ) {
				$i++;
				if ( lc($SQL[$i]) eq 'update' ) { $VALUES[0] = 1; }
				elsif ( lc($SQL[$i]) eq 'insert' ) { $VALUES[1] = 1; }
				else {
					pop(@DbList);
					pop(@DbFile);
					return 34;
				}
			} elsif ( $lcSQL eq 'index' ) {
				$i++;
				$IndexColumn = $SQL[$i++];
				if ( $SQL[$i] eq ',' ) { return 85; }
			} else {
				$i++;
			}
		}

		if ( $CONNECTER == 2 && $Password eq '' ) {
			pop(@DbList);
			pop(@DbFile);
			return 48;
		}

	} elsif ( $COMMAND eq 'relate' ) {
		$i = 1;

		$c = 0;
		$InnerFile = '';
		while ( $i < $MaxSent ) {
			$TARGET = lc($SQL[$i++]);
			if ( $TARGET eq 'file' ) {
				$InnerFile = $SQL[$i];
				$InnerFile =~ s/^['"]//;
				$InnerFile =~ s/['"]$//;
			} elsif ( $TARGET eq 'view' ) {
				$TABLE = FindTable($SQL[$i]);
				if ( $TABLE eq '' ) { return 1; }
				if ( $DbFile[$TABLE] ne '' ) { return 73; }
			}
			$i++;
			if ( $c == 0 ) {
				if ( lc($SQL[$i]) ne 'and' ) { return 74; }
				$c++;
			}
			$i++;
		}

	} elsif ( $COMMAND eq 'desc' ) {
		$i = 1;

		if ( lc($SQL[$i]) ne 'table' ) {
			$TABLE = FindTable($SQL[$i]);
			if ( $TABLE eq '' ) { return 1; }
		} else {
			$TABLE = 0;
		}

		$CURSOR = "DEFAULTCURSOR";
		if ( $Cursors{$CURSOR} == undef ) {
			$Cursors{$CURSOR} = $CursorCount++;
		}
		$CURSOR = $Cursors{$CURSOR};

	} elsif ( $COMMAND eq 'lock' ) {

		if ( $LockedDb != 0 ) { return 26; }

		$i = 1;
		if ( lc($SQL[$i++]) eq 'table' ) { $i++; }

		$TABLE = FindTable($SQL[$i]);
		if ( $TABLE eq '' ) { return 1; }

		if ( lc($SQL[++$i]) eq 'nowait' ) { $VALUES[0] = 1; }

	} elsif ( $COMMAND eq 'unlock' ) {
		
	} elsif ( $COMMAND eq 'commit' ) {
		$i = 1;
		if ( lc($SQL[$i]) eq 'table' ) { $i++ }
		if ( $SQL[$i] ne '' ) {
			$TABLE = FindTable($SQL[$i]);
			if ( $TABLE eq '' ) { return 1; }
		} else {
			$TABLE = 0;
		}
	} elsif ( $COMMAND eq 'rollback' ) {
		$i = 1;
		if ( lc($SQL[$i]) eq 'table' ) { $i++ }
		if ( $SQL[$i] ne '' ) {
			$TABLE = FindTable($SQL[$i]);
			if ( $TABLE eq '' ) { return 1; }
		} else {
			$TABLE = 0;
		}
	}

	return 0;

}

sub CreateSearchProgram {
	my( $start, $end, @OWHERE ) = @_;
	my( @opstack, $WhereMode, $CurForm, $op, $i, $idx, $tmp, $tmp2, @atmp, $c );
	$pos++;

	for ( $i = $start, $WhereMode = 0; $i < $end; $i++ ) {
		if ( $OWHERE[$i] =~ /^NOT$/i ) {
			push( @opstack, lc($OWHERE[$i]) );
		} elsif ( $OWHERE[$i] =~ /^(AND|OR)$/i ) {
			if ( $CurForm->[4] != 0 ) {
				push( @WHERES, $CurForm );
				$CurForm = undef;
			}
			while ( @opstack ) {
				$op = pop( @opstack );
				if ( $op eq 'and' ) {
					$CurForm->[0] = 1;
				} elsif ( $op eq 'or' ) {
					$CurForm->[0] = 2;
				} else {
					$CurForm->[0] = 3;
				}
				push( @WHERES, $CurForm );
				$CurForm = undef;
			}
			if ( $i <= $start || $i >= $end ) { return -9; }
			push( @opstack, lc($OWHERE[$i]) );
		} elsif ( $OWHERE[$i] eq '(' ) {
			$i++;
			$i = CreateSearchProgram( $i, $end, @OWHERE );
			if ( $i < 0 ) { return $i; }
			foreach ( @opstack ) {
				$op = pop( @opstack );
				if ( $op eq 'and' ) {
					$CurForm->[0] = 1;
				} elsif ( $op eq 'or' ) {
					$CurForm->[0] = 2;
				} else {
					$CurForm->[0] = 3;
				}
				push( @WHERES, $CurForm );
				$CurForm = undef;
			}
		} elsif ( $OWHERE[$i] eq ')' ) {
			last;
		} else {
			if ( $CurForm->[4] != 0 ) {
				push( @WHERES, $CurForm );
				$CurForm = undef;
			}
			$CurForm->[0] = 0;
			if ( $OWHERE[$i+1] eq '(' ) {
				# with function
				if ( $OWHERE[$i+3] ne ')' ) { return -27; }
				$lcFunc = lc($OWHERE[$i]);
				if ( $lcFunc eq 'length' ) {
					$CurForm->[6] = 1;
				} elsif ( $lcFunc eq 'upper' ) {
					$CurForm->[6] = 2;
				} elsif ( $lcFunc eq 'lower' ) {
					$CurForm->[6] = 3;
				} elsif ( $lcFunc eq 'rolling' ) {
					$CurForm->[6] = 4;
				} elsif ( $lcFunc eq 'rolling2' ) {
					$CurForm->[6] = 5;
				} elsif ( $lcFunc eq 'getyear' ) {
					$CurForm->[6] = 6;
				} elsif ( $lcFunc eq 'getmonth' ) {
					$CurForm->[6] = 7;
				} elsif ( $lcFunc eq 'getday' ) {
					$CurForm->[6] = 8;
				} elsif ( $lcFunc eq 'gethour' ) {
					$CurForm->[6] = 9;
				} elsif ( $lcFunc eq 'getminute' ) {
					$CurForm->[6] = 10;
				} elsif ( $lcFunc eq 'getsecond' ) {
					$CurForm->[6] = 11;
				} elsif ( $lcFunc eq 'getweek' ) {
					$CurForm->[6] = 12;
				} elsif ( $lcFunc eq 'wordrolling' ) {
					$CurForm->[6] = 13;
				} else {
					return -39;
				}
				$CurForm->[1] = $i2n{$OWHERE[$i+2]};
				$i += 4;
			} else {
				$CurForm->[6] = 0;
				$CurForm->[1] = $i2n{$OWHERE[$i]};
				$i++;
			}
			if ( $CurForm->[1] eq '' ) { return -76; }
			if ( ($lcOP = lc($OWHERE[$i])) eq 'not' ) { push( @opstack, $lcOP ); $i++; }
			$CurForm->[2] = lc($OWHERE[$i]);
			$i++;
			if ( $OWHERE[$i] eq '(' ) {
				# plural values
				$i++;
				$CurForm->[3] = 1; # compare means: number
				while ( $OWHERE[$i] ne ')' ) {
					if ( $i >= $end ) { return -9; }
					if ( $OWHERE[$i] ne ',' ) {
						if ( $OWHERE[$i+1] eq '(' ) {
							# with function
							if ( $OWHERE[$i+3] ne ')' ) { return -27; }
							$lcFunc = lc($OWHERE[$i]);
							$CurForm->[5]->[$CurForm->[4]] = $OWHERE[$i+2];
							$i += 3;
						} else {
							$lcFunc = '';
							$CurForm->[5]->[$CurForm->[4]] = $OWHERE[$i];
						}
						if ( $CurForm->[5]->[$CurForm->[4]] =~ /^['"]/ ) {
							$CurForm->[3] = 0; # compare means: string
							$CurForm->[5]->[$CurForm->[4]] =~ s/^['"]//;
							$CurForm->[5]->[$CurForm->[4]] =~ s/['"]$//;
						} elsif ( $CurForm->[5]->[$CurForm->[4]] =~ /^__ResultSet\((\d+)\)$/ ) {
							$CurForm->[3] = 0; # compare means: string
							$CurForm->[5]->[$CurForm->[4]] = "__SE_SYSTEM_ARRAY:" . Array2Str(getResultByArray($1, 0, 'V'));
						} else {
							if ( !($CurForm->[5]->[$CurForm->[4]] =~ /^[\-\.0-9]+$/) ) { return -9; }
						}
						if ( $lcFunc eq 'length' ) {
							$CurForm->[5]->[$CurForm->[4]] = length($CurForm->[5]->[$CurForm->[4]]);
						} elsif ( $lcFunc eq 'upper' ) {
							$CurForm->[5]->[$CurForm->[4]] = graphic_uc($CurForm->[5]->[$CurForm->[4]]);
						} elsif ( $lcFunc eq 'lower' ) {
							$CurForm->[5]->[$CurForm->[4]] = graphic_lc($CurForm->[5]->[$CurForm->[4]]);
						} elsif ( $lcFunc eq 'rolling' ) {
							$CurForm->[5]->[$CurForm->[4]] = rolling($CurForm->[5]->[$CurForm->[4]]);
						} elsif ( $lcFunc eq 'rolling2' ) {
							$CurForm->[5]->[$CurForm->[4]] = rolling2($CurForm->[5]->[$CurForm->[4]]);
						} elsif ( $lcFunc eq 'getyear' ) {
							$CurForm->[5]->[$CurForm->[4]] = year($CurForm->[5]->[$CurForm->[4]]);
						} elsif ( $lcFunc eq 'getmonth' ) {
							$CurForm->[5]->[$CurForm->[4]] = month($CurForm->[5]->[$CurForm->[4]]);
						} elsif ( $lcFunc eq 'getday' ) {
							$CurForm->[5]->[$CurForm->[4]] = day($CurForm->[5]->[$CurForm->[4]]);
						} elsif ( $lcFunc eq 'gethour' ) {
							$CurForm->[5]->[$CurForm->[4]] = hour($CurForm->[5]->[$CurForm->[4]]);
						} elsif ( $lcFunc eq 'getminute' ) {
							$CurForm->[5]->[$CurForm->[4]] = minute($CurForm->[5]->[$CurForm->[4]]);
						} elsif ( $lcFunc eq 'getsecond' ) {
							$CurForm->[5]->[$CurForm->[4]] = second($CurForm->[5]->[$CurForm->[4]]);
						} elsif ( $lcFunc eq 'getweek' ) {
							$CurForm->[5]->[$CurForm->[4]] = week($CurForm->[5]->[$CurForm->[4]]);
						} elsif ( $lcFunc eq 'wordrolling' ) {
							$CurForm->[5]->[$CurForm->[4]] = wrolling($CurForm->[5]->[$CurForm->[4]]);
						} elsif ( $lcFunc eq '' ) {
						} else {
							return -39;
						}
						$CurForm->[4]++;
					}
					$i++;
				}
			} else {
				# single value
				@atmp = ();
				$tmp = 0;
				if ( $OWHERE[$i+1] eq '(' ) {
					# with function
					if ( $OWHERE[$i+3] ne ')' ) { return -27; }
					$lcFunc = lc($OWHERE[$i]);
					$CurForm->[5]->[$CurForm->[4]] = $OWHERE[$i+2];
					$i += 3;
				} else {
					$lcFunc = '';
					$CurForm->[5]->[$CurForm->[4]] = $OWHERE[$i];
				}
				if ( $CurForm->[5]->[$CurForm->[4]] =~ /^['"]/ ) {
					$CurForm->[3] = 0; # compare means: string
					$CurForm->[5]->[$CurForm->[4]] =~ s/^['"]//;
					$CurForm->[5]->[$CurForm->[4]] =~ s/['"]$//;
				} elsif ( $CurForm->[5]->[$CurForm->[4]] =~ /^__ResultSet\((\d+)\)$/ ) {
					$CurForm->[3] = 0; # compare means: string
					@atmp = getResultByArray($1, 0, 'V');
					$tmp = @atmp;
					$CurForm->[5]->[$CurForm->[4]] = "__SE_SYSTEM_ARRAY:" . Array2Str(@atmp);
				} else {
					if ( !($CurForm->[5]->[$CurForm->[4]] =~ /^[\-\.0-9]+$/) ) {
						if ( ($tmp2 = checkColumn($CurForm->[5]->[$CurForm->[4]])) == -1 ) {
							return -9;
						} else {
							$CurForm->[5]->[$CurForm->[4]] = $tmp2;
							$CurForm->[7] = -1;
						}
					}
					$CurForm->[3] = 1; # compare means: number
				}
				if ( $CurForm->[7] == -1 ) {
					if ( $lcFunc eq 'length' ) {
						$CurForm->[7] = 1;
					} elsif ( $lcFunc eq 'upper' ) {
						$CurForm->[7] = 2;
					} elsif ( $lcFunc eq 'lower' ) {
						$CurForm->[7] = 3;
					} elsif ( $lcFunc eq 'rolling' ) {
						$CurForm->[7] = 4;
					} elsif ( $lcFunc eq 'rolling2' ) {
						$CurForm->[7] = 5;
					} elsif ( $lcFunc eq 'getyear' ) {
						$CurForm->[7] = 6;
					} elsif ( $lcFunc eq 'getmonth' ) {
						$CurForm->[7] = 7;
					} elsif ( $lcFunc eq 'getday' ) {
						$CurForm->[7] = 8;
					} elsif ( $lcFunc eq 'gethour' ) {
						$CurForm->[7] = 9;
					} elsif ( $lcFunc eq 'getminute' ) {
						$CurForm->[7] = 10;
					} elsif ( $lcFunc eq 'getsecond' ) {
						$CurForm->[7] = 11;
					} elsif ( $lcFunc eq 'getweek' ) {
						$CurForm->[7] = 12;
					} elsif ( $lcFunc eq 'wordrolling' ) {
						$CurForm->[7] = 13;
					} elsif ( $lcFunc eq '' ) {
					} else {
						return -39;
					}
				} else {
					if ( $lcFunc eq 'length' ) {
						$CurForm->[5]->[$CurForm->[4]] = length($CurForm->[5]->[$CurForm->[4]]);
						$CurForm->[3] = 1; # compare means: number
					} elsif ( $lcFunc eq 'upper' ) {
						$CurForm->[5]->[$CurForm->[4]] = graphic_uc($CurForm->[5]->[$CurForm->[4]]);
					} elsif ( $lcFunc eq 'lower' ) {
						$CurForm->[5]->[$CurForm->[4]] = graphic_lc($CurForm->[5]->[$CurForm->[4]]);
					} elsif ( $lcFunc eq 'rolling' ) {
						$CurForm->[5]->[$CurForm->[4]] = rolling($CurForm->[5]->[$CurForm->[4]]);
					} elsif ( $lcFunc eq 'rolling2' ) {
						$CurForm->[5]->[$CurForm->[4]] = rolling2($CurForm->[5]->[$CurForm->[4]]);
					} elsif ( $lcFunc eq 'getyear' ) {
						$CurForm->[5]->[$CurForm->[4]] = year($CurForm->[5]->[$CurForm->[4]]);
					} elsif ( $lcFunc eq 'getmonth' ) {
						$CurForm->[5]->[$CurForm->[4]] = month($CurForm->[5]->[$CurForm->[4]]);
					} elsif ( $lcFunc eq 'getday' ) {
						$CurForm->[5]->[$CurForm->[4]] = day($CurForm->[5]->[$CurForm->[4]]);
					} elsif ( $lcFunc eq 'gethour' ) {
						$CurForm->[5]->[$CurForm->[4]] = hour($CurForm->[5]->[$CurForm->[4]]);
					} elsif ( $lcFunc eq 'getminute' ) {
						$CurForm->[5]->[$CurForm->[4]] = minute($CurForm->[5]->[$CurForm->[4]]);
					} elsif ( $lcFunc eq 'getsecond' ) {
						$CurForm->[5]->[$CurForm->[4]] = second($CurForm->[5]->[$CurForm->[4]]);
					} elsif ( $lcFunc eq 'getweek' ) {
						$CurForm->[5]->[$CurForm->[4]] = week($CurForm->[5]->[$CurForm->[4]]);
					} elsif ( $lcFunc eq 'wordrolling' ) {
						$CurForm->[5]->[$CurForm->[4]] = wrolling($CurForm->[5]->[$CurForm->[4]]);
					} elsif ( $lcFunc eq '' ) {
					} else {
						return -39;
					}
				}
				if ( $tmp != 0 ) { $CurForm->[4] = $tmp; }
				else { $CurForm->[4] = 1; }
			}
			if ( $IndexTable != -1 ) {
				if ( $CurForm->[6] == 0 && $CurForm->[7] == 0 &&
				     $CurForm->[1] == $IndexList[$IndexTable]->[0] &&
				    ($CurForm->[2] eq '=' || $CurForm->[2] eq 'in') ) {
					# can use index
					for ( $idx = 0; $idx < $CurForm->[4]; $idx++ ) {
						$tmp = $IndexList[$IndexTable]->[1]->{$CurForm->[5]->[$idx]};
						if ( $tmp ne undef ) { push( @schRecs, $tmp ); }
						else { $NeedSearch = 0; }
					}
				}
			}
		}
	}
	if ( $CurForm->[4] != 0 ) {
		push( @WHERES, $CurForm );
		$CurForm = undef;
	}
	while ( @opstack ) {
		$op = pop( @opstack );
		if ( $op eq "and" ) {
			$CurForm->[0] = 1;
		} elsif ( $op eq "or" ) {
			$CurForm->[0] = 2;
		} else {
			$CurForm->[0] = 3;
		}
		push( @WHERES, $CurForm );
		$CurForm = undef;
	}

	# Check parenthesis closed
	$pos--;
	if ( $pos > 1 && $i >= $end ) { return -16; }

	return $i;

}

sub CreateJoinProgram {
	local( $joinNestLevel ) = ( 0, 0 );
	my ( $pTable, $ALIAS, $ed, $TableLineCnt );

	( $pTable, $TableLineCnt, $ALIAS, $ed, $err ) = JoinBody(@_);

	if ( $ALIAS ne '' ) {
		foreach ( @SQL ) { s/^$ALIAS\.//; }
	}

	return ( $pTable, $TableLineCnt, $ed, $err );

}

sub JoinBody {

	my( $st, $ed );
	my( $i, $TABLE, $myAlias, $myLineCnt, $pairAlias, $pairLineCnt, $JOIN, $w, $flg, $c );
	my( @result, $resultLineCnt, @mine, @pair, $tmp, $err, $pair);
	my( $j, $jid, $k, $kid, @pset, $exist );
	local( @JOINTMP );

	$st = $_[0];
	$ed = $_[1];
	if ( $st >= $ed ) { return ( 0, 0, '', $ed, 86 ); }

	$i = $st;
	if ( $SQL[$i] =~ /^__ResultSet\((\d+)\)$/ ) {
		@{mine} = @{$ExecuteResult[$1]};
		$myLineCnt = $RecordCount[$1] + 1;
		$IndexTable = -1;
		$flg = 1;
	} else {
		$TABLE = FindTable($SQL[$i]);
		if ( $TABLE eq '' ) { return ( 0, 0, '', $ed, 1 ); }
		@{mine} = @{$DB[$TABLE]};
		$myLineCnt = $DbLineCount[$TABLE];
		$IndexTable = $TABLE;
		$flg = 0;
	}

	$i++;
	$w = lc($SQL[$i]);
	$myAlias = '';
	if ( $w eq 'as' ) { $w = lc($SQL[++$i]); }
	if ( $w ne 'left' && $w ne 'inner' && $w ne 'outer' && $w ne 'natural' && $w ne 'on' && $i < $ed ) {
		# not anything
		$myAlias = $SQL[$i++];
	} else {
		if ( $flg == 0 && $myAlias eq '' ) {
			$myAlias = $DbList[$TABLE];
		} else {
			$myAlias = '';
		}
	}

	if ( $SQL[$i] eq ',' ) { return ( 0, 0, '', $ed, 85 ); }
	if ( $flg == 1 ) {
		$c = 0;
		if ( $myAlias eq '' ) {
			while ( $mine[0]->[$c] ne '' ) {
				if ( index($mine[0]->[$c], '.') != -1 ) { last; }
				$c++;
			}
			if ( $mine[0]->[$c] eq '' ) { return ( 0, 0, '', $i, 87 ); }
		} else {
			while ( $mine[0]->[$c] ne '' ) { $mine[0]->[$c++] =~ s/^.*\.//; }
		}
	}
	if ( $i >= $ed ) { return ( \@mine, $myLineCnt, $myAlias, $i, 0 ); }
	if ( lc($SQL[$i]) eq 'on' ) {
		if ( $joinNestLevel > 0 ) { return ( \@mine, $myLineCnt, $myAlias, $i, 0 ); }
		else { return ( 0, 0, '', $ed, 86 ); }
	}

	while ( $i < $ed ) {
		$w = lc($SQL[$i]);
		if ( $w eq'inner' || $w eq 'outer' || $w eq 'left' || $w eq 'natural' ) {
			# deside JOIN means
			$IndexTable = -1;
			if ( $w eq 'outer' ) { $INOUT = 2; }
			if ( $w eq 'left' ) {
				$INOUT = 2;
				if ( lc($SQL[$i+1]) eq 'outer' ) { $i++; }
			}
			elsif ( $w eq 'inner' || $w eq 'natural' ) { $INOUT = 1; }
			if ( lc($SQL[++$i]) ne 'join' ) { return ( 0, 0, '', $ed, 86 ); }

			# pair
			$joinNestLevel++;
			( $pair, $pairLineCnt, $pairAlias, $i, $err ) = JoinBody( ++$i, $ed, \@SQL );
			@{pair} = @{$pair};
			$joinNestLevel--;
			if ( $err != 0 ) { return ( 0, 0, '', $i, $err ); }
			if ( $myAlias eq $pairAlias ) { return ( 0, 0, '', $i, 87 ); }

			# join condition
			$ColNo[0] = $ColNo[1] = 0;
			if ( lc($SQL[$i]) eq 'on' && $w ne 'natural' ) {
				# Normal Join

				if ( $SQL[++$i] ne '(' ) { return ( 0, 0, '', $i, 86 ); }
				$i++;

				while ( $SQL[$i] ne ')' ) {
					if ( $i >= $ed ) { last; }
					# left side
					if ( ($c = checkItem( \@{$mine[0]}, $myAlias, $SQL[$i] )) != -1 ) {
						$ColNo[0]++;
						$TABLES[0]->[$ColNo[0]]->[0] = $c;
					} elsif ( ($c = checkItem( \@{$pair[0]}, $pairAlias, $SQL[$i] )) != -1 ) {
						$ColNo[1]++;
						$TABLES[1]->[$ColNo[1]]->[0] = $c;
					} else {
						return ( 0, 0, '', $i, 86 );
					}
					$i++;
					if ( lc($SQL[$i]) eq 'number' ) {
						$TABLES[0]->[$ColNo[0]]->[2] =
						$TABLES[1]->[$ColNo[0]]->[2] = 1;
						$i++;
					} elsif ( lc($SQL[$i]) eq 'charactor' || lc($SQL[$i]) eq 'character' ) {
						$TABLES[0]->[$ColNo[0]]->[2] =
						$TABLES[1]->[$ColNo[0]]->[2] = 2;
						$i++;
					} else {
						$TABLES[0]->[$ColNo[0]]->[2] =
						$TABLES[1]->[$ColNo[0]]->[2] = 2;
					}

					if ( $SQL[$i++] ne '=' ) { return ( 0, 0, '', $i, 85 ); }

					# right side
					if ( ($c = checkItem( \@{$mine[0]}, $myAlias, $SQL[$i] )) != -1 ) {
						$ColNo[0]++;
						$TABLES[0]->[$ColNo[0]]->[0] = $c;
					} elsif ( ($c = checkItem( \@{$pair[0]}, $pairAlias, $SQL[$i] )) != -1 ) {
						$ColNo[1]++;
						$TABLES[1]->[$ColNo[1]]->[0] = $c;
					} else {
						return ( 0, 0, '', $i, 86 );
					}
					$i++;
					if ( lc($SQL[$i]) eq 'number' || lc($SQL[$i]) eq 'charactor' || lc($SQL[$i]) eq 'character' ) {
						return ( 0, 0, '', $i, 86 );
					}

					if ( $ColNo[0] != $ColNo[1] ) { return ( 0, 0, '', $i, 86 ); }
					if ( lc($SQL[$i]) ne 'and' && $SQL[$i] ne ')' ) { return ( 0, 0, '', $i, 85 ); }
					if ( lc($SQL[$i]) eq 'and' ) { $i++; }
				}
			} else {
				# Natural Join
				$j = $k = 0;
				for ( $j = 0; $mine[0]->[$j] ne ''; $j++ ) {
					for ( $k = 0; $pair[0]->[$k] ne ''; $k++ ) {
						$jid = $mine[0]->[$j];
						$jid =~ s/^.*?\.//;
						$kid = $pair[0]->[$k];
						$kid =~ s/^.*?\.//;
						if ( $jid eq $kid ) {
							$exist = 0;
							foreach ( @pset ) { if ( $_ eq $jid ) { $exist = 1; last; } }
							push( @pset, $jid );
							if ( !$exist ) {
								$ColNo[0]++;
								$TABLES[0]->[$ColNo[0]]->[0] = $j;
								$ColNo[1]++;
								$TABLES[1]->[$ColNo[1]]->[0] = $k;
								if ( $mine[1]->[$j] =~ /\D/ || $mine[1]->[$k] =~ /\D/ ) {
									$TABLES[0]->[$ColNo[0]]->[2] =
									$TABLES[1]->[$ColNo[0]]->[2] = 2;
								} else {
									$TABLES[0]->[$ColNo[0]]->[2] =
									$TABLES[1]->[$ColNo[0]]->[2] = 1;
								}
							}
						}
					}
				}
				$i++;
			}

			# JOIN execute
			$JOINTMP = ();
			$JOINTMP[0] = makeTempForCView( \@{mine}, $myLineCnt  , $myAlias   );
			$JOINTMP[1] = makeTempForCView( \@{pair}, $pairLineCnt, $pairAlias );
			sortAll( 0, $myLineCnt,   $ColNo[0], \@{$TABLES[0]} );
			sortAll( 1, $pairLineCnt, $ColNo[1], \@{$TABLES[1]} );

			$resultLineCnt = 1;
			compJoinTable( \@{result}, $resultLineCnt, $ColNo[0],
						\@{$JOINTMP[0]}, $myLineCnt, \@{$JOINTMP[1]}, $pairLineCnt );
			@mine = @result;
			$myLineCnt = $resultLineCnt;
			$myAlias = '';

			if ( lc($SQL[++$i]) eq 'on' ) {
				if ( $joinNestLevel == 0 ) { return ( 0, 0, '', $i, 86 ); }
				else { last; }
			}

		} else {
			return ( 0, 0, '', $i, 86 );
		}
	}

	return ( \@mine, $myLineCnt, $myAlias, $i, 0 );

}

sub checkItem {
	my ( @n, $alias, $ItemName );
	my ( $i, $realName );

	@{n} = @{$_[0]};
	$alias = $_[1];
	$ItemName = $_[2];

	for ( $i = 0; $i < @n; $i++ ) {
		$realName = ( index($n[$i], ".") == -1 ) ? "$alias.$n[$i]" : $n[$i];
		if ( $realName eq $ItemName ) { return $i; }
	}
	return -1;
}

sub checkColumn {
	my( @STABLE, $TableCnt, $c );

	if ( $COMMAND eq 'select' ) {
		@{STABLE} = @{$TABLE};
	} else {
		@{STABLE} = @{$DB[$TABLE]};
	}

	$c = 0;
	while ( $STABLE[0]->[$c] ne '' ) {
		if ( $_[0] eq $STABLE[0]->[$c] ) { return $c; }
		$c++;
	}

	return -1;

}

sub getItemFromTag {
	my ( @reta, $start, $end, $XML, %MEMBER, $tag, $ttag );
	$XML = $_[0];
	$XML =~ /<(channel|item)\s+rdf:about\s*=\s*['"]?([^'"]*)['"]?\s*>/i;
	$MEMBER{about} = $2;
	$XML =~ s/<\/?$1.*>//ig;

	while ( $XML =~ /<(.*?)>/ ) {
		$ttag = $tag = $1;
		if ( index($tag, "/") != -1 ) {
			$tag =~ s/[\?\.\^\$\[\]\*\+\|\(\)\\]/\\$&/g;
			$XML =~ s/<$tag>//ig;
			next;
		}
		if ( ($start = index($XML, "<$tag>")) != -1 && ($end = index($XML, "</$tag>")) != -1 ) {
			if ( $start < $end ) { 
				$MEMBER{$tag} = substr($XML, $start+length($tag)+2, $end - $start - length($tag)-2);
			}
		}
		$ttag =~ s/[\?\.\^\$\[\]\*\+\|\(\)\\]/\\$&/g;
		$XML =~ s/<\/?$ttag\/?>//ig;
	}
	$reta[0] = $MEMBER{about};
	$reta[1] = $MEMBER{title};
	$reta[2] = $MEMBER{link};
	$reta[3] = $MEMBER{description};
	$reta[4] = $MEMBER{'dc:subject'};
	$reta[5] = timelocal($MEMBER{'dc:date'});
	$reta[6] = $MEMBER{'dc:type'};
	$reta[7] = $MEMBER{'dc:format'};
	$reta[8] = $MEMBER{'dc:identifier'};
	$reta[9] = $MEMBER{'dc:source'};
	$reta[10] = $MEMBER{'dc:relation'};
	$reta[11] = $MEMBER{'dc:coverage'};
	$reta[12] = $MEMBER{'dc:rights'};

	return @reta;
}

sub putChannelToXML {
	my ( $channel ) = $_[0];
	my ( $TABLE ) = $_[1];
	my ( $start, $end, $aitems, $i, $about, @n );

	@n = @{$ExecuteResult[$CURSOR]->[1]};
	for ( $i = 0; $i < @n; $i++ ) { $n[$i] =~ s/<(.*?)>/&lt;$1&gt;/g; }

	if ( $n[6] =~ /\D/ ) {
		$time = $n[6];
	} else {
		@time = localtime($n[6]);
		@lt = localtime(time); @gt = gmtime(time);
		if ( $lt[2] < $gt[2] ) { $lt[2] += 24; }
		$diff = $lt[2] - $gt[2];
		$time = sprintf("%04d-%02d-%02dT%02d:%02d:%02d+%02d:00", $time[5]+1900, $time[4]+1, $time[3], $time[2], $time[1], $time[0], $diff);
	}

	$channel =~ s/(<channel\s+rdf:about\s*=\s*['"]?)([^'"]*)(['"]?\s*>)/$1$n[1]$3/i;
	$channel = putItemToXML( $channel, 'title', $n[2] );
	$channel = putItemToXML( $channel, 'link', $n[3] );
	$channel = putItemToXML( $channel, 'description', $n[4] );
	$channel = putItemToXML( $channel, 'dc:subject', $n[5] );
	$channel = putItemToXML( $channel, 'dc:date', $time );
	$channel = putItemToXML( $channel, 'dc:type', $n[7] );
	$channel = putItemToXML( $channel, 'dc:format', $n[8] );
	$channel = putItemToXML( $channel, 'dc:identifier', $n[9] );
	$channel = putItemToXML( $channel, 'dc:source', $n[10] );
	$channel = putItemToXML( $channel, 'dc:relation', $n[11] );
	$channel = putItemToXML( $channel, 'dc:coverage', $n[12] );
	$channel = putItemToXML( $channel, 'dc:rights', $n[13] );
	if ( ($start = index($channel, '<items>')) != -1 && ($end = index($channel, '</items>')) != -1 ) {
		if ( $start < $end ) { 
			$aitem = substr($channel, $end + 8);
			$channel = substr($channel, 0, $start) . "<items>\n   <rdf:Seq>\n";
			for ( $i = 2; $i <= $RecordCount[$CURSOR]; $i++ ) {
				$about = $ExecuteResult[$CURSOR]->[$i]->[1];
				$about =~ s/<(.*?)>/&lt;$1&gt;/g;
				$channel .= "    <rdf:li rdf:resource=\"$about\" />\n";
			}
			$channel .= "   </rdf:Seq>\n  </items>$aitem";
		}
	}
	return $channel;
}

sub putItemToXML {
	my ( $XML, $tag, $data ) = @_;
	my ( $start, $end );

	if ( ($start = index($XML, "<$tag>")) != -1 && ($end = index($XML, "</$tag>")) != -1 ) {
		if ( $start < $end ) { 
			$XML = substr($XML, 0, $start + length($tag)+2) . $data . substr($XML, $end);
		}
	} elsif ( $data ne '' && $XML =~ /<$tag\s*?\/\s*?>/ ) {
		$start = $&;
		$end = index($XML, $start);
		$XML = substr($XML, 0, $end) . "<$tag>$data</$tag>" . substr($XML, $end+length($start));
	}

	return $XML;
}

sub xsplit4sql {
	local($quote, $vb, @reta, $st, $c2);
	my( $i, $l );

	$st = $_[0];
	$st =~ s/(^\s*|\r|\s*$)//g;

	@esc = ( "\n", "\t", "\"", "'", "\\" );

	$quote = 0;
	$l = length($st);
	$vb = "";
	@reta = ();
	for ( $i = 0; $i < $l; $i++ ) {
		$c = substr($st, $i, 1);
		if ( $quote == 0 && ord($c) < 0x20 ) { $c = ' '; }
		if ( $CharCode == 0 ) {
			if ( $c =~ /^[\x81-\x9f\xe0-\xef]$/) {
				$i++;
				$c .= substr($st, $i, 1);
			}
		} elsif ( $CharCode == 1 ) {
			if ( $c =~ /^[\xa1-\xfe]$/) {
				$i++;
				$c .= substr($st, $i, 1);
			}
		}
		if ( $quote == 0 && $c eq '"' ) { $quote = 1; }
		elsif ( $c eq "'" ) {
			if ( $quote != 1 ) {
				$quote = ($quote == 2) ? 0 : 2;
			}
		}
		elsif ( $c eq '"' ) {
			if ( $quote != 2 ) {
				$quote = ($quote == 1) ? 0 : 1;
			}
		}
		elsif ( $quote == 0 && $c =~ /[\(\)]/ ) {
			if ( $vb ne "" ) {
				push(@reta, $vb);
				$vb = "";
			}
			push(@reta, $c);
			next;
		}
		elsif ( $quote == 0 && $c =~ /^[<>!=]$/ ) {
			if ( $vb ne "" ) {
				push(@reta, $vb);
				$vb = "";
			}
			$c2 = substr($st, $i+1, 1);
			if ( $c2 =~ /^[>=]$/ ) {
				$c .= $c2;
				$i++;
			}
			push(@reta, $c);
			next;
		}
		if ( $quote == 1 && $c eq "\\" ) {
			$c2 = substr($st, $i+1, 1);
			if ( $c2 eq "n" ) {
				$vb .= $esc[0];
				$i++;
				next;
			} elsif ( $c2 eq "t" ) {
				$vb .= $esc[1];
				$i++;
				next;
			} elsif ( $c2 eq '"' ) {
				$vb .= $esc[2];
				$i++;
				next;
			} elsif ( $c2 eq "'" ) {
				$vb .= $esc[3];
				$i++;
				next;
			} elsif ( $c2 eq "\\" ) {
				$vb .= $esc[4];
				$i++;
				next;
			}
		}
		if ( $quote == 2 && $c eq "\\" ) {
			$c2 = substr($st, $i+1, 1);
			$vb .= "$c$c2";
			$i++;
			next;
		}
		elsif ( $quote == 0 && ( $c eq ',' || $c eq ' ' || $c eq ';') ) {
			if ( $vb ne "" ) {
				push(@reta, $vb);
				$vb = "";
			}
			if ( $c ne ' ' ) { push(@reta, $c); }
			next;
		}
		$vb .= $c;
	}

	if ( $vb ne "" ) {
		push(@reta, $vb);
	}

	if ( $quote != 0 ) { return (); }

	return @reta;

}

sub xsplit4load {
	my ($pr, $st, @reta, $t, $n, $mm, $lp, @n );

	$pr = $_[0];
	$st = "$_[1]\n";

	@n = split(/$pr/, $st);
	chomp($n[@n-1]);
	foreach ( @n ) {
		if ( $mm == 0 && substr($_, 0, 1) eq '"' ) { $mm = 1; }
		if ( $mm == 1 ) {
			$mm = 2;
			$reta[$n] .= $_;
			if ( /(\\\\"|[^\\]")$/ ) { $mm = 0; $n++; }
			next;
		} elsif ( $mm == 2 ) {
			$reta[$n] .= "$pr$_";
			if ( /(\\\\"|[^\\]"|^")$/) { $mm = 0; $n++; }
			next;
		}
		push( @reta, $_ );
		$n++;
	}

	@reta = map { s/^"(.*)"$/$1/; s/(\\\\|\\n|\\t|\\"|\\')/$Conv_ESC2CON{$&}/g; $_ } @reta;
	return @reta;

}

sub make_i2n {
	my($i);

	%i2n = ();
	for ( $i = 0; $DB[$_[0]]->[0]->[$i] ne ""; $i++ ) {
		$i2n{$DB[$_[0]]->[0]->[$i]} = $i;
	}

}

sub FindTable {
	my ( $l, $TName, $TABLE );

	$l = 0;
	foreach ( @DbList ) {
		if ( $_[0] eq $_ ) {
			$TABLE = $l;
			make_i2n($TABLE) if ( $_[1] == 0 );
			last;
		}
		$l++;
	}
	return $TABLE;
}

sub DoubleItem {
	local($j, @Items);
	my( $i );

	@Items = @_;

	for ( $i = 0; $i < @Items - 1; $i++ ) {
		for ( $j = $i + 1; $j < @Items; $j++ ) {
			if ( $Items[$i] eq $Items[$j] ) {
				return 0;
			}
		}
	}

	return 1;

}

sub getResultByArray {
	my ( $CURSOR, $pos, $mode ) = @_;
	my ( @result, $i, $tmp );

	if ( $mode eq 'H' ) {
		@result = @{$ExecuteResult[$CURSOR]->[$pos]};
	} elsif ( $mode eq 'V' ) {
		for ( $i = 1; $i <= $RecordCount[$CURSOR]; $i++ ) {
			$tmp = $ExecuteResult[$CURSOR]->[$i]->[$pos];
			if ( $tmp =~ s/^__SE_SYSTEM_ARRAY:// ) {
				push( @result, Str2Array($tmp) );
			} else {
				push( @result, $tmp );
			}
		}
	}

	return @result;

}

sub sjis2euc {
	my( $st, $hib, $lob, $ed, $i, $c );

	$st = $_[0];

	$ed = "";
	$len = length($st);
	for ( $i = 0; $i < $len; $i++ ) {
		$s = substr($st, $i, 1);
		if ( $s =~ /^[\x81-\x9f\xe0-\xef]$/) {
			$hib = ord(substr($st, $i  , 1));
			$lob = ord(substr($st, $i+1, 1));
			$i++;
			$hib -= ($hib <= 0x9f) ? 0x71 : 0xb1;
			$hib = ($hib << 1) + 1;
			if ($lob >= 0x9e) {
				$lob -= 0x7e;
				$hib++;
			} elsif ($lob > 0x7f) { $lob -= 0x20; }
			else { $lob -= 0x1f; }

			$hib |= 0x80;
			$lob |= 0x80;
			$ed .= sprintf("%c%c", $hib, $lob);
		} else {
			$ed .= $s;
		}
	}

	return $ed;

}

sub Initialize {

	# Global variables
	$LockedDb = -1;
	@DbList = ("");
	@DbFile = ();
	@IndexList = ();
	@DbLineCount = ();
	@NoColumns = ();
	@XML = ();
	@CurPos = ();
	@RecordCount = ();
	@ExecuteResult = ();
	%Cursors = ();
	$CursorCount = 1;
	@Carefully = ();
	@Listeners = ();
	@OuterFiles = ();
	@Passwords = ();
	@OuterSQL = ();
	@TimeOut = ();
	@IndexList = ();
	%RelateWord = ();
	$RegRelate = '';
	@DisregardWords =();
	$RegDisregard = '';
	$NewestCursor = 0;
	$NestLevel = 0;
	$CharCode = 2;
	$Separater = ",";
	$FullLock = 0;
	$SessionID = '';
	$SessionLimit = 0;
	$AutoCommit = 0;
	$ArrayUnfold = 0;
	$proxy = '';
	$pport = 80;

	$Compressable = CheckCompressExist();

	# Setting of interupt
	$SIG{PIPE} = \&sigpipe;
	$SIG{ALRM} = \&sigalrm;
	$SIG{TERM} = $SIG{HUP} = \&terminate;

	if ( (-e "SE.FULLLOCK") && (stat("SE.FULLLOCK"))[10] < (time - 1800) ) { unlink("SE.FULLLOCK"); }
	if ( (-e "SE.COMMIT.LOCK") && (stat("SE.COMMIT.LOCK"))[10] < (time - 1800) ) { unlink("SE.COMMIT.LOCK"); }

	while ( 1 ) { if ( !(-e "SE.FULLLOCK") ) { last; } }
	if ( $main::FULLLOCK ne '' ) {
		$FullLock = 1;
		open(LOCK, ">SE.FULLLOCK");
		close(LOCK);
	}

	# Changing table
	%Conv_ESC2CON = ( "\\\\", "\\", "\\n", "\n", "\\t", "\t", "\\\"", "\"", "\\'", "'" );
	%Conv_CON2ESC = ( "\\", "\\\\", "\n", "\\n", "\t", "\\t", "\"", "\\\"", "'", "\'" );

	PrepareUTF8();

	# prepare Default XML
	$DefaultXML = "<?xml version=\"1.0\" encoding=\"___SYSTEM_CHARA_SET___\" ?>\n"
		    . "<rdf:RDF xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\"\n"
		    . "        xmlns=\"http://purl.org/rss/1.0/\"\n"
		    . "        xmlns:dc=\"http://purl.org/dc/elements/1.1/\" xml:lang=\"ja\">\n"
		    . "\n"
		    . " <channel rdf:about=\"\">\n"
		    . "  <title></title>\n"
		    . "  <link></link>\n"
		    . "  <description></description>\n"
		    . "  <dc:language>ja</dc:language>\n"
		    . "  <items>\n"
		    . "   <rdf:Seq>\n"
		    . "    <rdf:li rdf:resource=\"\" />\n"
		    . "   </rdf:Seq>\n"
		    . "  </items>\n"
		    . " </channel>\n"
		    . "\n"
		    . " <item rdf:about=\"\">\n"
		    . "  <title></title>\n"
		    . "  <link></link>\n"
		    . "  <description></description>\n"
		    . "  <dc:subject></dc:subject>\n"
		    . "  <dc:date></dc:date>\n"
		    . "  <dc:type></dc:type>\n"
		    . "  <dc:format></dc:format>\n"
		    . "  <dc:identifier></dc:identifier>\n"
		    . "  <dc:source></dc:source>\n"
		    . "  <dc:relation></dc:relation>\n"
		    . "  <dc:coverage></dc:coverage>\n"
		    . "  <dc:rights></dc:rights>\n"
		    . " </item>\n"
		    . "\n"
		    . "</rdf:RDF>\n";

}

sub PrepareSJIS {
	%ConvertTable_SJIS = (
		# signs
		"\x81\x49", "\x21", "\x81\x68", "\x22", "\x81\x94", "\x23", "\x81\x90", "\x24", "\x81\x93", "\x25", 
		"\x81\x95", "\x26", "\x81\x66", "\x27", "\x81\x69", "\x28", "\x81\x6a", "\x29", "\x81\x96", "\x2a", 
		"\x81\x7b", "\x2b", "\x81\x43", "\x2c", "\x81\x7c", "\x2d", "\x81\x44", "\x2e", "\x81\x5e", "\x2f", 
		"\x81\x5b", "\x2d", "\x81\x5c", "\x2d", "\x81\x46", "\x3a", "\x81\x47", "\x3b", "\x81\x60", "\x7e", 
		"\x81\x83", "\x3c", "\x81\x81", "\x3d", "\x81\x84", "\x3e", "\x81\x48", "\x3f", "\x81\x97", "\x40", 
		"\x81\x6d", "\x5b", "\x81\x8f", "\x5c", "\x81\x6e", "\x5d", "\x81\x4f", "\x5e", "\x81\x51", "\x5f", 
		"\x81\x65", "\x60", "\x81\x6f", "\x7b", "\x81\x62", "\x7c", "\x81\x70", "\x7d", "\x81\x5d", "\x2d", 
		"\x81\x42", "\xa1", "\x81\x75", "\xa2", "\x81\x76", "\xa3", "\x81\x41", "\xa4", "\x81\x4a", "\xde", 
		"\x81\x67", "\x22", "\x81\x96", "\x2a", "\x81\x7e", "\x2a", "\x81\x45", "\xa5", "\x81\x4b", "\xdf", 
		"\x81\x40", "\x20", "\x81\x80", "\x2f", 

		# Number
		"\x82\x4f", "\x30", "\x82\x50", "\x31", "\x82\x51", "\x32", "\x82\x52", "\x33", "\x82\x53", "\x34", 
		"\x82\x54", "\x35", "\x82\x55", "\x36", "\x82\x56", "\x37", "\x82\x57", "\x38", "\x82\x58", "\x39", 

		# wide size alphabet
		"\x82\x60", "\x61", "\x82\x61", "\x62", "\x82\x62", "\x63", "\x82\x63", "\x64", "\x82\x64", "\x65", 
		"\x82\x65", "\x66", "\x82\x66", "\x67", "\x82\x67", "\x68", "\x82\x68", "\x69", "\x82\x69", "\x6a", 
		"\x82\x6a", "\x6b", "\x82\x6b", "\x6c", "\x82\x6c", "\x6d", "\x82\x6d", "\x6e", "\x82\x6e", "\x6f", 
		"\x82\x6f", "\x70", "\x82\x70", "\x71", "\x82\x71", "\x72", "\x82\x72", "\x73", "\x82\x73", "\x74", 
		"\x82\x74", "\x75", "\x82\x75", "\x76", "\x82\x76", "\x77", "\x82\x77", "\x78", "\x82\x78", "\x79", "\x82\x79", "\x7a", 
		"\x82\x81", "\x61", "\x82\x82", "\x62", "\x82\x83", "\x63", "\x82\x84", "\x64", "\x82\x85", "\x65", 
		"\x82\x86", "\x66", "\x82\x87", "\x67", "\x82\x88", "\x68", "\x82\x89", "\x69", "\x82\x8a", "\x6a", 
		"\x82\x8b", "\x6b", "\x82\x8c", "\x6c", "\x82\x8d", "\x6d", "\x82\x8e", "\x6e", "\x82\x8f", "\x6f", 
		"\x82\x90", "\x70", "\x82\x91", "\x71", "\x82\x92", "\x72", "\x82\x93", "\x73", "\x82\x94", "\x74", 
		"\x82\x95", "\x75", "\x82\x96", "\x76", "\x82\x97", "\x77", "\x82\x98", "\x78", "\x82\x99", "\x79", "\x82\x9a", "\x7a", 

		# hiragana
		"\x82\x9f", "\xa7", "\x82\xa0", "\xb1", "\x82\xa1", "\xa8", "\x82\xa2", "\xb2", "\x82\xa3", "\xa9", 
		"\x82\xa4", "\xb3", "\x82\xa5", "\xaa", "\x82\xa6", "\xb4", "\x82\xa7", "\xab", "\x82\xa8", "\xb5", 
		"\x82\xa9", "\xb6", "\x82\xaa", "\xb6\xde", "\x82\xab", "\xb7", "\x82\xac", "\xb7\xde", "\x82\xad", "\xb8", 
		"\x82\xae", "\xb8\xde", "\x82\xaf", "\xb9", "\x82\xb0", "\xb9\xde", "\x82\xb1", "\xba", "\x82\xb2", "\xba\xde", 
		"\x82\xb3", "\xbb", "\x82\xb4", "\xbb\xde", "\x82\xb5", "\xbc", "\x82\xb6", "\xbc\xde", "\x82\xb7", "\xbd", 
		"\x82\xb8", "\xbd\xde", "\x82\xb9", "\xbe", "\x82\xba", "\xbe\xde", "\x82\xbb", "\xbf", "\x82\xbc", "\xbf\xde", 
		"\x82\xbd", "\xc0", "\x82\xbe", "\xc0\xde", "\x82\xbf", "\xc1", "\x82\xc0", "\xc1\xde", "\x82\xc1", "\xaf", 
		"\x82\xc2", "\xc2", "\x82\xc3", "\xc2\xde", "\x82\xc4", "\xc3", "\x82\xc5", "\xc3\xde", "\x82\xc6", "\xc4", "\x82\xc7", "\xc4\xde", 
		"\x82\xc8", "\xc5", "\x82\xc9", "\xc6", "\x82\xca", "\xc7", "\x82\xcb", "\xc8", "\x82\xcc", "\xc9", 
		"\x82\xcd", "\xca", "\x82\xce", "\xca\xde", "\x82\xcf", "\xca\xdf", "\x82\xd0", "\xcb", "\x82\xd1", "\xcb\xde", 
		"\x82\xd2", "\xcb\xdf", "\x82\xd3", "\xcc", "\x82\xd4", "\xcc\xde", "\x82\xd5", "\xcc\xdf", "\x82\xd6", "\xcd", 
		"\x82\xd7", "\xcd\xde", "\x82\xd8", "\xcd\xdf", "\x82\xd9", "\xce", "\x82\xda", "\xce\xde", "\x82\xdb", "\xce\xdf", 
		"\x82\xdc", "\xcf", "\x82\xdd", "\xd0", "\x82\xde", "\xd1", "\x82\xdf", "\xd2", "\x82\xe0", "\xd3", 
		"\x82\xe1", "\xac", "\x82\xe2", "\xd4", "\x82\xe3", "\xad", "\x82\xe4", "\xd5", "\x82\xe5", "\xae", "\x82\xe6", "\xd6", 
		"\x82\xe7", "\xd7", "\x82\xe8", "\xd8", "\x82\xe9", "\xd9", "\x82\xea", "\xda", "\x82\xeb", "\xdb", 
		"\x82\xec", "\xdc", "\x82\xed", "\xdc", "\x82\xee", "\xb2", "\x82\xef", "\xb4", "\x82\xf0", "\xa6", "\x82\xf1", "\xdd", 

		# katakana
		"\x83\x40", "\xa7", "\x83\x41", "\xb1", "\x83\x42", "\xa8", "\x83\x43", "\xb2", "\x83\x44", "\xa9", 
		"\x83\x45", "\xb3", "\x83\x46", "\xaa", "\x83\x47", "\xb4", "\x83\x48", "\xab", "\x83\x49", "\xb5", 
		"\x83\x4a", "\xb6", "\x83\x4b", "\xb6\xde", "\x83\x4c", "\xb7", "\x83\x4d", "\xb7\xde", "\x83\x4e", "\xb8", 
		"\x83\x4f", "\xb8\xde", "\x83\x50", "\xb9", "\x83\x51", "\xb9\xde", "\x83\x52", "\xba", "\x83\x53", "\xba\xde", 
		"\x83\x54", "\xbb", "\x83\x55", "\xbb\xde", "\x83\x56", "\xbc", "\x83\x57", "\xbc\xde", "\x83\x58", "\xbd", 
		"\x83\x59", "\xbd\xde", "\x83\x5a", "\xbe", "\x83\x5b", "\xbe\xde", "\x83\x5c", "\xbf", "\x83\x5d", "\xbf\xde", 
		"\x83\x5e", "\xc0", "\x83\x5f", "\xc0\xde", "\x83\x60", "\xc1", "\x83\x61", "\xc1\xde", "\x83\x62", "\xaf", 
		"\x83\x63", "\xc2", "\x83\x64", "\xc2\xde", "\x83\x65", "\xc3", "\x83\x66", "\xc3\xde", "\x83\x67", "\xc4", "\x83\x68", "\xc4\xde", 
		"\x83\x69", "\xc5", "\x83\x6a", "\xc6", "\x83\x6b", "\xc7", "\x83\x6c", "\xc8", "\x83\x6d", "\xc9", 
		"\x83\x6e", "\xca", "\x83\x6f", "\xca\xde", "\x83\x70", "\xca\xdf", "\x83\x71", "\xcb", "\x83\x72", "\xcb\xde", 
		"\x83\x73", "\xcb\xdf", "\x83\x74", "\xcc", "\x83\x75", "\xcc\xde", "\x83\x76", "\xcc\xdf", "\x83\x77", "\xcd", 
		"\x83\x78", "\xcd\xde", "\x83\x79", "\xcd\xdf", "\x83\x7a", "\xce", "\x83\x7b", "\xce\xde", "\x83\x7c", "\xce\xdf", 
		"\x83\x7d", "\xcf", "\x83\x7e", "\xd0", "\x83\x80", "\xd1", "\x83\x81", "\xd2", "\x83\x82", "\xd3", 
		"\x83\x83", "\xac", "\x83\x84", "\xd4", "\x83\x85", "\xad", "\x83\x86", "\xd5", "\x83\x87", "\xae", "\x83\x88", "\xd6", 
		"\x83\x89", "\xd7", "\x83\x8a", "\xd8", "\x83\x8b", "\xd9", "\x83\x8c", "\xda", "\x83\x8d", "\xdb", 
		"\x83\x8e", "\xdc", "\x83\x8f", "\xdc", "\x83\x90", "\xb2", "\x83\x91", "\xb4", "\x83\x92", "\xa6", "\x83\x93", "\xdd", 
		"\x83\x94", "\xb3\xde", "\x83\x95", "\xb6", "\x83\x96", "\xb9"
	);
}

sub PrepareEUC {
	%ConvertTable_EUC = (
		# signs
		"\xa1\xaa", "\x21", "\xa1\xc9", "\x22", "\xa1\xf4", "\x23", "\xa1\xf0", "\x24", "\xa1\xf3", "\x25", 
		"\xa1\xf5", "\x26", "\xa1\xc7", "\x27", "\xa1\xca", "\x28", "\xa1\xcb", "\x29", "\xa1\xf6", "\x2a", 
		"\xa1\xdc", "\x2b", "\xa1\xa4", "\x2c", "\xa1\xdd", "\x2d", "\xa1\xa5", "\x2e", "\xa1\xbf", "\x2f", 
		"\xa1\xbc", "\x2d", "\xa1\xbd", "\x2d", "\xa1\xa7", "\x3a", "\xa1\xa8", "\x3b", "\xa1\xc1", "\x7e", 
		"\xa1\xe3", "\x3c", "\xa1\xe1", "\x3d", "\xa1\xe4", "\x3e", "\xa1\xa9", "\x3f", "\xa1\xf7", "\x40", 
		"\xa1\xce", "\x5b", "\xa1\xef", "\x5c", "\xa1\xcf", "\x5d", "\xa1\xb0", "\x5e", "\xa1\xb2", "\x5f", 
		"\xa1\xc6", "\x60", "\xa1\xd0", "\x7b", "\xa1\xc3", "\x7c", "\xa1\xd1", "\x7d", "\xa1\xbe", "\x2d", 
		"\xa1\xa3", "\x8e\xa1", "\xa1\xd6", "\x8e\xa2", "\xa1\xd7", "\x8e\xa3", "\xa1\xa2", "\x8e\xa4", "\xa1\xab", "\x8e\xde", 
		"\xa1\xc8", "\x22", "\xa1\xf6", "\x2a", "\xa1\xdf", "\x2a", "\xa1\xa6", "\x8e\xa5", "\xa1\xac", "\x8e\xdf", 
		"\xa1\xa1", "\x20", "\xa1\xe0", "\x2f", 

		# number
		"\xa3\xb0", "\x30", "\xa3\xb1", "\x31", "\xa3\xb2", "\x32", "\xa3\xb3", "\x33", "\xa3\xb4", "\x34", 
		"\xa3\xb5", "\x35", "\xa3\xb6", "\x36", "\xa3\xb7", "\x37", "\xa3\xb8", "\x38", "\xa3\xb9", "\x39", 

		# wide size alphabet
		"\xa3\xc1", "\x61", "\xa3\xc2", "\x62", "\xa3\xc3", "\x63", "\xa3\xc4", "\x64", "\xa3\xc5", "\x65", 
		"\xa3\xc6", "\x66", "\xa3\xc7", "\x67", "\xa3\xc8", "\x68", "\xa3\xc9", "\x69", "\xa3\xca", "\x6a", 
		"\xa3\xcb", "\x6b", "\xa3\xcc", "\x6c", "\xa3\xcd", "\x6d", "\xa3\xce", "\x6e", "\xa3\xcf", "\x6f", 
		"\xa3\xd0", "\x70", "\xa3\xd1", "\x71", "\xa3\xd2", "\x72", "\xa3\xd3", "\x73", "\xa3\xd4", "\x74", 
		"\xa3\xd5", "\x75", "\xa3\xd6", "\x76", "\xa3\xd7", "\x77", "\xa3\xd8", "\x78", "\xa3\xd9", "\x79", "\xa3\xda", "\x7a", 
		"\xa3\xe1", "\x61", "\xa3\xe2", "\x62", "\xa3\xe3", "\x63", "\xa3\xe4", "\x64", "\xa3\xe5", "\x65", 
		"\xa3\xe6", "\x66", "\xa3\xe7", "\x67", "\xa3\xe8", "\x68", "\xa3\xe9", "\x69", "\xa3\xea", "\x6a", 
		"\xa3\xeb", "\x6b", "\xa3\xec", "\x6c", "\xa3\xed", "\x6d", "\xa3\xee", "\x6e", "\xa3\xef", "\x6f", 
		"\xa3\xf0", "\x70", "\xa3\xf1", "\x71", "\xa3\xf2", "\x72", "\xa3\xf3", "\x73", "\xa3\xf4", "\x74", 
		"\xa3\xf5", "\x75", "\xa3\xf6", "\x76", "\xa3\xf7", "\x77", "\xa3\xf8", "\x78", "\xa3\xf9", "\x79", "\xa3\xfa", "\x7a", 

		# hiragana
		"\xa4\xa1", "\x8e\xa7", "\xa4\xa2", "\x8e\xb1", "\xa4\xa3", "\x8e\xa8", "\xa4\xa4", "\x8e\xb2", "\xa4\xa5", "\x8e\xa9", 
		"\xa4\xa6", "\x8e\xb3", "\xa4\xa7", "\x8e\xaa", "\xa4\xa8", "\x8e\xb4", "\xa4\xa9", "\x8e\xab", "\xa4\xaa", "\x8e\xb5", 
		"\xa4\xab", "\x8e\xb6", "\xa4\xac", "\x8e\xb6\x8e\xde", "\xa4\xad", "\x8e\xb7", "\xa4\xae", "\x8e\xb7\x8e\xde", "\xa4\xaf", "\x8e\xb8", 
		"\xa4\xb0", "\x8e\xb8\x8e\xde", "\xa4\xb1", "\x8e\xb9", "\xa4\xb2", "\x8e\xb9\x8e\xde", "\xa4\xb3", "\x8e\xba", "\xa4\xb4", "\x8e\xba\x8e\xde", 
		"\xa4\xb5", "\x8e\xbb", "\xa4\xb6", "\x8e\xbb\x8e\xde", "\xa4\xb7", "\x8e\xbc", "\xa4\xb8", "\x8e\xbc\x8e\xde", "\xa4\xb9", "\x8e\xbd", 
		"\xa4\xba", "\x8e\xbd\x8e\xde", "\xa4\xbb", "\x8e\xbe", "\xa4\xbc", "\x8e\xbe\x8e\xde", "\xa4\xbd", "\x8e\xbf", "\xa4\xbe", "\x8e\xbf\x8e\xde", 
		"\xa4\xbf", "\x8e\xc0", "\xa4\xc0", "\x8e\xc0\x8e\xde", "\xa4\xc1", "\x8e\xc1", "\xa4\xc2", "\x8e\xc1\x8e\xde", "\xa4\xc3", "\x8e\xaf", 
		"\xa4\xc4", "\x8e\xc2", "\xa4\xc5", "\x8e\xc2\x8e\xde", "\xa4\xc6", "\x8e\xc3", "\xa4\xc7", "\x8e\xc3\x8e\xde", "\xa4\xc8", "\x8e\xc4", "\xa4\xc9", "\x8e\xc4\x8e\xde", 
		"\xa4\xca", "\x8e\xc5", "\xa4\xcb", "\x8e\xc6", "\xa4\xcc", "\x8e\xc7", "\xa4\xcd", "\x8e\xc8", "\xa4\xce", "\x8e\xc9", 
		"\xa4\xcf", "\x8e\xca", "\xa4\xd0", "\x8e\xca\x8e\xde", "\xa4\xd1", "\x8e\xca\x8e\xdf", "\xa4\xd2", "\x8e\xcb", "\xa4\xd3", "\x8e\xcb\x8e\xde", 
		"\xa4\xd4", "\x8e\xcb\x8e\xdf", "\xa4\xd5", "\x8e\xcc", "\xa4\xd6", "\x8e\xcc\x8e\xde", "\xa4\xd7", "\x8e\xcc\x8e\xdf", "\xa4\xd8", "\x8e\xcd", 
		"\xa4\xd9", "\x8e\xcd\x8e\xde", "\xa4\xda", "\x8e\xcd\x8e\xdf", "\xa4\xdb", "\x8e\xce", "\xa4\xdc", "\x8e\xce\x8e\xde", "\xa4\xdd", "\x8e\xce\x8e\xdf", 
		"\xa4\xde", "\x8e\xcf", "\xa4\xdf", "\x8e\xd0", "\xa4\xe0", "\x8e\xd1", "\xa4\xe1", "\x8e\xd2", "\xa4\xe2", "\x8e\xd3", 
		"\xa4\xe3", "\x8e\xac", "\xa4\xe4", "\x8e\xd4", "\xa4\xe5", "\x8e\xad", "\xa4\xe6", "\x8e\xd5", "\xa4\xe7", "\x8e\xae", "\xa4\xe8", "\x8e\xd6", 
		"\xa4\xe9", "\x8e\xd7", "\xa4\xea", "\x8e\xd8", "\xa4\xeb", "\x8e\xd9", "\xa4\xec", "\x8e\xda", "\xa4\xed", "\x8e\xdb", 
		"\xa4\xee", "\x8e\xdc", "\xa4\xef", "\x8e\xdc", "\xa4\xf0", "\x8e\xb2", "\xa4\xf1", "\x8e\xb4", "\xa4\xf2", "\x8e\xa6", "\xa4\xf3", "\x8e\xdd", 

		# katakana
		"\xa5\xa1", "\x8e\xa7", "\xa5\xa2", "\x8e\xb1", "\xa5\xa3", "\x8e\xa8", "\xa5\xa4", "\x8e\xb2", "\xa5\xa5", "\x8e\xa9", 
		"\xa5\xa6", "\x8e\xb3", "\xa5\xa7", "\x8e\xaa", "\xa5\xa8", "\x8e\xb4", "\xa5\xa9", "\x8e\xab", "\xa5\xaa", "\x8e\xb5", 
		"\xa5\xab", "\x8e\xb6", "\xa5\xac", "\x8e\xb6\x8e\xde", "\xa5\xad", "\x8e\xb7", "\xa5\xae", "\x8e\xb7\x8e\xde", "\xa5\xaf", "\x8e\xb8", 
		"\xa5\xb0", "\x8e\xb8\x8e\xde", "\xa5\xb1", "\x8e\xb9", "\xa5\xb2", "\x8e\xb9\x8e\xde", "\xa5\xb3", "\x8e\xba", "\xa5\xb4", "\x8e\xba\x8e\xde", 
		"\xa5\xb5", "\x8e\xbb", "\xa5\xb6", "\x8e\xbb\x8e\xde", "\xa5\xb7", "\x8e\xbc", "\xa5\xb8", "\x8e\xbc\x8e\xde", "\xa5\xb9", "\x8e\xbd", 
		"\xa5\xba", "\x8e\xbd\x8e\xde", "\xa5\xbb", "\x8e\xbe", "\xa5\xbc", "\x8e\xbe\x8e\xde", "\xa5\xbd", "\x8e\xbf", "\xa5\xbe", "\x8e\xbf\x8e\xde", 
		"\xa5\xbf", "\x8e\xc0", "\xa5\xc0", "\x8e\xc0\x8e\xde", "\xa5\xc1", "\x8e\xc1", "\xa5\xc2", "\x8e\xc1\x8e\xde", "\xa5\xc3", "\x8e\xaf", 
		"\xa5\xc4", "\x8e\xc2", "\xa5\xc5", "\x8e\xc2\x8e\xde", "\xa5\xc6", "\x8e\xc3", "\xa5\xc7", "\x8e\xc3\x8e\xde", "\xa5\xc8", "\x8e\xc4", "\xa5\xc9", "\x8e\xc4\x8e\xde", 
		"\xa5\xca", "\x8e\xc5", "\xa5\xcb", "\x8e\xc6", "\xa5\xcc", "\x8e\xc7", "\xa5\xcd", "\x8e\xc8", "\xa5\xce", "\x8e\xc9", 
		"\xa5\xcf", "\x8e\xca", "\xa5\xd0", "\x8e\xca\x8e\xde", "\xa5\xd1", "\x8e\xca\x8e\xdf", "\xa5\xd2", "\x8e\xcb", "\xa5\xd3", "\x8e\xcb\x8e\xde", 
		"\xa5\xd4", "\x8e\xcb\x8e\xdf", "\xa5\xd5", "\x8e\xcc", "\xa5\xd6", "\x8e\xcc\x8e\xde", "\xa5\xd7", "\x8e\xcc\x8e\xdf", "\xa5\xd8", "\x8e\xcd", 
		"\xa5\xd9", "\x8e\xcd\x8e\xde", "\xa5\xda", "\x8e\xcd\x8e\xdf", "\xa5\xdb", "\x8e\xce", "\xa5\xdc", "\x8e\xce\x8e\xde", "\xa5\xdd", "\x8e\xce\x8e\xdf", 
		"\xa5\xde", "\x8e\xcf", "\xa5\xdf", "\x8e\xd0", "\xa5\xe0", "\x8e\xd1", "\xa5\xe1", "\x8e\xd2", "\xa5\xe2", "\x8e\xd3", 
		"\xa5\xe3", "\x8e\xac", "\xa5\xe4", "\x8e\xd4", "\xa5\xe5", "\x8e\xad", "\xa5\xe6", "\x8e\xd5", "\xa5\xe7", "\x8e\xae", "\xa5\xe8", "\x8e\xd6", 
		"\xa5\xe9", "\x8e\xd7", "\xa5\xea", "\x8e\xd8", "\xa5\xeb", "\x8e\xd9", "\xa5\xec", "\x8e\xda", "\xa5\xed", "\x8e\xdb", 
		"\xa5\xee", "\x8e\xdc", "\xa5\xef", "\x8e\xdc", "\xa5\xf0", "\x8e\xb2", "\xa5\xf1", "\x8e\xb4", "\xa5\xf2", "\x8e\xa6", "\xa5\xf3", "\x8e\xdd", 
		"\xa5\xf4", "\x8e\xb3\x8e\xde", "\xa5\xf5", "\x8e\xb6", "\xa5\xf6", "\x8e\xb9"
	);

}

sub PrepareUTF8 {
	%ConvertTable_UTF8 = (
		# signs
		"\xef\xbc\x81",	"\x21",	"\xe2\x80\x9d",	"\x22",	"\xef\xbc\x83",	"\x23",	"\xef\xbc\x84",	"\x24",	"\xef\xbc\x85",	"\x25",
		"\xef\xbc\x86",	"\x26",	"\xe2\x80\x99",	"\x27",	"\xef\xbc\x88",	"\x28",	"\xef\xbc\x89",	"\x29",	"\xef\xbc\x8a",	"\x2a",
		"\xef\xbc\x8b",	"\x2b",	"\xef\xbc\x8c",	"\x2c",	"\xef\xbc\x8d",	"\x2d",	"\xef\xbc\x8e",	"\x2e",	"\xef\xbc\x8f",	"\x2f",
		"\xe3\x83\xbc",	"\x2d",	"\xe2\x80\x95",	"\x2d",	"\xef\xbc\x9a",	"\x3a",	"\xef\xbc\x9b",	"\x3b",	"\xef\xbd\x9e",	"\x7e",
		"\xef\xbc\x9c",	"\x3c",	"\xef\xbc\x9d",	"\x3d",	"\xef\xbc\x9e",	"\x3e",	"\xef\xbc\x9f",	"\x3f",	"\xef\xbc\xa0",	"\x40",
		"\xef\xbc\xbb",	"\x5b",	"\xef\xbf\xa5",	"\x5c\x5c",	"\xef\xbc\xbd",	"\x5d",	"\xef\xbc\xbe",	"\x5e",	"\xef\xbc\xbf",	"\x5f",
		"\xe2\x80\x98",	"\x60",	"\xef\xbd\x9b",	"\x7b",	"\xef\xbd\x9c",	"\x7c",	"\xef\xbd\x9d",	"\x7d",	"\xe2\x80\x90",	"\x2d",
		"\xe3\x80\x82",	"\xef\xbd\xa1",	"\xe3\x80\x8c",	"\xef\xbd\xa2",	"\xe3\x80\x8d",	"\xef\xbd\xa3",	"\xe3\x80\x81",	"\xef\xbd\xa4",	"\xe3\x82\x9b",	"\xef\xbe\x9e",
		"\xe2\x80\x9c",	"\x22",	"\xef\xbc\x8a",	"\x2a",	"\xc3\x97",	"\x2a",	"\xe3\x83\xbb",	"\xef\xbd\xa5",	"\xe3\x82\x9c",	"\xef\xbe\x9f",
		"\xe3\x80\x80",	"\x20",	"\xc3\xb7",	"\x2f",

		# number
		"\xef\xbc\x90",	"\x30",	"\xef\xbc\x91",	"\x31",	"\xef\xbc\x92",	"\x32",	"\xef\xbc\x93",	"\x33",	"\xef\xbc\x94",	"\x34",
		"\xef\xbc\x95",	"\x35",	"\xef\xbc\x96",	"\x36",	"\xef\xbc\x97",	"\x37",	"\xef\xbc\x98",	"\x38",	"\xef\xbc\x99",	"\x39",

		# wide size alphabet
		"\xef\xbc\xa1",	"\x61",	"\xef\xbc\xa2",	"\x62",	"\xef\xbc\xa3",	"\x63",	"\xef\xbc\xa4",	"\x64",	"\xef\xbc\xa5",	"\x65",
		"\xef\xbc\xa6",	"\x66",	"\xef\xbc\xa7",	"\x67",	"\xef\xbc\xa8",	"\x68",	"\xef\xbc\xa9",	"\x69",	"\xef\xbc\xaa",	"\x6a",
		"\xef\xbc\xab",	"\x6b",	"\xef\xbc\xac",	"\x6c",	"\xef\xbc\xad",	"\x6d",	"\xef\xbc\xae",	"\x6e",	"\xef\xbc\xaf",	"\x6f",
		"\xef\xbc\xb0",	"\x70",	"\xef\xbc\xb1",	"\x71",	"\xef\xbc\xb2",	"\x72",	"\xef\xbc\xb3",	"\x73",	"\xef\xbc\xb4",	"\x74",
		"\xef\xbc\xb5",	"\x75",	"\xef\xbc\xb6",	"\x76",	"\xef\xbc\xb7",	"\x77",	"\xef\xbc\xb8",	"\x78",	"\xef\xbc\xb9",	"\x79",	"\xef\xbc\xba",	"\x7a",
		"\xef\xbd\x81",	"\x61",	"\xef\xbd\x82",	"\x62",	"\xef\xbd\x83",	"\x63",	"\xef\xbd\x84",	"\x64",	"\xef\xbd\x85",	"\x65",
		"\xef\xbd\x86",	"\x66",	"\xef\xbd\x87",	"\x67",	"\xef\xbd\x88",	"\x68",	"\xef\xbd\x89",	"\x69",	"\xef\xbd\x8a",	"\x6a",
		"\xef\xbd\x8b",	"\x6b",	"\xef\xbd\x8c",	"\x6c",	"\xef\xbd\x8d",	"\x6d",	"\xef\xbd\x8e",	"\x6e",	"\xef\xbd\x8f",	"\x6f",
		"\xef\xbd\x90",	"\x70",	"\xef\xbd\x91",	"\x71",	"\xef\xbd\x92",	"\x72",	"\xef\xbd\x93",	"\x73",	"\xef\xbd\x94",	"\x74",
		"\xef\xbd\x95",	"\x75",	"\xef\xbd\x96",	"\x76",	"\xef\xbd\x97",	"\x77",	"\xef\xbd\x98",	"\x78",	"\xef\xbd\x99",	"\x79",	"\xef\xbd\x9a",	"\x7a",

		# hiragana
		"\xe3\x81\x81",	"\xef\xbd\xa7",	"\xe3\x81\x82",	"\xef\xbd\xb1",	"\xe3\x81\x83",	"\xef\xbd\xa8",	"\xe3\x81\x84",	"\xef\xbd\xb2",	"\xe3\x81\x85",	"\xef\xbd\xa9",
		"\xe3\x81\x86",	"\xef\xbd\xb3",	"\xe3\x81\x87",	"\xef\xbd\xaa",	"\xe3\x81\x88",	"\xef\xbd\xb4",	"\xe3\x81\x89",	"\xef\xbd\xab",	"\xe3\x81\x8a",	"\xef\xbd\xb5",
		"\xe3\x81\x8b",	"\xef\xbd\xb6",	"\xe3\x81\x8c",	"\xef\xbd\xb6\xef\xbe\x9e",	"\xe3\x81\x8d",	"\xef\xbd\xb7",	"\xe3\x81\x8e",	"\xef\xbd\xb7\xef\xbe\x9e",	"\xe3\x81\x8f",	"\xef\xbd\xb8",
		"\xe3\x81\x90",	"\xef\xbd\xb8\xef\xbe\x9e",	"\xe3\x81\x91",	"\xef\xbd\xb9",	"\xe3\x81\x92",	"\xef\xbd\xb9\xef\xbe\x9e",	"\xe3\x81\x93",	"\xef\xbd\xba",	"\xe3\x81\x94",	"\xef\xbd\xba\xef\xbe\x9e",
		"\xe3\x81\x95",	"\xef\xbd\xbb",	"\xe3\x81\x96",	"\xef\xbd\xbb\xef\xbe\x9e",	"\xe3\x81\x97",	"\xef\xbd\xbc",	"\xe3\x81\x98",	"\xef\xbd\xbc\xef\xbe\x9e",	"\xe3\x81\x99",	"\xef\xbd\xbd",
		"\xe3\x81\x9a",	"\xef\xbd\xbd\xef\xbe\x9e",	"\xe3\x81\x9b",	"\xef\xbd\xbe",	"\xe3\x81\x9c",	"\xef\xbd\xbe\xef\xbe\x9e",	"\xe3\x81\x9d",	"\xef\xbd\xbf",	"\xe3\x81\x9e",	"\xef\xbd\xbf\xef\xbe\x9e",
		"\xe3\x81\x9f",	"\xef\xbe\x80",	"\xe3\x81\xa0",	"\xef\xbe\x80\xef\xbe\x9e",	"\xe3\x81\xa1",	"\xef\xbe\x81",	"\xe3\x81\xa2",	"\xef\xbe\x81\xef\xbe\x9e",	"\xe3\x81\xa3",	"\xef\xbd\xaf",
		"\xe3\x81\xa4",	"\xef\xbe\x82",	"\xe3\x81\xa5",	"\xef\xbe\x82\xef\xbe\x9e",	"\xe3\x81\xa6",	"\xef\xbe\x83",	"\xe3\x81\xa7",	"\xef\xbe\x83\xef\xbe\x9e",	"\xe3\x81\xa8",	"\xef\xbe\x84",	"\xe3\x81\xa9",	"\xef\xbe\x84\xef\xbe\x9e",
		"\xe3\x81\xaa",	"\xef\xbe\x85",	"\xe3\x81\xab",	"\xef\xbe\x86",	"\xe3\x81\xac",	"\xef\xbe\x87",	"\xe3\x81\xad",	"\xef\xbe\x88",	"\xe3\x81\xae",	"\xef\xbe\x89",
		"\xe3\x81\xaf",	"\xef\xbe\x8a",	"\xe3\x81\xb0",	"\xef\xbe\x8a\xef\xbe\x9e",	"\xe3\x81\xb1",	"\xef\xbe\x8a\xef\xbe\x9f",	"\xe3\x81\xb2",	"\xef\xbe\x8b",	"\xe3\x81\xb3",	"\xef\xbe\x8b\xef\xbe\x9e",
		"\xe3\x81\xb4",	"\xef\xbe\x8b\xef\xbe\x9f",	"\xe3\x81\xb5",	"\xef\xbe\x8c",	"\xe3\x81\xb6",	"\xef\xbe\x8c\xef\xbe\x9e",	"\xe3\x81\xb7",	"\xef\xbe\x8c\xef\xbe\x9f",	"\xe3\x81\xb8",	"\xef\xbe\x8d",
		"\xe3\x81\xb9",	"\xef\xbe\x8d\xef\xbe\x9e",	"\xe3\x81\xba",	"\xef\xbe\x8d\xef\xbe\x9f",	"\xe3\x81\xbb",	"\xef\xbe\x8e",	"\xe3\x81\xbc",	"\xef\xbe\x8e\xef\xbe\x9e",	"\xe3\x81\xbd",	"\xef\xbe\x8e\xef\xbe\x9f",
		"\xe3\x81\xbe",	"\xef\xbe\x8f",	"\xe3\x81\xbf",	"\xef\xbe\x90",	"\xe3\x82\x80",	"\xef\xbe\x91",	"\xe3\x82\x81",	"\xef\xbe\x92",	"\xe3\x82\x82",	"\xef\xbe\x93",
		"\xe3\x82\x83",	"\xef\xbd\xac",	"\xe3\x82\x84",	"\xef\xbe\x94",	"\xe3\x82\x85",	"\xef\xbd\xad",	"\xe3\x82\x86",	"\xef\xbe\x95",	"\xe3\x82\x87",	"\xef\xbd\xae",	"\xe3\x82\x88",	"\xef\xbe\x96",
		"\xe3\x82\x89",	"\xef\xbe\x97",	"\xe3\x82\x8a",	"\xef\xbe\x98",	"\xe3\x82\x8b",	"\xef\xbe\x99",	"\xe3\x82\x8c",	"\xef\xbe\x9a",	"\xe3\x82\x8d",	"\xef\xbe\x9b",
		"\xe3\x82\x8e",	"\xef\xbe\x9c",	"\xe3\x82\x8f",	"\xef\xbe\x9c",	"\xe3\x82\x90",	"\xef\xbd\xb2",	"\xe3\x82\x91",	"\xef\xbd\xb4",	"\xe3\x82\x92",	"\xef\xbd\xa6",	"\xe3\x82\x93",	"\xef\xbe\x9d",

		# katakana
		"\xe3\x82\xa1",	"\xef\xbd\xa7",	"\xe3\x82\xa2",	"\xef\xbd\xb1",	"\xe3\x82\xa3",	"\xef\xbd\xa8",	"\xe3\x82\xa4",	"\xef\xbd\xb2",	"\xe3\x82\xa5",	"\xef\xbd\xa9",
		"\xe3\x82\xa6",	"\xef\xbd\xb3",	"\xe3\x82\xa7",	"\xef\xbd\xaa",	"\xe3\x82\xa8",	"\xef\xbd\xb4",	"\xe3\x82\xa9",	"\xef\xbd\xab",	"\xe3\x82\xaa",	"\xef\xbd\xb5",
		"\xe3\x82\xab",	"\xef\xbd\xb6",	"\xe3\x82\xac",	"\xef\xbd\xb6\xef\xbe\x9e",	"\xe3\x82\xad",	"\xef\xbd\xb7",	"\xe3\x82\xae",	"\xef\xbd\xb7\xef\xbe\x9e",	"\xe3\x82\xaf",	"\xef\xbd\xb8",
		"\xe3\x82\xb0",	"\xef\xbd\xb8\xef\xbe\x9e",	"\xe3\x82\xb1",	"\xef\xbd\xb9",	"\xe3\x82\xb2",	"\xef\xbd\xb9\xef\xbe\x9e",	"\xe3\x82\xb3",	"\xef\xbd\xba",	"\xe3\x82\xb4",	"\xef\xbd\xba\xef\xbe\x9e",
		"\xe3\x82\xb5",	"\xef\xbd\xbb",	"\xe3\x82\xb6",	"\xef\xbd\xbb\xef\xbe\x9e",	"\xe3\x82\xb7",	"\xef\xbd\xbc",	"\xe3\x82\xb8",	"\xef\xbd\xbc\xef\xbe\x9e",	"\xe3\x82\xb9",	"\xef\xbd\xbd",
		"\xe3\x82\xba",	"\xef\xbd\xbd\xef\xbe\x9e",	"\xe3\x82\xbb",	"\xef\xbd\xbe",	"\xe3\x82\xbc",	"\xef\xbd\xbe\xef\xbe\x9e",	"\xe3\x82\xbd",	"\xef\xbd\xbf",	"\xe3\x82\xbe",	"\xef\xbd\xbf\xef\xbe\x9e",
		"\xe3\x82\xbf",	"\xef\xbe\x80",	"\xe3\x83\x80",	"\xef\xbe\x80\xef\xbe\x9e",	"\xe3\x83\x81",	"\xef\xbe\x81",	"\xe3\x83\x82",	"\xef\xbe\x81\xef\xbe\x9e",	"\xe3\x83\x83",	"\xef\xbd\xaf",
		"\xe3\x83\x84",	"\xef\xbe\x82",	"\xe3\x83\x85",	"\xef\xbe\x82\xef\xbe\x9e",	"\xe3\x83\x86",	"\xef\xbe\x83",	"\xe3\x83\x87",	"\xef\xbe\x83\xef\xbe\x9e",	"\xe3\x83\x88",	"\xef\xbe\x84",	"\xe3\x83\x89",	"\xef\xbe\x84\xef\xbe\x9e",
		"\xe3\x83\x8a",	"\xef\xbe\x85",	"\xe3\x83\x8b",	"\xef\xbe\x86",	"\xe3\x83\x8c",	"\xef\xbe\x87",	"\xe3\x83\x8d",	"\xef\xbe\x88",	"\xe3\x83\x8e",	"\xef\xbe\x89",
		"\xe3\x83\x8f",	"\xef\xbe\x8a",	"\xe3\x83\x90",	"\xef\xbe\x8a\xef\xbe\x9e",	"\xe3\x83\x91",	"\xef\xbe\x8a\xef\xbe\x9f",	"\xe3\x83\x92",	"\xef\xbe\x8b",	"\xe3\x83\x93",	"\xef\xbe\x8b\xef\xbe\x9e",
		"\xe3\x83\x94",	"\xef\xbe\x8b\xef\xbe\x9f",	"\xe3\x83\x95",	"\xef\xbe\x8c",	"\xe3\x83\x96",	"\xef\xbe\x8c\xef\xbe\x9e",	"\xe3\x83\x97",	"\xef\xbe\x8c\xef\xbe\x9f",	"\xe3\x83\x98",	"\xef\xbe\x8d",
		"\xe3\x83\x99",	"\xef\xbe\x8d\xef\xbe\x9e",	"\xe3\x83\x9a",	"\xef\xbe\x8d\xef\xbe\x9f",	"\xe3\x83\x9b",	"\xef\xbe\x8e",	"\xe3\x83\x9c",	"\xef\xbe\x8e\xef\xbe\x9e",	"\xe3\x83\x9d",	"\xef\xbe\x8e\xef\xbe\x9f",
		"\xe3\x83\x9e",	"\xef\xbe\x8f",	"\xe3\x83\x9f",	"\xef\xbe\x90",	"\xe3\x83\xa0",	"\xef\xbe\x91",	"\xe3\x83\xa1",	"\xef\xbe\x92",	"\xe3\x83\xa2",	"\xef\xbe\x93",
		"\xe3\x83\xa3",	"\xef\xbd\xac",	"\xe3\x83\xa4",	"\xef\xbe\x94",	"\xe3\x83\xa5",	"\xef\xbd\xad",	"\xe3\x83\xa6",	"\xef\xbe\x95",	"\xe3\x83\xa7",	"\xef\xbd\xae",	"\xe3\x83\xa8",	"\xef\xbe\x96",
		"\xe3\x83\xa9",	"\xef\xbe\x97",	"\xe3\x83\xaa",	"\xef\xbe\x98",	"\xe3\x83\xab",	"\xef\xbe\x99",	"\xe3\x83\xac",	"\xef\xbe\x9a",	"\xe3\x83\xad",	"\xef\xbe\x9b",
		"\xe3\x83\xae",	"\xef\xbe\x9c",	"\xe3\x83\xaf",	"\xef\xbe\x9c",	"\xe3\x83\xb0",	"\xef\xbd\xb2",	"\xe3\x83\xb1",	"\xef\xbd\xb4",	"\xe3\x83\xb2",	"\xef\xbd\xa6",	"\xe3\x83\xb3",	"\xef\xbe\x9d",
		"\xe3\x83\xb4",	"\xef\xbd\xb3\xef\xbe\x9e",	"\xe3\x83\xb5",	"\xef\xbd\xb6",	"\xe3\x83\xb6",	"\xef\xbd\xb9\x22"
	);

}

sub Inline {
	my ( $own ) = __FILE__;
	return if $INC{$own};
	if ( $ENV{REQUEST_METHOD} ne '' ) { return; }

	$lcAG = lc($ARGV[0]);
	if ( $lcAG eq '-inline' || $lcAG eq '-i' ) {
		$inlinemode = 1;
		print "Welcome to \"SQL Engine!\"\n";
		print "\tAt ".localtime(time)."\n\n";
		if ( $ARGV[1] ne '' ) {
			if ( @ARGV == 2 ) {
				$dn = 'EMP';
				$df = $ARGV[1];
			} else {
				$dn = $ARGV[1];
				$df = $ARGV[2];
			}
			$r = DBOpen($dn, $df);
			if ( $r != 0 ) {
				print "Open failed $df\n";
				print GetError($r)."\n";
			} else {
				print "Table $dn was opened by $df\n";
			}
		}
		$bufline = 0;
		while (1) {
			while (1) {
				print "> ";
				$inlinesql = <STDIN>;
				xchomp($inlinesql);
				$inlinesql =~ s/^\s*//;
				if ( $inlinesql ne "" ) { last; }
			}

			if ( $inlinesql =~ /^(exit|quit|qui|bye)$/i ) {
				print "Bye!!\n";
				exit;
			}
			if ( $inlinesql =~ /^!\d+$/ ) {
				$inlinesql =~ s/!(\d+)/$1/;
				if ( $inlinesql > 9 || $inlinesql < 0 ) {
					print "Can use history number 0 - 9";
					next;
				} else {
					$inlinesql = $buffer[$inlinesql];
					print "$inlinesql\n";
				}
			} elsif ( $inlinesql =~ /^!!$/ ) {
				$inlinesql = $buffer[$bufline-1];
				print "$inlinesql\n";
			} elsif ( $inlinesql =~ /^!.*$/ ) {
				$inlinesql =~ s/^!(.*)$/$1/;
				for ( $i = @buffer-1; $i >= 0; $i-- ) {
					if ( lc($buffer[$i]) eq '$inlinesql' ) {
						$inlinesql = $buffer[$i];
						print "$inlinesql\n";
						last;
					}
				}
				if ( $i < 0 ) { next; }
			} elsif ( $inlinesql =~ /^(history|h)$/i )  {
				$i = 0;
				foreach ( @buffer ) {
					print "$i $buffer[$i]\n";
					$i++;
				}
				next;
			} elsif ( $inlinesql =~ /^load\sobs\s+["']?([^"']*)["']?$/i )  {
				$fname = $1;
				$fname =~ s/^['"]//;
				if ( ($r = RelateWordsFromFile($fname)) != 0 ) {
					print GetError($r)."\n\n";
				} else {
					print "read obscure dictionary $fname\n\n";
				}
				next;
			} elsif ( $inlinesql =~ /^separater\s*is\s+["']?([^"']*)["']?$/i )  {
				$sep = $w = $1;
				$w =~ s/(\\\\|\\n|\\t|\\"|\\')/$Conv_ESC2CON{$&}/ig;
				SeparaterIs($w);
				print "Separater is \"$sep\"\n\n";
				next;
			} elsif ( $inlinesql =~ /^unfold\s*array\s+["']?(on|1)["']?$/i )  {
				$ArrayUnfold = 1;
				print "Arrays are displayed unfold\n\n";
				next;
			} elsif ( $inlinesql =~ /^unfold\s*array\s+["']?(off|0)["']?$/i )  {
				$ArrayUnfold = 0;
				print "Arrays are displayed like (Array)\n\n";
				next;
			} elsif ( $inlinesql =~ /^\s*(dir|ls|type|cat)\s*/i )  {
				$w = `$inlinesql`;
				print $w;
				next;
			} elsif ( $inlinesql =~ /^\s*cd\s*(.*)$/i )  {
				if ( $1 eq '' ) {
					$w = `$inlinesql`;
					print $w;
				} else {
					chdir($1);
				}
				next;
			} else {
				$buffer[$bufline++] = $inlinesql;
			}
			if ( $bufline > 10 ) {
				for ( $i = 1; $i < $bufline; $i++ ) {
					$buffer[$i-1] = $buffer[$i];
				}
				splice( @buffer, 10, 1 );
				$bufline = 10;
			}
			$r = Execute($inlinesql);
			print GetError($r)."\n\n";
		}

	} elsif ( $lcAG ne '' ) {
		$inlinemode = 1;

		$inlinesql = $ARGV[0];
		if ( $inlinesql =~ /^"/ && $inlinesql =~ /"$/ ) {
			$inlinesql = substr( $inlinesql, 1, length($inlinesql) - 2 );
		} else {
			if ( (  $inlinesql =~ /^"/  && !($inlinesql =~ /"$/) ) ||
			     (!($inlinesql =~ /^"/) &&   $inlinesql =~ /"$/  ) ) {
				$mes = GetError(33);
				print "$mes\n";
			}
		}
		$r = Execute($inlinesql);
		$mes = GetError($r);
		print "$mes\n";

		exit $r;
	} else {
		$inlinemode = 0;
	}
}

sub rolling {
	my( $original ) = $_[0];
	my( $w );

	if ( $CharCode == 0 ) {
		$original =~ s/[\x81-\x9f\xe0-\xef]./$w=$ConvertTable_SJIS{$&};($w ne undef)?$w:$&/eg;
	} elsif ( $CharCode == 1 ) {
		$original =~ s/([\x00-\x7f]|\x8e.|\x8f..|[^\x00-\x7F\x8e\x8f].)/$w=$ConvertTable_EUC{$&};($w ne undef)?$w:$&/eg;
	} else {
		$original =~ s/([\x00-\x7f]|[\xc0-\xcf\xd0-\xdf].|[\xe0-\xef]..)/$w=$ConvertTable_UTF8{$&};($w ne undef)?$w:$&/eg;
	}

	return graphic_lc($original);
}

sub rolling2 {
	my( $original ) = $_[0];
	$original = rolling($original);
	$original =~ s/\s//g;
	return $original;
}

sub wrolling {
	my( $original ) = $_[0];
	$original = rolling($original);
	$original =~ s/[\x00-\x20]//g;

	$original =~ s/$RegRelate/$RelateWord{$&}/g;
	$original =~ s/$RegDisregard//g;

	return $original;
}

sub graphic_lc {
	my( $original ) = $_[0];

	if ( $CharCode == 0 ) {
		$original =~ s/([\x81-\x9f\xe0-\xef].|([A-Z]))/($2 ne '')?lc($&):$&/eg;
	} else {
		$original = lc($original);
	}

	return $original;
}

sub graphic_uc {
	my( $original ) = $_[0];

	if ( $CharCode == 0 ) {
		$original =~ s/([\x81-\x9f\xe0-\xef].|([a-z]))/($2 ne '')?uc($&):$&/eg;
	} else {
		$original = uc($original);
	}

	return $original;
}

sub year   { return ((localtime($_[0]))[5])+1900; }
sub month  { return ((localtime($_[0]))[4])+1; }
sub day    { return (localtime($_[0]))[3]; }
sub hour   { return (localtime($_[0]))[2]; }
sub minute { return (localtime($_[0]))[1]; }
sub second { return (localtime($_[0]))[0]; }
sub week   { return (localtime($_[0]))[6]; }
sub xchomp { foreach ( @_ ) { s/[\r\n]+$//g; } }

sub xindex {
	if ( $CharCode != 0 ) { return index($_[0], $_[1]); }
	if ( $_[1] =~ /^[\x81-\x9f\xe0-\xef]/ ) { return index($_[0], $_[1]); }
	my ( $bit, $i, $f, $len );

	if ( length($_[1]) == 0 ) { return -1; }
	$f = substr($_[1], 0, 1);
	$len = length($_[0]);
	for ( $i = 0; $i < $len; $i++ ) {
		$c = substr($_[0], $i, 1);
		if ( $c =~ /[\x81-\x9f\xe0-\xef]/ ) {
			$bit = 1;
		} else {
			if ( $c eq $f ) {
				if ( !$bit ) { return index($_[0], $_[1]); }
			}
			$bit = 0;
		}
	}
	return -1;
}

sub GetOuterFile {
	$URL  = $_[0];
	$TOUT = $_[1];
	$OFIL = $_[2];

	use Socket;

	AdjustQuery();

	# deside file name
	$Unic_Name = "$hostname$path";
	if ( $query ne '' ) {
		$OFIL =~ /[\/\\](.+)$/;
		$Unic_Name = substr($Unic_Name, 0, rindex($Unic_Name, "/"));
		$Unic_Name .= $OFIL;
	}
	$Unic_Name =~ s/[\/\\\.\~]/_/g;
	$Unic_Name =~ s/_+/_/g;
	$Unic_Name = "./se_sqlsys/$Unic_Name.cgi";

	$FTime = 0;
	if ( -e $Unic_Name ) { $FTime = (stat($Unic_Name))[9]; }

	ConnectSocket();
	$HEAD{status} =~ /\d\d\d/;
	if ( $& ne '' && ($& < 200 || $& > 299) ) {
		close(SOCK);
		return 49;
	}

	$body = 0;
	$URL_BODY = '';
	while ( <SOCK> ) {
		$or = $_;
		s/[\r\n]//g;
		if ( $_ eq '' && $body == 0 ) { 
			# finished geting header
			$body = 1;
			if ( $OFIL ne '' ) {
				if ( $HEAD{'CGI-Listener'} eq 'Password Error' ) {
					close(SOCK);
					return (52, $Unic_Name);
				} elsif ( $HEAD{'CGI-Listener'} eq 'NotFound' ) {
					close(SOCK);
					return (56, $Unic_Name);
				} elsif ( $HEAD{'CGI-Listener'} ne 'OK' ) {
					close(SOCK);
					return (51, $Unic_Name);
				}
				if ( int($HEAD{'File-Date'}/2) != $HEAD{'File-Date'} ) { $HEAD{'File-Date'}++; }
				if ( $FTime != 0 && $HEAD{'File-Date'} eq $FTime ) {
					close(SOCK);
					return (0,$Unic_Name);
				}
				if ( $HEAD{Compress} eq 'ZIP' ) {
					binmode(SOCK);
					$/ = '';
				}
			}
			next;
		}
		if ( $body == 0 ) {
			# get header
			if ( s/^[\s\t]+// ) {
				$HEAD{$name} .= $_;
			} else {
				/^([^:]+):\s*(.*)$/;
				$name = $1;
				$value = $2;
				$HEAD{$name} = $value;
			}
		} else {
			$URL_BODY .= $or;
		}
	}
	close(SOCK);

	if ( ($pos = index($URL_BODY, "<SQL_Engine_Data>")) != -1 ) {
		$URL_BODY = substr($URL_BODY, $pos + 17);
	}
	if ( ($pos = rindex($URL_BODY, "</SQL_Engine_Data>")) != -1 ) {
		$URL_BODY = substr($URL_BODY, 0, $pos);
	}

	if ( $HEAD{Compress} eq 'ZIP' ) {
		$URL_BODY = uncompress($URL_BODY);
		$/ = "\n";
	}

	if ( !(-e './se_sqlsys') ) { mkdir('./se_sqlsys', 666); }

	# file create
	open(OUT, ">$Unic_Name") || return (7, '');
	print OUT $URL_BODY;
	close(OUT);
	if ( $HEAD{'File-Date'} ne '' ) {
		utime($HEAD{'File-Date'},$HEAD{'File-Date'},$Unic_Name);
	}

	return (0,$Unic_Name);

}

sub UpdateOuterFile {
	$URL  = $_[0];
	$TOUT = $_[1];

	use Socket;

	ConnectSocket();
	$HEAD{status} =~ /\d\d\d/;
	if ( $& ne '' && ($& < 200 || $& > 299) ) {
		close(SOCK);
		return 49;
	}

	$body = 0;
	while ( <SOCK> ) {
		s/[\r\n]//g;
		if ( $_ eq '' && $body == 0 ) { 
			# finished geting header
			$body = 1;
			if ( $HEAD{'CGI-Listener'} eq 'Password Error' ) {
				close(SOCK);
				return 52;
			} elsif ( $HEAD{'CGI-Listener'} ne 'OK' ) {
				close(SOCK);
				return 51;
			}
			next;
		}
		if ( $body == 0 ) {
			# Get header
			if ( s/^[\s\t]+// ) {
				$HEAD{$name} .= $_;
			} else {
				/^([^:]+):\s*(.*)$/;
				$name = $1;
				$value = $2;
				$HEAD{$name} = $value;
			}
		} else {
			$SQL_STATUS .= $_;
		}
	}
	close(SOCK);

	if ( ($pos = index($SQL_STATUS, "<SQL_Engine_Data>")) != -1 ) {
		$SQL_STATUS = substr($SQL_STATUS, $pos + 17);
	}
	if ( ($pos = rindex($SQL_STATUS, "</SQL_Engine_Data>")) != -1 ) {
		$SQL_STATUS = substr($SQL_STATUS, 0, $pos);
	}

	return $SQL_STATUS;

}

sub EncodeURL {
	my( $result ) = $_[0];
	$result =~ s/(\W)/'%'.unpack("H2", $1)/ego;
	return $result;
}

sub AdjustQuery {

	if ( $URL =~ /^(\w+):\/\/(([^:\/]+)(?::(\d*))?)(?:(\/[^\?\#]*)(?:\?([^\#]*))?(?:\#(.*))?)?$/sx ) {
#		$protcol	= $1;
		$host		= $2;
#		$uri_host	= "$1://$2";
		$hostname	= $3;
		$port		= $4 || 80;
		$path		= $5 || "/";
#		$URI		= "$1://$2$path";
		$query		= $6;
	}
}

sub ConnectSocket {
	# connect
	if ( $proxy eq '' ) {
		$address     = inet_aton($hostname) || return 50;
		$sockaddress = sockaddr_in($port, $address);
	} else {
		$address     = inet_aton($proxy) || return 50;
		$sockaddress = sockaddr_in($pport, $address);
	}

	# socket
	if ( !socket( SOCK, PF_INET, SOCK_STREAM, getprotobyname('tcp')) ) { return 49; }
	eval("alarm($TOUT);");
	if ( !connect( SOCK, $sockaddress ) ) { return 49; }
	eval("alarm(0);");
	binmode(SOCK);
	select(SOCK);
	$| = 1;
	select(STDOUT);

	$URL =~ s/ /%20/g;

	# request
	print SOCK "GET $path?$query HTTP/1.0\r\n";
	print SOCK "Host: $host\r\n";
	print SOCK "User-Agent: SQL Engine\r\n";
	print SOCK "Connection: close\r\n";
	print SOCK "\r\n";

	# status
	$HEAD{status} = <SOCK>;
}

sub SetProxy {
	$proxy = $_[0];
	$pport = $_[1] if $_[1];
}

sub CheckCompressExist {
	return eval 'use Compress::Zlib; 1' || 0;
}

sub Sort {
	my( $onum, $start, $max );
	local( @n );

	$onum  = $_[0];
	$start = $_[1];
	$max   = $_[2];

	*n = $ExecuteResult[$CURSOR];
	if ( $ORDERS[$onum]->[2] == 2 ) {
		if ( $ORDERS[$onum]->[1] == 0 ) {
			SortBody($ORDERS[$onum]->[0], $start, $max, \@n, \&Comp_le);
		} else {
			SortBody($ORDERS[$onum]->[0], $start, $max, \@n, \&Comp_ge);
		}
	} else {
		if ( $ORDERS[$onum]->[1] == 0 ) {
			SortBody($ORDERS[$onum]->[0], $start, $max, \@n, \&Comp_le_n);
		} else {
			SortBody($ORDERS[$onum]->[0], $start, $max, \@n, \&Comp_ge_n);
		}
	}

}

sub Sort2 {
	my( @target, $onum, $start, $max, $i );
	local( @n );

	$i = $_[0];
	$onum = $_[1];
	$start = $_[2];
	$max = $_[3];

	*n = $JOINTMP[$i];
	if ( $SetInfo[$onum]->[2] == 2 ) {
		SortBody($SetInfo[$onum]->[0], $start, $max, \@n, \&Comp_le);
	} else {
		SortBody($SetInfo[$onum]->[0], $start, $max, \@n, \&Comp_le_n);
	}

}

sub Sort3 {
	my( @target, $onum, $start, $max, $i );
	local( @n );

	$onum = $_[0];
	$start = $_[1];
	$max = $_[2];

	*n = $ExecuteResult[$CURSOR];
	if ( $GROUP[$onum]->[2] == 2 ) {
		SortBody($GROUP[$onum]->[0], $start, $max, \@n, \&Comp_le);
	} else {
		SortBody($GROUP[$onum]->[0], $start, $max, \@n, \&Comp_le_n);
	}

}

sub Sort4 {
	my( $onum, $start, $max );
	local( @n );

	$onum  = $_[0];
	$start = $_[1];
	$max   = $_[2];

	*n = $ExecuteResult[$CURSOR];
	if ( $ExecuteResult[$CURSOR]->[1]->[$onum] =~ /\D/ ) {
		SortBody($onum, $start, $max, \@n, \&Comp_le);
	} else {
		SortBody($onum, $start, $max, \@n, \&Comp_le_n);
	}

}


sub SortBody {
	my ( $i,$j,$k,$start );
	local ( $s1,$s2,$e1,$e2,$cm,$v1,@tmp );

	$inum = $_[0];
	$start = $_[1];
	$m_dcnt = $_[2];
	*m_data = $_[3];
	$compl = $_[4];
	$v1 = $m_dcnt-1;

loop_1:
	$s1=$start;
loop_2:
	$e1=GetLastNo($s1);
	$s2=$e1+1;

	if ($s2>=$m_dcnt) {
		if ($s1==$start) {
			goto loop_e;
		} else {
			goto loop_1;
		}
	}
	$e2=GetLastNo($s2);

	$i=$s1;
	$j=$s2;
	$k=0;
loop_3:
	if ($i<=$e1 && $j<=$e2)	{
		if (&$compl($m_data[$i]->[$inum], $m_data[$j]->[$inum])) {
			CopyArray( \@tmp, $k++, \@m_data, $i++ );
		} else {
			CopyArray( \@tmp, $k++, \@m_data, $j++ );
		}
	} else {
		if ($i<=$e1) {
			CopyArray( \@tmp, $k++, \@m_data, $i++ );
		} else {
			CopyArray( \@tmp, $k++, \@m_data, $j++ );
		}
	}
	if ($i<=$e1 || $j<=$e2) { goto loop_3; }

	$cm = $e2-$s1+1;
	for ($k=0; $k<$cm; $k++) {
		CopyArray( \@m_data, $s1+$k, \@tmp, $k );
	}

	$s1 = $e2 + 1;
	if ($s1<$m_dcnt) {
		goto loop_2;
	} else {
		goto loop_1;
	}

loop_e:

}

sub GetLastNo {
	$st = $_[0];

	while($st<$v1 && &$compl($m_data[$st]->[$inum], $m_data[$st+1]->[$inum])) { $st++; }

	return $st;
}

sub Comp_le { return $_[0] le $_[1]; }
sub Comp_ge { return $_[0] ge $_[1]; }
sub Comp_le_n { return $_[0] <= $_[1]; }
sub Comp_ge_n { return $_[0] >= $_[1]; }
sub CopyArray { @{$_[0]}[$_[1]] = @{$_[2]}[$_[3]]; }

sub timelocal {
	my ( $time );
	if ( $_[0] =~ /(\d+)[\/\-](\d+)[\/\-](\d+)([\s\w](\d+):(\d+)([:'"](\d+))?)?/ ) {
		my ( $y ) = $1;
		my ( $m ) = $2;
		my ( $d ) = $3;
		my ( $h ) = $5;
		my ( $mm ) = $6;
		my ( $s ) = $8;

		if ( $m < 3 ) { $y--; $m += 12; }
		$time = int(365*$y+$y/4-$y/100+$y/400+306*($m+1)/10-428+$d)-719164;
		$time = $time * 86400 + ($h*3600+$mm*60+$s) + 54000;
		if ( $time == 0 ) { return $_[0]; }
		return $time;
	} else {
		return $_[0];
	}
}

sub Array2Str {
	my ( $result ) = '';
	foreach ( @_ ) {
		s/(\W)/sprintf("%%%02X", unpack("C", $1))/eg;
		$result .= ';' if ( $result ne '' );
		$result .= $_;
	}
	return $result;
}

sub Str2Array {
	my $tmp = $_[0];
	my ( @result ) = ();
	if ( $tmp eq '' ) { return (); }
	if ( index($tmp, ';') != -1 ) {
		foreach ( split(/;/, $tmp) ) {
			s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("C", hex($1))/eg;
			push ( @result, $_ );
		}
		return @result;
	} else {
		$tmp =~ s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("C", hex($1))/eg;
		return ($tmp);
	}
}

sub AddArray {
	my ( $dest, $src ) = @_;
	my ( @result );

	if ( $dest =~ s/^__SE_SYSTEM_ARRAY:// ) {
		@result = Str2Array($dest);
	} else {
		@result = ($dest);
	}

	if ( $src =~ s/^__SE_SYSTEM_ARRAY:// ) {
		push( @result, Str2Array($src) );
	} else {
		push( @result, $src );
	}

	return "__SE_SYSTEM_ARRAY:" . Array2Str(@result);

}

sub AddArrayDistinct {
	my ( $dest, $src ) = @_;
	my ( @tmp, @result, $c, $rec, $l );

	if ( $dest =~ s/^__SE_SYSTEM_ARRAY:// ) {
		@tmp = Str2Array($dest);
	} else {
		@tmp = ($dest);
	}

	if ( $src =~ s/^__SE_SYSTEM_ARRAY:// ) {
		push( @tmp, Str2Array($src) );
	} else {
		push( @tmp, $src );
	}

	@tmp = sort {$a cmp $b} @tmp;
	for ( $l = $rec = 0; $rec < @tmp; $rec++ ) {
		if ( $tmp[$rec] ne $tmp[$rec+1] ) {
			$result[$l] = $tmp[$rec];
			$l++;
		}
	}

	return "__SE_SYSTEM_ARRAY:" . Array2Str(@result);

}

sub GetError {

	$ernum = $_[0]-0;

	@ErrMessage = (
		'Success',						# 0
		'Table or view not opened',				# 1
		'Not supported SQL',					# 2
		'Invalid operator',					# 3
		'FROM not found',					# 4
		'Output columns not found at SELECT sentence',		# 5
		'ORDER doesn\'t finished',				# 6
		'File read error or locked',				# 7
		'WHERE doesn\'t finished',				# 8
		'syntax error in WHERE',				# 9
		'This expression in WHERE is not supported',		# 10
		'Cannot assign NUMBER and CHARCTER at once',		# 11
		'Columns output-columns doesn\'t have cannot sort',	# 12
		'No more data should be fetched',			# 13
		'Undefined columns in output columns',			# 14
		'CSV file has any null column name',			# 15
		'Not closed right parenthiese',				# 16
		'Not group name or group function',			# 17
		'INTO not found',					# 18
		'SET not found',					# 19
		'VALUES not found',					# 20
		'Undefined column name',				# 21
		'That table name are already used',			# 22
		'Syntax error on SET',					# 23
		'SET has any undefined columns',			# 24
		'Need to assign inputable value on Left value',		# 25
		'Already locked',					# 26
		'Functions nested or not found riht parenthiese',	# 27
		'Invalid target',					# 28
		'FILE not found',					# 29
		'FILE overlaped',					# 30
		'Column names overlaped',				# 31
		'File already exists',					# 32
		'Cannot use inline mode',				# 33
		'FOR doesn\'t finished',				# 34
		'Invalid error number',					# 35
		'Sub-query returns no values',				# 36
		'CURSOR doesn\'t finished',				# 37
		'Columns undefined',					# 38
		'Function not supported',				# 39
		'TO not found',						# 40
		'Column name already used',				# 41
		'Keyword * cannot has alias',				# 42
		'Undefined cursor name',				# 43
		'SET doesn\'t finished',				# 44
		'Number of columns and values are not matched',		# 45
		'Number of columns and used columns are not matched',	# 46
		'Cannot make system directory',				# 47
		'PASSWORD not found',					# 48
		'Connection failed to outer server',			# 49
		'Outer server not found',				# 50
		'Listener not responsed',				# 51
		'Invalid password',					# 52
		'Write permission not found',				# 53
		'Cannot execute for outer server',			# 54
		'Listener catched invalid command',			# 55
		'File not found on outer server',			# 56
		'GROUP has syntax error or doesn\'t finished',		# 57
		'Invalid column on OPEN',				# 58
		'Columns output-columns doesn\'t have cannot grouping',	# 59
		'Target tables are too few',				# 60
		'Target tables are too much',				# 61
		'Not match number of columns on JOIN',			# 62
		'Join condition not found',				# 63
		'NUMBER and CHARCTER are not assign that position',	# 64
		'Cannot commit view',					# 65
		'Cannot rollback view',					# 66
		'Cannot lock view',					# 67
		'',							# 68
		'Undefine SQL',						# 69
		'Have any undefined "?"',				# 70
		'No more "?" should be define',				# 71
		'no SQL',						# 72
		'Assgin a table for join target',			# 73
		'Not found join target',				# 74
		'Invalid view assgin',					# 75
		'WHERE has undefined columns',				# 76
		'Invalid sentence',					# 77
		'Cannot use FOR INSERT for XML',			# 78
		'Not RSS format file',					# 79
		'Cannot use carefully mode for RSS file',		# 80
		'Not found channel on RSS file',			# 81
		'Cannot create system table for session mode',		# 82
		'Session mode was not started',				# 83
		'Invalid session valiable name',			# 84
		'Not supported in this version',			# 85
		'Syntax error on JOIN',					# 86
		'Not found access name and alias or overlaped',		# 87
	);

	if ( $ernum < 0 ) { $ernum = 35; }

	$num = substr( "00".$ernum, -3, 3 );
	$mes = "[SQL-Engine]SEERR-$num $ErrMessage[$ernum]";

	return $mes;

}

sub sigpipe {
	error("Shut down by connected server");
	exit;
}
sub sigalrm {
	error("Connection timeout");
	exit;
}

sub error {

	print <<EOM;
Content-type: text/html

<html>
<head><title>Error</title></head>
<body>
$_[0]
</body>
</html>
EOM

	exit;

}

END { terminate() }
sub terminate { unlink("SE.FULLLOCK") if ( $FullLock == 1 ); }

1;

